<?php
/**
 * Joomla! component Creative Contact Form
 *
 * @version $Id: 2012-04-05 14:30:25 svn $
 * @author creative-solutions.net
 * @package Creative Contact Form
 * @subpackage com_creativecontactform
 * @license GNU/GPL
 *
 */

// no direct access
defined('_JEXEC') or die('Restircted access');

// import Joomla modelform library
jimport('joomla.application.component.modeladmin');

class CreativeContactFormModelCreativeForm extends JModelAdmin
{
	//get max id
	public function getMax_id()
	{
		// Create a new query object.
		$db		= $this->getDbo();
		$query = 'SELECT COUNT(id) AS count_id FROM #__creative_forms';
		$db->setQuery($query);
		$max_id = $db->loadResult();
		return $max_id;
	}
	/**
	 * Returns a reference to the a Table object, always creating it.
	 *
	 * @param	type	The table type to instantiate
	 * @param	string	A prefix for the table class name. Optional.
	 * @param	array	Configuration array for model. Optional.
	 * @return	JTable	A database object
	 * @since	1.6
	 */
	public function getTable($type = 'CreativeForm', $prefix = 'CreativeFormTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	/**
	 * Method to get the record form.
	 *
	 * @param	array	$data		Data for the form.
	 * @param	boolean	$loadData	True if the form is to load its own data (default case), false if not.
	 * @return	mixed	A JForm object on success, false on failure
	 * @since	1.6
	 */
	public function getForm($data = array(), $loadData = true) 
	{
		// Get the form.
		$form = $this->loadForm('com_creativecontactform.creativeform', 'creativeform', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)) 
		{
			return false;
		}
		return $form;
	}
	/**
	 * Method to get the data that should be injected in the form.
	 *
	 * @return	mixed	The data for the form.
	 * @since	1.6
	 */
	protected function loadFormData() 
	{
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_creativecontactform.edit.creativeform.data', array());
		if (empty($data)) 
		{
			$data = $this->getItem();
		}
			$data = $this->getItem();
		return $data;
	}
	
	protected function canEditState($record)
	{
		return parent::canEditState($record);
	}
	
	
	/**
	 * Method to toggle the featured setting of contacts.
	 *
	 * @param	array	$pks	The ids of the items to toggle.
	 * @param	int		$value	The value to toggle to.
	 *
	 * @return	boolean	True on success.
	 * @since	1.6
	 */
	public function featured($pks, $value = 0)
	{
		// Sanitize the ids.
		$pks = (array) $pks;
		JArrayHelper::toInteger($pks);
	
		if (empty($pks)) {
			$this->setError(JText::_('COM_CREATIVECONTACTFORM_NO_ITEM_SELECTED'));
			return false;
		}
	
		$table = $this->getTable();
	
		try
		{
			$db = $this->getDbo();
	
			$db->setQuery(
					'UPDATE #__creative_forms' .
					' SET featured = '.(int) $value.
					' WHERE id IN ('.implode(',', $pks).')'
			);
			if (!$db->execute()) {
				throw new Exception($db->getErrorMsg());
			}
	
		}
		catch (Exception $e)
		{
			$this->setError($e->getMessage());
			return false;
		}
	
		$table->reorder();
	
		// Clean component's cache
		$this->cleanCache();
	
		return true;
	}

	public function saveorder($pks = Array(), $order = Array())
	{
		$query = 'UPDATE #__creative_forms' .
					' SET ordering = ' .
					' (CASE ';
		foreach($pks as $index => $id) {
			$ord = (int) $order[$index];
			$id = (int) $id;

			$query .= " WHEN id = '".$id."' THEN '".$ord."' ";
		}

		$pks_line = implode(',', $pks);
		$query .= 
					' END)' . 
					' WHERE id IN ('.$pks_line.')';

		$db = $this->getDbo();

		$db->setQuery($query);

		if ($db->execute()) {
			return true;
		}

		return false;
	}

	/**
	 * Method to save field
	 */
	function saveForm()
	{
		$date = new JDate();
		$id = JFactory::getApplication()->input->getInt('id',0);
		
		$req = new JObject();

		$req->email_to = strip_tags($_REQUEST['jform']['email_to']);
		$req->email_bcc = strip_tags($_REQUEST['jform']['email_bcc']);
		$req->email_subject = strip_tags($_REQUEST['jform']['email_subject']);
		$req->email_from = strip_tags($_REQUEST['jform']['email_from']);
		$req->email_from_name = strip_tags($_REQUEST['jform']['email_from_name']);
		$req->email_replyto = strip_tags($_REQUEST['jform']['email_replyto']);
		$req->email_replyto_name = strip_tags($_REQUEST['jform']['email_replyto_name']);
		$req->shake_count = (int)$_REQUEST['jform']['shake_count'];
		$req->shake_distanse = (int)$_REQUEST['jform']['shake_distanse'];
		$req->shake_duration = (int)$_REQUEST['jform']['shake_duration'];
		$req->id_template = (int)$_REQUEST['jform']['id_template'];
		$req->name = strip_tags($_REQUEST['jform']['name']);
		$req->top_text = strip_tags($_REQUEST['jform']['top_text']);
		$req->pre_text = $_REQUEST['jform']['pre_text'];
		$req->thank_you_text = strip_tags($_REQUEST['jform']['thank_you_text']);
		$req->send_text = strip_tags($_REQUEST['jform']['send_text']);
		$req->send_new_text = strip_tags($_REQUEST['jform']['send_new_text']);
		$req->close_alert_text = strip_tags($_REQUEST['jform']['close_alert_text']);
		$req->form_width = strip_tags($_REQUEST['jform']['form_width']);
		$req->name = strip_tags($_REQUEST['jform']['name']);
		$req->name = strip_tags($_REQUEST['jform']['name']);
		$req->name = strip_tags($_REQUEST['jform']['name']);
		$req->name = strip_tags($_REQUEST['jform']['name']);
		$req->name = strip_tags($_REQUEST['jform']['name']);
		$req->name = strip_tags($_REQUEST['jform']['name']);
		$req->alias = '';
		$req->created = '0000-00-00 00:00:00';
		$req->publish_up = '0000-00-00 00:00:00';
		$req->publish_down = '0000-00-00 00:00:00';
		$req->published = (int)$_REQUEST['jform']['published'];
		$req->checked_out = 0;
		$req->checked_out_time = '0000-00-00 00:00:00';
		$req->access = 1;
		$req->featured = 0;
		$req->language = '';
		$req->redirect = strip_tags($_REQUEST['jform']['redirect']);
		$req->redirect_itemid = (int)$_REQUEST['jform']['redirect_itemid'];
		$req->redirect_url = $_REQUEST['jform']['redirect_url'];
		$req->redirect_delay = (int)$_REQUEST['jform']['redirect_delay'];
		$req->send_copy_enable = (int)$_REQUEST['jform']['send_copy_enable'];
		$req->send_copy_text = strip_tags($_REQUEST['jform']['send_copy_text']);
		$req->show_back = (int)$_REQUEST['jform']['show_back'];

		$req->email_info_show_referrer = (int)$_REQUEST['jform']['email_info_show_referrer'];
		$req->email_info_show_ip = (int)$_REQUEST['jform']['email_info_show_ip'];
		$req->email_info_show_browser = (int)$_REQUEST['jform']['email_info_show_browser'];
		$req->email_info_show_os = (int)$_REQUEST['jform']['email_info_show_os'];
		$req->email_info_show_sc_res = (int)$_REQUEST['jform']['email_info_show_sc_res'];
		$req->custom_css = strip_tags($_REQUEST['jform']['custom_css']);

		// 4.0.0 updates
		$req->render_type = (int)$_REQUEST['jform']['render_type'];
		$req->popup_button_text = strip_tags($_REQUEST['jform']['popup_button_text']);
		$req->static_button_position = (int)$_REQUEST['jform']['static_button_position'];
		$req->static_button_offset = strip_tags($_REQUEST['jform']['static_button_offset']);
		$req->appear_animation_type = (int)$_REQUEST['jform']['appear_animation_type'];
		$req->check_token = (int)$_REQUEST['jform']['check_token'];
		$req->next_button_text = strip_tags($_REQUEST['jform']['next_button_text']);
		$req->prev_button_text = strip_tags($_REQUEST['jform']['prev_button_text']);

		//4.6.1
		$req->email_template = $_REQUEST['jform']['email_template'];
        $req->auto_reply = $_REQUEST['jform']['auto_reply'];

		$response = array(0=>"no","1"=>0);

		if($id == 0) {//if id ==0, we add the record
			$req->id = NULL;

			//get max ordering
			$query = "SELECT MAX(`ordering`) FROM `#__creative_forms`";
			$this->_db->setQuery($query);
			$max_order = $this->_db->loadResult();
			$max_order ++;

			$req->ordering = $max_order;
	
			if (!$this->_db->insertObject( '#__creative_forms', $req, 'id' )) {
				$cis_error = "COM_CREATIVECONTACTFORM_ERROR_FORM_SAVED";
				
				$response[0] = $cis_error;
				return $response;
			}
			$new_insert_id = $this->_db->insertid();
			$response[1] = $new_insert_id;
		}
		else { //else update the record
			$req->id = $id;
			if (!$this->_db->updateObject( '#__creative_forms', $req, 'id' )) {
				$cis_error = "COM_CREATIVECONTACTFORM_ERROR_FORM_SAVED";
				$response[0] = $cis_error;
				return $response;
			}
		}
	
		return $response;
	}

	/**
	 * Method to copy form
	 */
	function copyForm()
	{
		$id = JFactory::getApplication()->input->getInt('id',0);
		
		$req = new JObject();

		$req->email_to = strip_tags($_REQUEST['jform']['email_to']);
		$req->email_bcc = strip_tags($_REQUEST['jform']['email_bcc']);
		$req->email_subject = strip_tags($_REQUEST['jform']['email_subject']);
		$req->email_from = strip_tags($_REQUEST['jform']['email_from']);
		$req->email_from_name = strip_tags($_REQUEST['jform']['email_from_name']);
		$req->email_replyto = strip_tags($_REQUEST['jform']['email_replyto']);
		$req->email_replyto_name = strip_tags($_REQUEST['jform']['email_replyto_name']);
		$req->shake_count = (int)$_REQUEST['jform']['shake_count'];
		$req->shake_distanse = (int)$_REQUEST['jform']['shake_distanse'];
		$req->shake_duration = (int)$_REQUEST['jform']['shake_duration'];
		$req->id_template = (int)$_REQUEST['jform']['id_template'];
		$req->name = strip_tags($_REQUEST['jform']['name']) . ' (copy)';
		$req->top_text = strip_tags($_REQUEST['jform']['top_text']);
		$req->pre_text = $_REQUEST['jform']['pre_text'];
		$req->thank_you_text = strip_tags($_REQUEST['jform']['thank_you_text']);
		$req->send_text = strip_tags($_REQUEST['jform']['send_text']);
		$req->send_new_text = strip_tags($_REQUEST['jform']['send_new_text']);
		$req->close_alert_text = strip_tags($_REQUEST['jform']['close_alert_text']);
		$req->form_width = strip_tags($_REQUEST['jform']['form_width']);

		$req->alias = '';
		$req->created = '0000-00-00 00:00:00';
		$req->publish_up = '0000-00-00 00:00:00';
		$req->publish_down = '0000-00-00 00:00:00';
		$req->published = (int)$_REQUEST['jform']['published'];
		$req->checked_out = 0;
		$req->checked_out_time = '0000-00-00 00:00:00';
		$req->access = 1;
		$req->featured = 0;
		$req->language = '';
		$req->redirect = strip_tags($_REQUEST['jform']['redirect']);
		$req->redirect_itemid = (int)$_REQUEST['jform']['redirect_itemid'];
		$req->redirect_url = $_REQUEST['jform']['redirect_url'];
		$req->redirect_delay = (int)$_REQUEST['jform']['redirect_delay'];
		$req->send_copy_enable = (int)$_REQUEST['jform']['send_copy_enable'];
		$req->send_copy_text = strip_tags($_REQUEST['jform']['send_copy_text']);

		$req->email_info_show_referrer = (int)$_REQUEST['jform']['email_info_show_referrer'];
		$req->email_info_show_ip = (int)$_REQUEST['jform']['email_info_show_ip'];
		$req->email_info_show_browser = (int)$_REQUEST['jform']['email_info_show_browser'];
		$req->email_info_show_os = (int)$_REQUEST['jform']['email_info_show_os'];
		$req->email_info_show_sc_res = (int)$_REQUEST['jform']['email_info_show_sc_res'];
		$req->custom_css = strip_tags($_REQUEST['jform']['custom_css']);

		// 4.0.0 updates
		$req->render_type = (int)$_REQUEST['jform']['render_type'];
		$req->popup_button_text = strip_tags($_REQUEST['jform']['popup_button_text']);
		$req->static_button_position = (int)$_REQUEST['jform']['static_button_position'];
		$req->static_button_offset = strip_tags($_REQUEST['jform']['static_button_offset']);
		$req->appear_animation_type = (int)$_REQUEST['jform']['appear_animation_type'];
		$req->check_token = (int)$_REQUEST['jform']['check_token'];
		$req->next_button_text = strip_tags($_REQUEST['jform']['next_button_text']);
		$req->prev_button_text = strip_tags($_REQUEST['jform']['prev_button_text']);

		//4.6.1
		$req->email_template = $_REQUEST['jform']['email_template'];
        $req->auto_reply = $_REQUEST['jform']['auto_reply'];

		$response = array(0=>"no","1"=>0);

		//if id ==0, we add the record
		$req->id = NULL;

		//get max ordering
		$query = "SELECT MAX(`ordering`) FROM `#__creative_forms`";
		$this->_db->setQuery($query);
		$max_order = $this->_db->loadResult();
		$max_order ++;

		$req->ordering = $max_order;

		if (!$this->_db->insertObject( '#__creative_forms', $req, 'id' )) {
			$cis_error = "COM_CREATIVECONTACTFORM_ERROR_FORM_COPIED";
			
			$response[0] = $cis_error;
			return $response;
		}
		$new_insert_id = $this->_db->insertid();
		$response[1] = $new_insert_id;

		//copy fields
		$query = "SELECT * FROM `#__creative_fields` WHERE `id_form` = '".$id."'";
		$this->_db->setQuery($query);
		$fields = $this->_db->loadAssocList();

		if(is_array($fields)) {
			foreach($fields as $field) {

				$req = new JObject();

				$req->id_form = $new_insert_id;
				$req->id_user = $field["id_user"];
				$req->name = $field["name"];
				$req->tooltip_text = $field["tooltip_text"];
				$req->id_type = $field["id_type"];
				$req->created = $field["created"];
				$req->publish_up = $field["publish_up"];
				$req->publish_down = $field["publish_down"];
				$req->published = $field["published"];
				$req->checked_out = $field["checked_out"];
				$req->checked_out_time = $field["checked_out_time"];
				$req->access = $field["access"];
				$req->featured = $field["featured"];
				$req->ordering = $field["ordering"];
				
				$req->alias = '';
				$req->language = '';
				$req->m_recipients_value = '';
				$req->m_recipients_multiple = 0;
				$req->pagebreak_type = 0;
				$req->pagebreak_page_title = '';
				$req->if_id = 0;
				$req->if_val = '';
				$req->then_id = 0;
				$req->hidden_val = '';

				$req->required = $field["required"];
				$req->width = $field["width"];
				$req->field_margin_top = $field["field_margin_top"];
				$req->select_show_scroll_after = $field["select_show_scroll_after"];
				$req->select_show_search_after = $field["select_show_search_after"];
				$req->message_required = $field["message_required"];
				$req->message_invalid = $field["message_invalid"];
				$req->show_parent_label = $field["show_parent_label"];
				$req->message_invalid = $field["message_invalid"];

				$req->select_default_text = $field["select_default_text"];
				$req->select_no_match_text = $field["select_no_match_text"];
				$req->upload_button_text = $field["upload_button_text"];
				$req->upload_minfilesize = $field["upload_minfilesize"];
				$req->upload_maxfilesize = $field["upload_maxfilesize"];
				$req->upload_acceptfiletypes = $field["upload_acceptfiletypes"];
				$req->upload_minfilesize_message = $field["upload_minfilesize_message"];
				$req->upload_maxfilesize_message = $field["upload_maxfilesize_message"];
				$req->upload_acceptfiletypes_message = $field["upload_acceptfiletypes_message"];
				$req->captcha_wrong_message = $field["captcha_wrong_message"];
				$req->datepicker_date_format = $field["datepicker_date_format"];
				$req->datepicker_animation = $field["datepicker_animation"];

				$req->datepicker_style = $field["datepicker_style"];
				$req->datepicker_icon_style = $field["datepicker_icon_style"];
				$req->datepicker_show_icon = $field["datepicker_show_icon"];
				$req->datepicker_input_readonly = $field["datepicker_input_readonly"];
				$req->datepicker_number_months = $field["datepicker_number_months"];

				$req->datepicker_mindate = $field["datepicker_mindate"];
				$req->datepicker_maxdate = $field["datepicker_maxdate"];

				$req->datepicker_changemonths = $field["datepicker_changemonths"];
				$req->datepicker_changeyears = $field["datepicker_changeyears"];
				$req->column_type = $field["column_type"];
				
				$req->custom_html = $field["custom_html"];
				$req->google_maps = $field["google_maps"];
				$req->heading = $field["heading"];

				$req->recaptcha_site_key = $field["recaptcha_site_key"];
				$req->recaptcha_security_key = $field["recaptcha_security_key"];
				$req->recaptcha_wrong_message = $field["recaptcha_wrong_message"];
				$req->recaptcha_theme = $field["recaptcha_theme"];
				$req->recaptcha_type = $field["recaptcha_type"];
				$req->contact_data = $field['contact_data'];
				$req->contact_data_width = $field['contact_data_width'];
				$req->creative_popup = $field["creative_popup"];
				$req->creative_popup_embed = $field["creative_popup_embed"];

				$req->id = NULL;

				$this->_db->insertObject( '#__creative_fields', $req, 'id' );

				$new_insert_id1 = $this->_db->insertid();

				//copy child options
				$query = "SELECT * FROM `#__creative_form_options` WHERE `id_parent` = '".$field["id"]."'";
				$this->_db->setQuery($query);
				$options = $this->_db->loadAssocList();

				if(is_array($options)) {
					foreach($options as $option) {
						$query = "INSERT INTO `#__creative_form_options` (`id_parent`,`name`,`value`,`ordering`,`showrow`,`selected`) 
						VALUES ('".$new_insert_id1."','".addslashes($option['name'])."','".addslashes($option['value'])."','".$option['ordering']."','".$option['showrow']."','".$option['selected']."') ";
						$this->_db->setQuery($query);
						$this->_db->execute();
					}
				}
				// END copy child options
			}
		}
	
		return $response;
	}

	function deleteForm($pks) {
		if(is_array($pks)) {
			foreach($pks as $f_id) {
				//delete form
				$query = "DELETE FROM `#__creative_forms` WHERE `id` = '".$f_id."'";
				$this->_db->setQuery($query);
				$this->_db->execute();

				//delete fields
				$query = "DELETE FROM `#__creative_fields` WHERE `id_form` = '".$f_id."'";
				$this->_db->setQuery($query);
				$this->_db->execute();
			}
		}
	}

	// version 4.6.3 cor
	function export($ids)
    {

    	$file_extension = '.ccf';

        $db    = $this->getDbo();
        $query = $db->getQuery(true)
            ->select('*')
            ->from('#__creative_forms')
            ->where('id IN ( ' . implode(', ', $ids) . ' )');
        $db->setQuery($query);
        $rows = $db->loadAssocList();
        // $rows = $db->loadObjectList();

        $fields_array = array();
        $options_array = array();
        foreach ($rows as $key => $row) {
        	$id = $row["id"];

        	// get fields
	        $query = "SELECT * FROM `#__creative_fields` WHERE `id_form` = '".$id."'";
			$this->_db->setQuery($query);
			$fields = $this->_db->loadAssocList();

			$fields_array[$id] = $fields;

			// get options
			foreach($fields as $k => $field_array) {
				$field_id = $field_array["id"];

				$query = "SELECT * FROM `#__creative_form_options` WHERE `id_parent` = '".$field_id."'";
				$this->_db->setQuery($query);
				$options = $this->_db->loadAssocList();

				$options_array[$field_id] = $options;
			}

        }

		$forms_array_top = array("ccf_forms" => $rows);
		$fields_array_top = array("ccf_fields" => $fields_array);
		$options_array_top = array("ccf_options" => $options_array);

		$final_array = array_merge($forms_array_top, $fields_array_top, $options_array_top);

        $string = json_encode($final_array);
        // $string = $final_array;
        // $string = json_encode($rows);

        $filename = JText::_("COM_CREATIVECONTACTFORM") . ' Items';
        if (count($rows) == 1)
        {
            $name = Joomla\String\StringHelper::strtolower(html_entity_decode($rows['0']['name']));
            $name = preg_replace('#[^a-z0-9_-]#', '_', $name);
            $name = trim(preg_replace('#__+#', '_', $name), '_-');

            $filename = JText::_("COM_CREATIVECONTACTFORM") .  ' Item (' . $name . ')';
        }

        // SET DOCUMENT HEADER
        if (preg_match('#Opera(/| )([0-9].[0-9]{1,2})#', $_SERVER['HTTP_USER_AGENT']))
        {
            $UserBrowser = "Opera";
        }
        elseif (preg_match('#MSIE ([0-9].[0-9]{1,2})#', $_SERVER['HTTP_USER_AGENT']))
        {
            $UserBrowser = "IE";
        }
        else
        {
            $UserBrowser = '';
        }
        $mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
        @ob_end_clean();
        ob_start();

        header('Content-Type: ' . $mime_type);
        header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');

        if ($UserBrowser == 'IE')
        {
            header('Content-Disposition: inline; filename="' . $filename . $file_extension . '"');
            header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
            header('Pragma: public');
        }
        else
        {
            header('Content-Disposition: attachment; filename="' . $filename . $file_extension . '"');
            header('Pragma: no-cache');
        }

        // PRINT STRING
        echo $string;
        // print_r($string);
        die;
    }

	// version 4.6.3 cor
    function import()
    {
    	$file_extension = '.ccf';
        $app = JFactory::getApplication();
        $file = $app->input->files->get("file");

        if (!is_array($file) || !isset($file['name']))
        {
            $msg = JText::_('COM_CREATIVECONTACTFORM_PLEASE_CHOOSE_A_VALID_FILE');
            $app->enqueueMessage($msg, 'error');
        	$app->redirect('index.php?option=com_creativecontactform&view=creativeforms&layout=import');
        }

        $ext = explode(".", $file['name']);

        if ($ext[count($ext) - 1] != substr($file_extension, 1))
        {
            $msg = JText::_('COM_CREATIVECONTACTFORM_PLEASE_CHOOSE_A_VALID_FILE');
            $app->enqueueMessage($msg, 'error');
        	$app->redirect('index.php?option=com_creativecontactform&view=creativeforms&layout=import');
        }

        jimport('joomla.filesystem.file');

        $data = file_get_contents($file['tmp_name']);

        if (empty($data)) {
            $msg = JText::_('COM_CREATIVECONTACTFORM_FILE_IS_EMPTY');
            $app->enqueueMessage($msg, 'error');
        	$app->redirect('index.php?option=com_creativecontactform&view=creativeforms');

            return;
        }

        $result = $this->importData($data);

        $msg = $result ? 'Items Saved!' : 'Error Saving Items';

        $app->enqueueMessage($msg, 'success');
    	$app->redirect('index.php?option=com_creativecontactform&view=creativeforms');
    }

    // version 4.6.3 cor
    function importData($data) {

    	$ccf_data = json_decode($data, true);
        if (is_null($ccf_data)) {
            $ccf_data = array();
        }

        $import_status = true;

        $ccf_forms = $ccf_data["ccf_forms"];
        $ccf_fields = $ccf_data["ccf_fields"];
        $ccf_options = $ccf_data["ccf_options"];

        if(sizeof($ccf_forms) == 0) {
        	$import_status = false;
        }
        else {
        	foreach ($ccf_forms as $key => $ccf_form) {
        		$form_id = $ccf_form["id"];
        		$pre_text = $ccf_form["pre_text"];

        		// create request
        		$req = new JObject();

        		foreach ($ccf_form as $key => $value) {
        			$req->$key = $value;
        		}

        		// overwrite id
        		$req->id = NULL;

				//get max ordering
				$query = "SELECT MAX(`ordering`) FROM `#__creative_forms`";
				$this->_db->setQuery($query);
				$max_order = $this->_db->loadResult();
				$max_order ++;

				// overwrite ordering
				$req->ordering = $max_order;
		
				if (!$this->_db->insertObject( '#__creative_forms', $req, 'id' )) {
					$import_status = false;

					continue;
				}
				$form_id_new = $this->_db->insertid();

				// write fields
				$ccf_form_fields = $ccf_fields[$form_id];

				if(sizeof($ccf_form_fields) > 0) {

					// process fields
					$creative_popups = array();

					foreach($ccf_form_fields as $key => $ccf_form_field) {
						$field_id = $ccf_form_field["id"];
						$field_type = $ccf_form_field["id_type"];

						// create request
        				$req = new JObject();

						foreach ($ccf_form_field as $key => $value) {

		        			$req->$key = $value;
		        		}

		        		$req->id = NULL;
						$req->id_form = $form_id_new;

						$this->_db->insertObject( '#__creative_fields', $req, 'id' );

						$field_id_new = $this->_db->insertid();

						// write fields options
						if($field_id_new != 0) {

							// check popup
							if($field_type == 21) {
								$creative_popups[$field_id] = $field_id_new;
							}
							
							$ccf_form_options = $ccf_options[$field_id];

							if(sizeof($ccf_form_options) > 0) {
								foreach($ccf_form_options as $key => $ccf_form_option) {

									// create request
			        				$req = new JObject();

			        				foreach ($ccf_form_option as $key => $value) {
					        			$req->$key = $value;
					        		}

					        		$req->id = NULL;
									$req->id_parent = $field_id_new;

									$this->_db->insertObject( '#__creative_form_options', $req, 'id' );
			        			}
							}
						}
					}

					// popup script, check pre text
					$pre_text_new = $pre_text;
					// check for {creative_popup id="N" structure
					if(sizeof($creative_popups) > 0) {
						$creative_popups_keys = array_keys($creative_popups);
						foreach($creative_popups_keys as $k => $f_id_1) {

							$pre_text_new = str_replace('{creative_popup id="'.$f_id_1.'"', '{creative_popup id="'.$creative_popups[$f_id_1].'"', $pre_text_new);

						}
					}

					// if we have updates
					if($pre_text_new != $pre_text) {
						// create request
        				$req = new JObject();

        				$req->id = $form_id_new;
        				$req->pre_text = $pre_text_new;
						$this->_db->updateObject( '#__creative_forms', $req, 'id' );
					}  

					// update fields records to check popup script
					$query = "SELECT * FROM `#__creative_fields` WHERE `id_form` = '".$form_id_new."'";
					$this->_db->setQuery($query);
					$fields = $this->_db->loadAssocList();

					if(sizeof($fields) > 0) {
						foreach($fields as $key => $field) {
							$field_id = $field["id"];

							$custom_html = $field["custom_html"];
							$name = $field["name"];
							$name_new = $name;
							$custom_html_new = $custom_html;

							// check for {creative_popup id="N" structure
							if(sizeof($creative_popups) > 0) {
								$creative_popups_keys = array_keys($creative_popups);
								foreach($creative_popups_keys as $k => $f_id_1) {
									$custom_html_new = str_replace('{creative_popup id="'.$f_id_1.'"', '{creative_popup id="'.$creative_popups[$f_id_1].'"', $custom_html_new);

									$name_new = str_replace('{creative_popup id="'.$f_id_1.'"', '{creative_popup id="'.$creative_popups[$f_id_1].'"', $name_new);
								}
							}

							// if we have updates
							if($name_new != $name || $custom_html_new != $custom_html) {

		        				$req = new JObject();

		        				$req->id = $field_id;
		        				$req->name = $name_new;
		        				$req->custom_html = $custom_html_new;
								$this->_db->updateObject( '#__creative_fields', $req, 'id' );
							}

							// update options
							$query = "SELECT * FROM `#__creative_form_options` WHERE `id_parent` = '".$field_id."'";
							$this->_db->setQuery($query);
							$options = $this->_db->loadAssocList();

							if(sizeof($options) > 0) {
								foreach($options as $key => $option) {
									$option_id = $option["id"];
									$option_name = $option["name"];
									$option_name_new = $option_name;

									// check for {creative_popup id="N" structure
									if(sizeof($creative_popups) > 0) {
										$creative_popups_keys = array_keys($creative_popups);
										foreach($creative_popups_keys as $k => $f_id_1) {

											$option_name_new = str_replace('{creative_popup id="'.$f_id_1.'"', '{creative_popup id="'.$creative_popups[$f_id_1].'"', $option_name_new);

										}
									}

									// if we have updates
									if($option_name_new != $option_name) {
										// create request
				        				$req = new JObject();

				        				$req->id = $option_id;
				        				$req->name = $option_name_new;
										$this->_db->updateObject( '#__creative_form_options', $req, 'id' );
									}
								}
							}
	        			}
	        		}
		        }
        	}
        }

        return $import_status;
    }

}