<?php
/**
 * Joomla! component Creative Contact Form
 *
 * @version $Id: 2012-04-05 14:30:25 svn $
 * @author creative-solutions.net
 * @package Creative Contact Form
 * @subpackage com_creativecontactform
 * @license GNU/GPL
 *
 */

// no direct access
defined('_JEXEC') or die('Restircted access');

// import Joomla modelform library
jimport('joomla.application.component.modeladmin');

class CreativeContactFormModelTemplate extends JModelAdmin
{
	/**
	 * Returns a reference to the a Table object, always creating it.
	 *
	 * @param	type	The table type to instantiate
	 * @param	string	A prefix for the table class name. Optional.
	 * @param	array	Configuration array for model. Optional.
	 * @return	JTable	A database object
	 * @since	1.6
	 */
	public function getTable($type = 'Template', $prefix = 'CreativeContactFormTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	/**
	 * Method to get the record form.
	 *
	 * @param	array	$data		Data for the form.
	 * @param	boolean	$loadData	True if the form is to load its own data (default case), false if not.
	 * @return	mixed	A JForm object on success, false on failure
	 * @since	1.6
	 */
	
	/**
	 * Method to get styles
	 *
	 */
	public function getStyles() {
		if(isset($_GET['id']))
			$id = (int)$_GET['id'];
		$db		= $this->getDbo();
		$sql = "SELECT `styles` FROM `#__contact_templates` WHERE `id` = ".$id;
		$db->setQuery($sql);
		return $styles = $db->loadResult();
	}
	
	public function getForm($data = array(), $loadData = true) 
	{
		// Get the form.
		$form = $this->loadForm('com_creativecontactform.template', 'template', array('control' => '', 'load_data' => $loadData));
		if (empty($form)) 
		{
			return false;
		}
		return $form;
	}
	/**
	 * Method to get the data that should be injected in the form.
	 *
	 * @return	mixed	The data for the form.
	 * @since	1.6
	 */
	protected function loadFormData() 
	{
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_creativepolling.edit.creativetemplate.data', array());
		if (empty($data)) 
		{
			$data = $this->getItem();
		}
		return $data;
	}
	
	/**
	 * Method to save data
	 *
	 * @return	mixed	The data for the form.
	 * @since	1.6
	 */
	public function store()
	{
		$id = (int)$_REQUEST['id'];
		$id_template = (int)$_REQUEST['id_template'];
		$published = (int)$_REQUEST['published'];
		$template_name = htmlspecialchars($_REQUEST['name'], ENT_QUOTES);
			
		//if id ==0, we add the record
		if($id == 0) {
	
			$query = ' SELECT * FROM #__contact_templates '.
					'  WHERE id = '.$id_template;
			$this->_db->setQuery( $query );
			$tmp = $this->_db->loadObject();
	
			$new_template = new JObject();
			$new_template->id = NULL;
			$new_template->name = $template_name;
			$new_template->published = $published;
			$new_template->styles = $tmp->styles;

			$new_template->created = '0000-00-00 00:00:00';
			$new_template->date_start = '0000-00-00 00:00:00';
			$new_template->date_end = '0000-00-00 00:00:00';
			$new_template->publish_up = '0000-00-00 00:00:00';
			$new_template->publish_down = '0000-00-00 00:00:00';
			$new_template->checked_out = 0;
			$new_template->checked_out_time = '0000-00-00 00:00:00';
			$new_template->access = 0;
			$new_template->ordering = 0;
			$new_template->featured = 0;
			$new_template->language = '';
	
			if (!$this->_db->insertObject( '#__contact_templates', $new_template, 'id' ))
				return false;
		}
		else { //else update the record
			$new_template = new JObject();
			$new_template->id = $id;
			$new_template->name = $template_name;
			$styles = str_replace(array('~','|'), '', $_REQUEST['styles']);
			$styles_formated = '';
			$ind = 0;
			foreach($styles as $k => $val) {
				$styles_formated .= $k.'~'.$val;
				if($ind != sizeof($styles) - 1)
					$styles_formated .= '|';
				$ind ++;
			}
	
			$new_template->styles = $styles_formated;
				
			if (!$this->_db->updateObject( '#__contact_templates', $new_template, 'id' ))
				return false;
		}
		return true;
	}

	// version 4.6.3 cor
	function export($ids)
    {

    	$file_extension = '.ccft';

        $db    = $this->getDbo();
        $query = $db->getQuery(true)
            ->select('*')
            ->from('#__contact_templates')
            ->where('id IN ( ' . implode(', ', $ids) . ' )');
        $db->setQuery($query);
        $rows = $db->loadAssocList();
        // $rows = $db->loadObjectList();

        $string = json_encode($rows);

        $filename = JText::_("COM_CREATIVECONTACTFORM") . ' Template Items';
        if (count($rows) == 1)
        {
            $name = Joomla\String\StringHelper::strtolower(html_entity_decode($rows['0']['name']));
            $name = preg_replace('#[^a-z0-9_-]#', '_', $name);
            $name = trim(preg_replace('#__+#', '_', $name), '_-');

            $filename = JText::_("COM_CREATIVECONTACTFORM") .  ' Template Item (' . $name . ')';
        }

        // SET DOCUMENT HEADER
        if (preg_match('#Opera(/| )([0-9].[0-9]{1,2})#', $_SERVER['HTTP_USER_AGENT']))
        {
            $UserBrowser = "Opera";
        }
        elseif (preg_match('#MSIE ([0-9].[0-9]{1,2})#', $_SERVER['HTTP_USER_AGENT']))
        {
            $UserBrowser = "IE";
        }
        else
        {
            $UserBrowser = '';
        }
        $mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
        @ob_end_clean();
        ob_start();

        header('Content-Type: ' . $mime_type);
        header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');

        if ($UserBrowser == 'IE')
        {
            header('Content-Disposition: inline; filename="' . $filename . $file_extension . '"');
            header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
            header('Pragma: public');
        }
        else
        {
            header('Content-Disposition: attachment; filename="' . $filename . $file_extension . '"');
            header('Pragma: no-cache');
        }

        // PRINT STRING
        echo $string;
        die;
    }

    // version 4.6.3 cor
    function import()
    {
    	$file_extension = '.ccft';
    	$app = JFactory::getApplication();
        $file = $app->input->files->get("file");

        if (!is_array($file) || !isset($file['name']))
        {
            $msg = JText::_('COM_CREATIVECONTACTFORM_PLEASE_CHOOSE_A_VALID_TEMPLATE_FILE');
            $app->enqueueMessage($msg, 'error');
        	$app->redirect('index.php?option=com_creativecontactform&view=templates&layout=import');
        }

        $ext = explode(".", $file['name']);

        if ($ext[count($ext) - 1] != substr($file_extension, 1))
        {
            $msg = JText::_('COM_CREATIVECONTACTFORM_PLEASE_CHOOSE_A_VALID_TEMPLATE_FILE');
            $app->enqueueMessage($msg, 'error');
        	$app->redirect('index.php?option=com_creativecontactform&view=templates&layout=import');
        }

        jimport('joomla.filesystem.file');

        $data = file_get_contents($file['tmp_name']);

        if (empty($data)) {
        	$msg = JText::_('COM_CREATIVECONTACTFORM_FILE_IS_EMPTY');
            $app->enqueueMessage($msg, 'error');
        	$app->redirect('index.php?option=com_creativecontactform&view=templates');

            return;
        }

        $result = $this->importData($data);

        $msg = $result ? 'Items Saved!' : 'Error Saving Items';

        $app->enqueueMessage($msg, 'success');
        $app->redirect('index.php?option=com_creativecontactform&view=templates');
    }

    // version 4.6.3 cor
    function importData($data) {

    	$ccf_data = json_decode($data, true);
        if (is_null($ccf_data)) {
            $ccf_data = array();
        }

        $import_status = true;

        $ccf_templates = $ccf_data;

        if(sizeof($ccf_templates) == 0) {
        	$import_status = false;
        }
        else {
        	foreach ($ccf_templates as $key => $ccf_template) {
        		// $template_id = $ccf_template["id"];

        		// create request
        		$req = new JObject();

        		foreach ($ccf_template as $key => $value) {
        			$req->$key = $value;
        		}

        		// overwrite id
        		$req->id = NULL;

				if (!$this->_db->insertObject( '#__contact_templates', $req, 'id' )) {
					$import_status = false;

					continue;
				}
				// $template_id_new = $this->_db->insertid();
        	}
        }

        return $import_status;
    }

}
