<?php
/**
 * Joomla! component Creative Contact Form
 *
 * @version $Id: 2012-04-05 14:30:25 svn $
 * @author creative-solutions.net
 * @package Creative Contact Form
 * @subpackage com_creativecontactform
 * @license GNU/GPL
 *
 */

// no direct access
defined('_JEXEC') or die('Restircted access');

class com_creativecontactformInstallerScript {

    /**
     * method to install the component
     *
     * @return void
     */
    function install($parent) {
        // installing module
        $module_installer = new JInstaller;
        @$module_installer->install(dirname(__FILE__).DIRECTORY_SEPARATOR.'modules'.DIRECTORY_SEPARATOR.'module');

       // installing plugin
        $plugin_installer = new JInstaller;
        $plugin_installer->install(dirname(__FILE__).DIRECTORY_SEPARATOR.'plugins'.DIRECTORY_SEPARATOR.'plugin');
        
        // enabling plugin
        $db = JFactory::getDBO();
        $db->setQuery('UPDATE #__extensions SET enabled = 1 WHERE element = "creativecontactform" AND folder = "system"');
        $db->execute();
    }

    /**
     * method to uninstall the component
     *
     * @return void
     */
    function uninstall($parent) {
        // $parent is the class calling this method
        //echo '<p>' . JText::_('COM_HELLOWORLD_UNINSTALL_TEXT') . '</p>';

        $db = JFactory::getDBO();
        
        $sql = 'SELECT `extension_id` AS id, `name`, `element`, `folder` FROM #__extensions WHERE `type` = "module" AND ( (`element` = "mod_creativecontactform") ) ';
        $db->setQuery($sql);
        $creative_module = $db->loadObject();
        $module_uninstaller = new JInstaller;
        if($module_uninstaller->uninstall('module', $creative_module->id))
             echo '<p>'.JText::_('COM_CREATIVECONTACTFORM_MODULE_UNINSTALL_SUCCESS').'</p>';
        else
            echo '<p>'.JText::_('COM_CREATIVECONTACTFORM_MODULE_UNINSTALL_FAILED').'</p>';

         // uninstalling creative image slider plugin
        $db->setQuery("select extension_id from #__extensions where type = 'plugin' and element = 'creativecontactform'");
        $creative_plugin = $db->loadObject();
        $plugin_uninstaller = new JInstaller;
        if($plugin_uninstaller->uninstall('plugin', $creative_plugin->extension_id))
            echo '<p>'.JText::_('COM_CREATIVECONTACTFORM_PLUGIN_UNINSTALL_SUCCESS').'</p>';
        else
            echo '<p>'.JText::_('COM_CREATIVECONTACTFORM_PLUGIN_UNINSTALL_FAILED').'</p>';
    }

    /**
     * method to update the component
     *
     * @return void
     */
    function update($parent) {
        // installing module
        $module_installer = new JInstaller;
        @$module_installer->install(dirname(__FILE__).DIRECTORY_SEPARATOR.'modules'.DIRECTORY_SEPARATOR.'module');

       // installing plugin
        $plugin_installer = new JInstaller;
        $plugin_installer->install(dirname(__FILE__).DIRECTORY_SEPARATOR.'plugins'.DIRECTORY_SEPARATOR.'plugin');
    }

    /**
     * method to run before an install/update/uninstall method
     *
     * @return void
     */
    function preflight($type, $parent) {
        // $parent is the class calling this method
        // $type is the type of change (install, update or discover_install)
        //echo '<p>' . JText::_('COM_HELLOWORLD_PREFLIGHT_' . $type . '_TEXT') . '</p>';
    }

    /**
     * method to run after an install/update/uninstall method
     *
     * @return void
     */
    function postflight($type, $parent) {

        if($type == 'uninstall') {
            return;
        }

        // return;
        $db = JFactory::getDBO();

       //2.0.1 -> 3.0.0 update/////////////////////////////////////////////////////////////////////////////////////////////
        $query = "SELECT * FROM `#__creative_fields` LIMIT 1";
        $db->setQuery($query);
        $columns_data = $db->LoadAssoc();

        if(is_array($columns_data)) {
            $columns_titles = array_keys($columns_data);
            if(!in_array('datepicker_date_format',$columns_titles)) {
                //add required columns to __creative_fields
                $query_update = "
                                    ALTER TABLE  `#__creative_fields`   
                                        ADD `tooltip_text` text not null after `name`,
                                        ADD `field_margin_top` text not null after `width`,
                                        ADD `column_type` tinyint not null DEFAULT  '0',
                                        ADD `datepicker_date_format` text not null,
                                        ADD `datepicker_animation` text not null,
                                        ADD `datepicker_style` SMALLINT UNSIGNED NOT NULL DEFAULT  '1',
                                        ADD `datepicker_icon_style` SMALLINT NOT NULL DEFAULT  '1',
                                        ADD `datepicker_show_icon` SMALLINT UNSIGNED NOT NULL DEFAULT  '1',
                                        ADD `datepicker_input_readonly` SMALLINT UNSIGNED NOT NULL DEFAULT  '1',
                                        ADD `datepicker_number_months` SMALLINT UNSIGNED NOT NULL DEFAULT  '1',
                                        ADD `datepicker_mindate` text not null,
                                        ADD `datepicker_maxdate` text not null,
                                        ADD `datepicker_changemonths` SMALLINT UNSIGNED NOT NULL DEFAULT  '0',
                                        ADD `datepicker_changeyears` SMALLINT UNSIGNED NOT NULL DEFAULT  '0',
                                        ADD `custom_html` text not null,
                                        ADD `heading` text not null,
                                        ADD `google_maps` text not null,
                                        ADD `recaptcha_site_key` text not null,
                                        ADD `recaptcha_security_key` text not null,
                                        ADD `recaptcha_wrong_message` text not null,
                                        ADD `recaptcha_theme` text not null,
                                        ADD `recaptcha_type` text not null,
                                        ADD `contact_data` text not null,
                                        ADD `contact_data_width` SMALLINT UNSIGNED NOT NULL DEFAULT '120',
                                        ADD `creative_popup` text not null,
                                        ADD `creative_popup_embed` text not null
                                    ";
                $db->setQuery($query_update);
                $db->execute();

                //add required columns to __creative_forms
                $query_update = "
                                    ALTER TABLE  `#__creative_forms`   
                                        ADD `email_info_show_referrer` tinyint not null DEFAULT  '1',
                                        ADD `email_info_show_ip` tinyint not null DEFAULT  '1',
                                        ADD `email_info_show_browser` tinyint not null DEFAULT  '1',
                                        ADD `email_info_show_os` tinyint not null DEFAULT  '1',
                                        ADD `email_info_show_sc_res` tinyint not null DEFAULT  '1',
                                        ADD `custom_css` text not null
                                    ";
                $db->setQuery($query_update);
                $db->execute();


                //add new field types
                $query_update = "INSERT INTO  `#__creative_field_types`(`id`, `name`) VALUES (NULL, 'Datepicker'),(NULL, 'Custom Html'),(NULL, 'Heading'),(NULL, 'Google Maps'),(NULL, 'Google reCAPTCHA'),(NULL, 'Contact Data'),(NULL, 'Creative Popup')";
                $db->setQuery($query_update);
                $db->execute();


                //update templates
                $query = "SELECT `id`,`styles` FROM `#__contact_templates`";
                $db->setQuery($query);
                $styles = $db->LoadAssocList();
                $addon_styles = '587~#111111|588~13|589~1|627~1|517~50|518~50|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~15|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|506~inherit|510~ccf_font_effect_none|502~left|511~ccf_font_effect_none|507~inherit|512~ccf_font_effect_none|509~inherit|505~white|508~inherit|519~85|520~90|500~left|501~left|513~ccf_font_effect_none|514~ccf_font_effect_none|521~85|522~90|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#e3e3e3|542~#e6e6e6|543~1|544~1|545~1|546~1|547~dotted|548~#b8b8b8|549~#b8b8b8|550~#b8b8b8|551~#b8b8b8|524~#525252|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#6b6b6b|532~0|533~0|534~0|515~ccf_font_effect_none|516~ccf_font_effect_none|552~1|553~#3d3d3d|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#ffffff|559~0|560~0|561~0|563~10|562~1|597~10|598~30|564~#0055cc|565~bold|566~normal|594~none|567~1|568~dotted|569~#ffffff|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#008f00|581~normal|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~|629~dark-thin|630~dark-thin|589~1|628~';
                if(is_array($styles)) {
                    foreach($styles as $val) {
                        $t_id = $val["id"];
                        $t_styles = $val["styles"];
                        $updates_styles = addslashes($t_styles) . '|' . addslashes($addon_styles);

                        $query_update_t = "UPDATE `#__contact_templates` SET `styles` = '".$updates_styles."' WHERE `id` = '".$t_id."'";
                        $db->setQuery($query_update_t);
                        $db->execute();
                    }
                }
                //END update styles
                
            }

        }
        // END 2.0.1->3.0.0 update////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


        // FREE TO PRO UPDATE////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $query_update = 
                            "
                                UPDATE `#__creative_field_types` SET `name` = CASE
                                    WHEN id = 13 THEN 'Captcha'
                                    WHEN id = 14 THEN 'File upload'
                                    WHEN id = 15 THEN 'Datepicker'
                                    WHEN id = 16 THEN 'Custom Html'
                                    WHEN id = 17 THEN 'Heading'
                                    WHEN id = 18 THEN 'Google Maps'
                                    WHEN id = 19 THEN 'Google reCAPTCHA'
                                    WHEN id = 20 THEN 'Contact Data'
                                    WHEN id = 21 THEN 'Creative Popup'
                                    ELSE `name`
                                    END 
                                WHERE id in (13,14,15,16,17,18,19,20,21)
                            ";
        $db->setQuery($query_update);
        $db->execute();

        // INSTALL TEMPLATES////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        $query = "SELECT `name` FROM `#__contact_templates`";
        $db->setQuery($query);
        $tmp_names_array = $db->LoadAssocList();

        $tmp_names = array();
        if(is_array($tmp_names_array)) {
            foreach($tmp_names_array as $k => $tmp_name) {
                $tmp_names[] = $tmp_name["name"];
            }
        }

        if(!in_array('Sky Template', $tmp_names)) {

            $ccf_templates_array  = array
                                            (
                                                'White Template 1' => '587~#111111|588~13|131~Arial, Helvetica, sans-serif|589~1|629~inset-2-dark|630~inset-2-dark|627~1|0~#ffffff|130~#ffffff|517~50|518~50|1~#dedede|2~1|3~solid|4~0|5~0|6~0|7~0|8~#ffffff|9~|10~0|11~0|12~0|13~0|14~#bababa|15~|16~0|17~0|18~7|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~0|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#000000|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#ffffff|28~2|29~1|30~2|190~3|191~0|192~82|502~left|193~3|194~1|195~#a8a8a8|196~dotted|197~#000000|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#ffffff|204~0|205~0|206~0|215~0|216~0|217~1|218~3|31~#000000|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#ffffff|38~2|39~1|40~1|41~#ff0000|42~20|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~white|508~inherit|132~#ffffff|133~#ffffff|168~60|519~90|520~90|500~left|501~left|134~#cccccc|135~1|136~solid|137~0|138~0|139~0|140~0|141~#f5f5f5|142~|143~0|144~0|145~10|146~0|147~#000000|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#1c1c1c|160~#ffffff|161~#cccccc|162~#d4d4d4|163~|164~0|165~0|166~10|167~2|513~ccf_font_effect_none|176~#ffdbdd|177~#ffdbdd|178~#ff9999|179~#363636|180~#ffffff|181~0|182~0|183~0|184~#ebaaaa|185~inset|186~0|187~0|188~19|189~0|171~#c70808|514~ccf_font_effect_none|172~#ffffff|173~2|174~1|175~1|169~95|521~90|522~90|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#f4f6f7|542~#f4f6f7|543~1|544~1|545~1|546~1|547~solid|548~#d4d4d4|549~#d4d4d4|550~#d4d4d4|551~#d4d4d4|524~#525252|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#e0e0e0|532~0|533~0|534~0|91~#ffffff|50~#e0e0e0|212~right|92~12|93~26|209~95|100~#c2c2c2|101~1|127~solid|102~0|103~0|104~0|105~0|94~#525252|95~|96~0|97~0|98~0|99~0|106~#666666|107~14|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#e0e0e0|124~#6b6b6b|516~ccf_font_effect_none|125~#ffffff|126~#cfcfcf|117~#999999|118~|119~0|120~0|121~6|122~0|552~1|553~#3d3d3d|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#ffffff|559~0|560~0|561~0|563~10|562~1|597~10|598~30|564~#0055cc|565~bold|566~normal|594~none|567~1|568~dotted|569~#ffffff|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#008f00|581~normal|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: #ddd;\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}|628~',
                                                'White Template 2' => '587~#111111|588~13|131~Arial, Helvetica, sans-serif|589~1|629~rounded-dark|630~rounded-dark|627~1|0~#ffffff|130~#ffffff|517~50|518~50|1~#ffffff|2~0|3~solid|4~10|5~10|6~10|7~10|8~#ffffff|9~inset|10~0|11~0|12~0|13~0|14~#ffffff|15~inset|16~0|17~0|18~0|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~15|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#3d2d3d|21~24|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#ffffff|28~2|29~1|30~2|190~5|191~6|192~90|502~left|193~5|194~1|195~#302930|196~dashed|197~#3d2d3d|198~12|199~bold|200~italic|201~none|202~inherit|511~ccf_font_effect_none|203~#ffffff|204~0|205~0|206~0|215~0|216~0|217~1|218~3|31~#3d2d3d|32~14|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#ffffff|38~2|39~1|40~1|41~#ff0000|42~18|43~bold|44~normal|509~inherit|46~#ffffff|47~2|48~1|49~1|505~apricot|508~inherit|132~#ffffff|133~#ffffff|168~63|519~85|520~85|500~left|501~left|134~#b6c9f5|135~1|136~solid|137~7|138~7|139~7|140~7|141~#89a100|142~inset|143~0|144~0|145~0|146~0|147~#000000|148~14|149~normal|150~normal|151~none|152~inherit|153~#000000|154~0|155~0|156~0|157~#ebebeb|158~#ffffff|159~#1c1c1c|160~#949494|161~#424242|162~#ffffff|163~inset|164~0|165~0|166~10|167~0|513~ccf_font_effect_none|176~#ed8e9b|177~#ed8e9b|178~#52000b|179~#ffffff|180~#ffffff|181~0|182~0|183~0|184~#cc7ecc|185~inset|186~1|187~1|188~10|189~0|171~#f70021|514~ccf_font_effect_none|172~#ffffff|173~2|174~1|175~1|169~93|521~85|522~85|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#f4f6f7|542~#f4f6f7|543~1|544~1|545~1|546~1|547~solid|548~#b8b8b8|549~#b8b8b8|550~#b8b8b8|551~#b8b8b8|524~#595959|525~14|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#d6d6d6|532~0|533~0|534~0|91~#000000|50~#000000|212~right|92~6|93~25|209~93|100~#ffffff|101~0|127~solid|102~7|103~7|104~7|105~7|94~#ffffff|95~|96~0|97~0|98~0|99~0|106~#ffffff|107~14|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#000000|114~1|115~-1|116~1|51~#666464|52~#666464|124~#fafafa|516~ccf_font_effect_none|125~#000000|126~#ffffff|117~#ffffff|118~|119~0|120~0|121~0|122~0|552~4|553~#3d3d3d|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#ffffff|559~0|560~0|561~0|563~13|562~8|597~10|598~30|564~#0055cc|565~bold|566~normal|594~none|567~1|568~dotted|569~#ffffff|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#008f00|581~normal|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~/*contact data icons styles*/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(185, 185, 186, 1);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: #ddd;\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}|628~',
                                                'Black Template 1' => '587~#cccccc|588~13|131~ccf-googlewebfont-Maven Pro|589~2|629~rounded-dark|630~rounded|627~0|0~#ffffff|130~#ffffff|517~50|518~50|1~#373737|2~1|3~solid|4~12|5~12|6~12|7~12|8~#000000|9~|10~2|11~4|12~5|13~0|14~#000000|15~|16~0|17~0|18~7|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~0|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#ffffff|21~30|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~2|30~2|190~3|191~0|192~82|502~left|193~3|194~1|195~#bababa|196~dotted|197~#c7c7c7|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~2|205~2|206~2|215~0|216~0|217~3|218~3|31~#adadad|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#000000|38~2|39~1|40~1|41~#ff0000|42~20|43~normal|44~normal|509~inherit|46~#000000|47~2|48~1|49~1|505~black|508~inherit|132~#595959|133~#595959|168~60|519~90|520~90|500~left|501~left|134~#4c4c4c|135~1|136~solid|137~5|138~5|139~5|140~5|141~#f5f5f5|142~|143~0|144~0|145~0|146~0|147~#c7c7c7|148~14|149~normal|150~normal|151~none|152~inherit|153~#000000|154~2|155~1|156~1|157~#ffffff|158~#ededed|159~#dedede|160~#000000|161~#828282|162~#808080|163~|164~0|165~0|166~8|167~1|513~ccf_font_effect_none|176~#ffffff|177~#ffffff|178~#520101|179~#bd0000|180~#000000|181~2|182~2|183~1|184~#6e2a2a|185~|186~0|187~0|188~8|189~1|171~#ba0000|514~ccf_font_effect_none|172~#000000|173~2|174~1|175~1|169~95|521~90|522~90|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#424242|542~#262626|543~1|544~1|545~1|546~1|547~solid|548~#383838|549~#383838|550~#141414|551~#2e2e2e|524~#b0b0b0|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~2|533~1|534~1|91~#262626|50~#0d0d0d|212~right|92~11|93~25|209~93|100~#424142|101~1|127~solid|102~7|103~7|104~7|105~7|94~#525252|95~|96~0|97~0|98~0|99~0|106~#949494|107~16|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#000000|114~2|115~1|116~2|51~#262626|52~#0d0d0d|124~#adadad|516~ccf_font_effect_none|125~#000000|126~#757575|117~#7a7a7a|118~|119~0|120~0|121~7|122~1|552~2|553~#bfbfbf|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#000000|559~2|560~2|561~2|563~2|562~2|597~10|598~30|564~#4c8bff|565~normal|566~normal|594~none|567~1|568~dotted|569~#0a78ff|570~#000000|571~2|572~1|573~2|574~#b00023|595~none|575~#b50000|576~#000000|577~2|578~1|579~1|580~#00a800|581~normal|582~italic|593~none|583~#000000|584~2|585~1|586~1|599~/*Wrapper styling******************************************/\n.creative_form_FORM_ID.creativecontactform_wrapper {\nbackground-image: url("ccf_img_path/bg_black_2.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\nborder-top: 1px solid rgba(48, 48, 48, 0.55) !important;\nwebkit-box-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5) !important;\n-moz-box-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5) !important;\nbox-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5 !important);\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creativecontactform_wrapper_inner{\nbackground: transparent url("ccf_img_path/bg_light.png") center 0px no-repeat;\nbackground-size: 100% 100% !important;\n}\n/*Input fields styles***************************************/\n.creative_form_FORM_ID .creativecontactform_input_element{\nbackground: -webkit-linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\nbackground: -moz-linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\nbackground: linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\n}\n/*select field type icon************************************/\n.creative_form_FORM_ID .ccf_select_icon {\nopacity: 0.5;\n}\n/*set creative checkbox opacity*************************/\n.creative_form_FORM_ID a.creativeform_twoglux_styled_element {\nopacity: 0.85;\n}\n/*Heading styles******************************************/\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 0.31) !important;\n}\n/*contact data icons styles******************************/\n.creative_form_FORM_ID .ccf_content_icon {\n/*\nbackground-color: rgba(126, 126, 126, 0.33) !important;\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n*/\n}\n/*popup styles*********************************************/\n.creative_form_FORM_ID.ccf_popup_inner_wrapper  .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 1) !important;\n}\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: rgba(132, 132, 132, 0.25);\ncolor: #ddd;\ntext-shadow: -1px 2px 2px #000;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar h1 {\ncolor: #fff;\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.08);\nborder-top: 1px solid rgba(0,0,0,0.7);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #c2c2c2;\nbackground: rgba(40, 40, 40, 0.77);\n}|628~',
                                                'Black Template 2' => '587~#ffffff|588~13|131~ccf-googlewebfont-Actor|589~2|629~3d-dark|630~3d|627~1|0~#2e2d2e|130~#050505|517~50|518~50|1~#2b2b2b|2~1|3~solid|4~12|5~0|6~0|7~12|8~#202020|9~|10~0|11~0|12~7|13~0|14~#000000|15~|16~0|17~0|18~10|19~1|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~15|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#ffffff|21~30|22~normal|23~normal|24~none|25~left|506~ccf-googlewebfont-Antic Slab|510~ccf_font_effect_none|27~#000000|28~1|29~1|30~3|190~2|191~0|192~90|502~left|193~6|194~1|195~#808080|196~dotted|197~#fafafa|198~13|199~normal|200~italic|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~-1|205~2|206~2|215~10|216~0|217~2|218~1|31~#ffffff|32~14|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#000000|38~1|39~1|40~1|41~#d60000|42~21|43~normal|44~normal|509~inherit|46~#000000|47~0|48~0|49~0|505~carrot-orange|508~inherit|132~#202020|133~#383838|168~60|519~85|520~90|500~left|501~left|134~#949494|135~1|136~solid|137~4|138~4|139~4|140~4|141~#ffffff|142~|143~0|144~0|145~0|146~0|147~#fafafa|148~14|149~normal|150~normal|151~none|152~inherit|153~#fcfcfc|154~0|155~0|156~0|157~#454545|158~#0a0a0a|159~#ffffff|160~#ff0000|161~#6b6b6b|162~#fcffc2|163~|164~0|165~0|166~20|167~-1|513~ccf_font_effect_none|176~#f0b400|177~#701a00|178~#e6cfcf|179~#ffffff|180~#000000|181~-1|182~-1|183~1|184~#ffffff|185~|186~0|187~0|188~15|189~-2|171~#e03c00|514~ccf_font_effect_none|172~#000000|173~0|174~1|175~2|169~95|521~85|522~90|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#666666|542~#242424|543~1|544~1|545~1|546~1|547~solid|548~#808080|549~#6b6b6b|550~#424242|551~#6b6b6b|524~#ffffff|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~-1|533~-1|534~2|91~#616161|50~#000000|212~left|92~9|93~33|209~90|100~#383038|101~1|127~solid|102~8|103~0|104~0|105~8|94~#ffffff|95~|96~0|97~2|98~12|99~-2|106~#d1d1d1|107~15|108~bold|109~normal|110~none|112~ccf-googlewebfont-Antic Slab|515~ccf_font_effect_none|113~#000103|114~1|115~-1|116~1|51~#000000|52~#696969|124~#fafafa|516~ccf_font_effect_none|125~#000000|126~#383038|117~#ffffff|118~|119~1|120~-1|121~12|122~-2|552~2|553~#d1d1d1|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#000000|559~-1|560~-1|561~2|563~21|562~2|597~10|598~30|564~#639cff|565~normal|566~normal|594~none|567~0|568~dotted|569~#ffffff|570~#000000|571~1|572~1|573~2|574~#db002c|595~underline|575~#b50000|576~#000000|577~1|578~1|579~2|580~#008f00|581~normal|582~italic|593~none|583~#000000|584~-1|585~-1|586~1|599~.creative_form_FORM_ID .ccf_content_icon {\n/*background-color: #545454;*/\n}\n/*popup styles*********************************************/\n.creative_form_FORM_ID.ccf_popup_inner_wrapper  .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 1) !important;\n}\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: rgba(132, 132, 132, 0.25);\ncolor: #ddd;\ntext-shadow: -1px 2px 2px #000;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar h1 {\ncolor: #fff;\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.08);\nborder-top: 1px solid rgba(0,0,0,0.7);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #c2c2c2;\nbackground:rgba(27, 27, 27, 1);\n}|628~',
                                                'Gray Template 1' => '587~#000819|588~13|131~ccf-googlewebfont-Actor|589~1|629~inset-dark|630~inset-dark|627~0|0~#121212|130~#0f0f0f|517~50|518~50|1~#707070|2~1|3~solid|4~0|5~0|6~0|7~0|8~#ffffff|9~|10~0|11~0|12~1|13~0|14~#000000|15~|16~0|17~0|18~3|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~5|608~solid|609~#000000|610~1|611~#ebebeb|612~#c7c7c7|613~25|614~15|615~15|616~15|617~0|618~#ffffff|619~#ffffff|620~15|621~21|622~20|623~15|624~3|625~solid|626~#000000|20~#ffffff|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~4|190~3|191~0|192~82|502~left|193~3|194~1|195~#a8a8a8|196~dotted|197~#dbdbdb|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~0|205~0|206~0|215~0|216~0|217~1|218~3|31~#000000|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#ffffff|38~2|39~1|40~1|41~#d40808|42~22|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~black|508~inherit|132~#ffffff|133~#ffffff|168~60|519~85|520~90|500~left|501~left|134~#8a8a8a|135~1|136~solid|137~0|138~0|139~0|140~0|141~#000819|142~inset|143~0|144~0|145~0|146~0|147~#000819|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#000819|160~#ffffff|161~#8a8a8a|162~#878787|163~inset|164~0|165~0|166~10|167~0|513~ccf_font_effect_none|176~#ffdbdd|177~#ffdbdd|178~#f27777|179~#000819|180~#ffffff|181~-1|182~1|183~1|184~#ebaaaa|185~inset|186~0|187~0|188~18|189~0|171~#b30000|514~ccf_font_effect_none|172~#ffffff|173~2|174~1|175~1|169~95|521~85|522~90|170~150|523~167|535~7|536~15|537~8|538~12|539~15|540~15|541~#999999|542~#a6a6a6|543~1|544~1|545~1|546~1|547~solid|548~#8f8f8f|549~#9c9c9c|550~#949494|551~#9c9c9c|524~#ffffff|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~-1|533~-1|534~1|91~#ffffff|50~#b0b0b0|212~right|92~10|93~20|209~99|100~#000819|101~1|127~solid|102~12|103~12|104~12|105~12|94~#696969|95~|96~0|97~0|98~4|99~0|106~#000819|107~15|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#8f8f8f|124~#000819|516~ccf_font_effect_none|125~#ffffff|126~#000000|117~#9c9fa6|118~|119~0|120~0|121~7|122~1|552~4|553~#000000|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#ffffff|558~#ffffff|559~0|560~0|561~0|563~10|562~1|597~10|598~30|564~#003bb0|565~bold|566~normal|594~none|567~0|568~dotted|569~#ffffff|570~#808080|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#008f00|581~normal|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~/*bg images************************************************/\n.creative_form_FORM_ID .creativecontactform_header {\nbackground-image: url("ccf_img_path/bg_header.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\n}\n.creative_form_FORM_ID .creativecontactform_footer {\nbackground-image: url("ccf_img_path/bg_footer.png") !important;\nbackground-repeat: repeat-x !important;\nbackground-size: auto auto !important;\n}\n/*contact data icons styles******************************/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(165, 165, 165, 1);\n/*border-radius: 100%;*/\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #689AFF !important; \ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: #ececec;\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}\n|628~',
                                                'Gray Template 2' => '587~#000819|588~13|131~ccf-googlewebfont-Gudea|589~1|629~rounded-dots-dark|630~rounded-dots-dark|627~0|0~#3d3d3d|130~#333333|517~50|518~50|1~#707070|2~1|3~solid|4~0|5~0|6~0|7~0|8~#ffffff|9~|10~0|11~0|12~1|13~0|14~#000000|15~|16~0|17~0|18~3|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~5|608~solid|609~#000000|610~1|611~#ffffff|612~#f0f0f0|613~25|614~15|615~15|616~15|617~0|618~#ffffff|619~#ffffff|620~15|621~21|622~20|623~15|624~3|625~solid|626~#000000|20~#ffffff|21~27|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~4|190~3|191~0|192~82|502~left|193~3|194~1|195~#a8a8a8|196~dotted|197~#dbdbdb|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~0|205~0|206~0|215~0|216~0|217~1|218~3|31~#000000|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#ffffff|38~2|39~1|40~1|41~#d40808|42~22|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~black|508~inherit|132~#ffffff|133~#ffffff|168~60|519~90|520~90|500~left|501~left|134~#8a8a8a|135~1|136~solid|137~0|138~0|139~0|140~0|141~#000819|142~inset|143~0|144~0|145~0|146~0|147~#000819|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#000819|160~#ffffff|161~#8a8a8a|162~#878787|163~inset|164~0|165~0|166~10|167~0|513~ccf_font_effect_none|176~#ffdbdd|177~#ffdbdd|178~#f27777|179~#000819|180~#ffffff|181~-1|182~1|183~1|184~#ebaaaa|185~inset|186~0|187~0|188~18|189~0|171~#b30000|514~ccf_font_effect_none|172~#ffffff|173~2|174~1|175~1|169~95|521~90|522~90|170~150|523~167|535~10|536~15|537~10|538~12|539~15|540~15|541~#999999|542~#5c5c5c|543~1|544~1|545~1|546~1|547~solid|548~#8a8a8a|549~#757575|550~#5c5c5c|551~#757575|524~#ffffff|525~16|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~-1|533~-1|534~1|91~#ffffff|50~#b0b0b0|212~right|92~10|93~20|209~99|100~#000819|101~1|127~solid|102~12|103~12|104~12|105~12|94~#696969|95~|96~0|97~0|98~4|99~0|106~#000819|107~15|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#8f8f8f|124~#000819|516~ccf_font_effect_none|125~#ffffff|126~#000000|117~#9c9fa6|118~|119~0|120~0|121~7|122~1|552~2|553~#000000|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#ffffff|558~#ffffff|559~0|560~0|561~0|563~10|562~1|597~10|598~30|564~#003bb0|565~bold|566~normal|594~none|567~1|568~dotted|569~#ffffff|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#008f00|581~normal|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~/*bg images************************************************/\n.creative_form_FORM_ID .creativecontactform_header {\nbackground-image: url("ccf_img_path/bg_header.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\n}\n.creative_form_FORM_ID .creativecontactform_footer {\nbackground-image: url("ccf_img_path/bg_footer.png") !important;\nbackground-repeat: repeat-x !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_body {\nbackground-image: url("ccf_img_path/bg_gray_1.png") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(0, 0, 0, 0.33) !important;\n}\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #689AFF !important; \ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgb(190, 190, 190);\nbackground-color: #DADADA;\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}\n|628~',
                                                'Gray Template 3' => '587~#000819|588~13|131~ccf-googlewebfont-Marmelad|589~1|629~dark-thin|630~dark-thin|627~0|0~#2e2e2e|130~#1f1f1f|517~50|518~50|1~#707070|2~1|3~solid|4~0|5~0|6~0|7~0|8~#ffffff|9~|10~0|11~0|12~1|13~0|14~#000000|15~|16~0|17~0|18~3|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~5|608~solid|609~#000000|610~1|611~#ffffff|612~#f0f0f0|613~25|614~15|615~15|616~15|617~0|618~#ffffff|619~#ffffff|620~15|621~21|622~20|623~15|624~3|625~solid|626~#000000|20~#ffffff|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~4|190~3|191~0|192~82|502~left|193~3|194~1|195~#a8a8a8|196~dotted|197~#dbdbdb|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~0|205~0|206~0|215~0|216~0|217~1|218~3|31~#000000|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#ffffff|38~2|39~1|40~1|41~#d40808|42~22|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~black|508~inherit|132~#ffffff|133~#ffffff|168~60|519~85|520~90|500~left|501~left|134~#8a8a8a|135~1|136~solid|137~0|138~0|139~0|140~0|141~#000819|142~inset|143~0|144~0|145~0|146~0|147~#000819|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#000819|160~#ffffff|161~#8a8a8a|162~#878787|163~inset|164~0|165~0|166~10|167~0|513~ccf_font_effect_none|176~#ffdbdd|177~#ffdbdd|178~#f27777|179~#000819|180~#ffffff|181~-1|182~1|183~1|184~#ebaaaa|185~inset|186~0|187~0|188~18|189~0|171~#b30000|514~ccf_font_effect_none|172~#ffffff|173~2|174~1|175~1|169~95|521~85|522~90|170~150|523~167|535~10|536~15|537~9|538~12|539~15|540~15|541~#999999|542~#5c5c5c|543~1|544~1|545~1|546~1|547~solid|548~#8a8a8a|549~#8a8a8a|550~#7d7d7d|551~#8a8a8a|524~#ffffff|525~16|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~-1|533~-1|534~1|91~#ffffff|50~#b0b0b0|212~right|92~10|93~20|209~99|100~#000819|101~1|127~solid|102~12|103~12|104~12|105~12|94~#696969|95~|96~0|97~0|98~4|99~0|106~#000819|107~14|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#8f8f8f|124~#000819|516~ccf_font_effect_none|125~#ffffff|126~#000000|117~#9c9fa6|118~|119~0|120~0|121~7|122~1|552~4|553~#000000|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#ffffff|558~#ffffff|559~0|560~0|561~0|563~10|562~1|597~10|598~30|564~#003bb0|565~bold|566~normal|594~none|567~1|568~dotted|569~#ffffff|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#005700|581~bold|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~/*bg images************************************************/\n.creative_form_FORM_ID .creativecontactform_header {\nbackground-image: url("ccf_img_path/bg_header.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\n}\n.creative_form_FORM_ID .creativecontactform_footer {\nbackground-image: url("ccf_img_path/bg_footer.png") !important;\nbackground-repeat: repeat-x !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_body {\nbackground-image: url("ccf_img_path/bg_gray_2.png") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(0, 0, 0, 0.33) !important;\n}\n/*contact data icons styles*****************************/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(0, 0, 0, 0.27);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #689AFF !important; \ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgb(190, 190, 190);\nbackground-color: #DADADA;\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}\n\n|628~',
                                                'Gray Template 4' => '587~#000819|588~13|131~ccf-googlewebfont-Metrophobic|589~1|629~rounded-dark|630~rounded-dark|627~0|0~#3d3d3d|130~#121212|517~50|518~50|1~#707070|2~1|3~solid|4~0|5~0|6~0|7~0|8~#ffffff|9~|10~0|11~0|12~1|13~0|14~#000000|15~|16~0|17~0|18~3|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~7|608~solid|609~#5e5e5e|610~1|611~#ffffff|612~#f0f0f0|613~25|614~15|615~15|616~15|617~0|618~#ffffff|619~#ffffff|620~15|621~21|622~20|623~15|624~7|625~solid|626~#6b6b6b|20~#ffffff|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~4|190~3|191~0|192~82|502~left|193~3|194~1|195~#a8a8a8|196~dotted|197~#dbdbdb|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~0|205~0|206~0|215~0|216~0|217~1|218~3|31~#000000|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#000000|38~0|39~0|40~0|41~#d40808|42~22|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~black|508~inherit|132~#ffffff|133~#ffffff|168~60|519~85|520~90|500~left|501~left|134~#8a8a8a|135~1|136~solid|137~0|138~0|139~0|140~0|141~#000819|142~inset|143~0|144~0|145~0|146~0|147~#000819|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#000819|160~#ffffff|161~#8a8a8a|162~#878787|163~inset|164~0|165~0|166~10|167~0|513~ccf_font_effect_none|176~#ffffff|177~#ffffff|178~#b83333|179~#a80000|180~#ffffff|181~-1|182~1|183~1|184~#ebaaaa|185~inset|186~0|187~0|188~0|189~0|171~#b30000|514~ccf_font_effect_none|172~#ffffff|173~2|174~1|175~1|169~95|521~85|522~90|170~150|523~167|535~9|536~15|537~10|538~12|539~15|540~15|541~#999999|542~#5c5c5c|543~1|544~1|545~1|546~1|547~solid|548~#858585|549~#858585|550~#787878|551~#858585|524~#ffffff|525~16|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~-1|533~-1|534~1|91~#ffffff|50~#b0b0b0|212~right|92~10|93~20|209~99|100~#000819|101~1|127~solid|102~12|103~12|104~12|105~12|94~#696969|95~|96~0|97~0|98~4|99~0|106~#000819|107~15|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#8f8f8f|124~#000819|516~ccf_font_effect_none|125~#ffffff|126~#000000|117~#9c9fa6|118~|119~0|120~0|121~7|122~1|552~4|553~#424242|554~14|555~bold|556~italic|596~none|590~0|591~dotted|592~#ffffff|558~#ffffff|559~0|560~0|561~0|563~10|562~1|597~10|598~30|564~#003bb0|565~bold|566~normal|594~none|567~1|568~dotted|569~#ffffff|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#005c00|581~bold|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~/*bg images************************************************/\n.creative_form_FORM_ID .creativecontactform_header {\nbackground-image: url("ccf_img_path/bg_black_1.png") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\n}\n.creative_form_FORM_ID .creativecontactform_footer {\nbackground-image: url("ccf_img_path//bg_black_1.png") !important;\nbackground-repeat: repeat-x !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_body {\nbackground-image: url("ccf_img_path/bg_gray_3.png") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(0, 0, 0, 0.33) !important;\n}\n/*contact data icons styles*/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(152, 152, 144, 0.73);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n\n\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #689AFF !important; \ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgb(139, 139, 139);\nbackground-color: rgba(169, 169, 157, 0.56);\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}\n\n|628~',
                                                'Gray Template 5' => '587~#111111|588~13|131~ccf-googlewebfont-Molengo|589~1|629~inset-3-dark|630~inset-3-dark|627~1|0~#fafafa|130~#a3a3a3|517~50|518~50|1~#ababab|2~1|3~solid|4~8|5~8|6~8|7~8|8~#333333|9~|10~3|11~3|12~13|13~-1|14~#000000|15~|16~0|17~0|18~10|19~1|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~5|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~0|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#333333|21~30|22~normal|23~italic|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#ffffff|28~1|29~1|30~3|190~4|191~0|192~100|502~left|193~5|194~1|195~#292929|196~dotted|197~#333333|198~13|199~normal|200~italic|201~none|202~inherit|511~ccf_font_effect_none|203~#a3a3a3|204~0|205~0|206~0|215~0|216~0|217~1|218~0|31~#000000|32~14|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#9c9c9c|38~0|39~0|40~0|41~#f00000|42~16|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~black|508~inherit|132~#f0f0f0|133~#9c9c9c|168~60|519~85|520~90|500~left|501~left|134~#333333|135~1|136~solid|137~4|138~4|139~4|140~4|141~#969696|142~inset|143~0|144~0|145~3|146~0|147~#000000|148~14|149~normal|150~normal|151~none|152~inherit|153~#8f8f8f|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#1c1c1c|160~#949494|161~#4a4a4a|162~#424142|163~inset|164~0|165~0|166~18|167~0|513~ccf_font_effect_none|176~#b5b5b5|177~#000000|178~#000000|179~#ffffff|180~#000000|181~0|182~0|183~0|184~#424142|185~inset|186~0|187~0|188~18|189~0|171~#c40a0a|514~ccf_font_effect_none|172~#000000|173~0|174~0|175~0|169~95|521~85|522~90|170~150|523~130|535~9|536~15|537~10|538~12|539~15|540~15|541~#ffffff|542~#c2c2c2|543~1|544~1|545~1|546~1|547~solid|548~#c2c2c2|549~#bdbdbd|550~#a8a8a8|551~#bdbdbd|524~#2e2e2e|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#919191|532~0|533~0|534~0|91~#bababa|50~#212121|212~right|92~6|93~25|209~95|100~#141414|101~1|127~solid|102~7|103~7|104~7|105~7|94~#636363|95~inset|96~2|97~2|98~3|99~-1|106~#ffffff|107~14|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#000000|114~1|115~-1|116~1|51~#212121|52~#bababa|124~#fafafa|516~ccf_font_effect_none|125~#000000|126~#141414|117~#5c5c5c|118~inset|119~-2|120~-2|121~3|122~-1|552~2|553~#3d3d3d|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#000000|559~0|560~0|561~0|563~2|562~1|597~10|598~30|564~#0055cc|565~bold|566~normal|594~none|567~0|568~dotted|569~#ffffff|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#008f00|581~normal|582~italic|593~none|583~#000000|584~0|585~0|586~0|599~/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgb(190, 190, 190);\nbackground-color: #DADADA;\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}\n|628~',
                                                'Blue Template 1' => '587~#000819|588~13|131~ccf-googlewebfont-Actor|589~1|629~inset-2-dark|630~inset-2-dark|627~1|0~#ffffff|130~#ffffff|517~50|518~50|1~#717987|2~1|3~solid|4~18|5~18|6~18|7~18|8~#ffffff|9~|10~0|11~0|12~1|13~0|14~#000819|15~|16~0|17~0|18~3|19~0|600~1|601~#496c80|602~#000819|603~15|604~15|605~15|606~15|607~2|608~solid|609~#000819|610~1|611~#ffffff|612~#f0f0f0|613~25|614~15|615~15|616~15|617~1|618~#496c80|619~#000819|620~15|621~21|622~20|623~15|624~1|625~solid|626~#000819|20~#ffffff|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~4|190~3|191~0|192~82|502~left|193~3|194~1|195~#a8a8a8|196~dotted|197~#dbdbdb|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~0|205~0|206~0|215~0|216~0|217~1|218~3|31~#000819|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#ffffff|38~2|39~1|40~1|41~#d40808|42~22|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~black|508~inherit|132~#ffffff|133~#bac4d6|168~60|519~90|520~90|500~left|501~left|134~#8a8a8a|135~1|136~solid|137~7|138~7|139~7|140~7|141~#000819|142~inset|143~0|144~0|145~0|146~0|147~#000819|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#bac4d6|159~#000819|160~#ffffff|161~#8a8a8a|162~#7c90a3|163~inset|164~0|165~0|166~7|167~1|513~ccf_font_effect_none|176~#ffdbdd|177~#ffdbdd|178~#f27777|179~#000819|180~#ffffff|181~-1|182~1|183~1|184~#ebaaaa|185~inset|186~0|187~0|188~18|189~0|171~#b30000|514~ccf_font_effect_none|172~#ffffff|173~2|174~1|175~1|169~95|521~90|522~90|170~150|523~167|535~8|536~15|537~11|538~12|539~15|540~15|541~#496c80|542~#1c303b|543~1|544~1|545~1|546~1|547~solid|548~#496c80|549~#496c80|550~#496c80|551~#496c80|524~#ffffff|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~-1|533~-1|534~1|91~#ffffff|50~#576480|212~right|92~10|93~20|209~99|100~#000819|101~1|127~solid|102~12|103~12|104~12|105~12|94~#001338|95~|96~0|97~0|98~4|99~0|106~#000819|107~15|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#576480|124~#000819|516~ccf_font_effect_none|125~#ffffff|126~#000819|117~#000819|118~|119~0|120~0|121~7|122~1|552~4|553~#213c5e|554~13|555~bold|556~normal|596~none|590~0|591~dotted|592~#ffffff|558~#ffffff|559~0|560~0|561~0|563~10|562~1|597~10|598~30|564~#003bb0|565~bold|566~normal|594~none|567~1|568~dotted|569~#ffffff|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#008f00|581~normal|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~/*contact data icons styles*****************************/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(48, 91, 116, 0.81);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #46A7E2 !important; \ntext-shadow: -1px 1px 2px #000 !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: -1px 1px 2px #000 !important;\nborder-bottom: none !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgba(189, 189, 189, 1);\nbackground-color: rgba(216, 216, 216, 1);\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}|628~',
                                                'Blue Template 2' => '587~#000819|588~13|131~ccf-googlewebfont-Fresca|589~1|629~inset-2-dark|630~rounded-dots-dark|627~0|0~#114159|130~#ffffff|517~50|518~50|1~#3e7794|2~1|3~solid|4~12|5~12|6~12|7~12|8~#ffffff|9~|10~0|11~0|12~1|13~0|14~#000000|15~|16~0|17~0|18~3|19~0|600~1|601~#7baec7|602~#114159|603~10|604~15|605~10|606~15|607~1|608~solid|609~#105070|610~0|611~#ffffff|612~#f0f0f0|613~25|614~15|615~15|616~15|617~1|618~#3d7a99|619~#063d57|620~10|621~21|622~12|623~15|624~1|625~solid|626~#06557d|20~#ffffff|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~4|190~3|191~0|192~82|502~left|193~3|194~1|195~#f5f5f5|196~dotted|197~#f5f5f5|198~14|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~-1|205~1|206~1|215~0|216~0|217~1|218~3|31~#022536|32~14|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#cee5f0|38~2|39~1|40~1|41~#d40808|42~22|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~sky-blue|508~inherit|132~#ffffff|133~#ffffff|168~60|519~85|520~90|500~left|501~left|134~#2c627d|135~1|136~solid|137~0|138~0|139~0|140~0|141~#000819|142~|143~0|144~0|145~0|146~0|147~#104661|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#03202e|160~#ffffff|161~#114159|162~#114159|163~|164~0|165~0|166~10|167~0|513~ccf_font_effect_none|176~#ffffff|177~#ffffff|178~#f27777|179~#9e0808|180~#ffffff|181~-1|182~1|183~1|184~#944141|185~|186~0|187~0|188~9|189~0|171~#b80000|514~ccf_font_effect_none|172~#b8b8b8|173~0|174~0|175~0|169~93|521~85|522~90|170~150|523~167|535~9|536~15|537~10|538~12|539~15|540~15|541~#999999|542~#5c5c5c|543~0|544~0|545~0|546~0|547~solid|548~#a1a1a1|549~#575757|550~#424242|551~#696969|524~#ffffff|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~-1|533~-1|534~1|91~#ffffff|50~#87b2c7|212~right|92~10|93~20|209~99|100~#014161|101~1|127~solid|102~12|103~12|104~12|105~12|94~#696969|95~|96~0|97~0|98~4|99~0|106~#043147|107~15|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#87b2c7|124~#002538|516~ccf_font_effect_none|125~#ffffff|126~#00334d|117~#9c9fa6|118~|119~0|120~0|121~7|122~1|552~4|553~#002a3d|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#ffffff|558~#cee5f0|559~2|560~1|561~1|563~10|562~1|597~10|598~30|564~#024f73|565~bold|566~normal|594~none|567~1|568~dotted|569~#00354d|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#006100|581~bold|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~.creative_form_FORM_ID .creativecontactform_body {\nbackground-image: url("ccf_img_path/bg_blue_1.png") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(19, 67, 92, 0.37) !important;\n}\n/*contact data icons styles*/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(76, 125, 150, 0.53);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #7DCDFF !important; \ntext-shadow: -1px 1px 2px #000 !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: -1px 1px 2px #000 !important;\nborder-bottom: none !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgba(136, 179, 202, 1);\nbackground-color: rgba(197, 215, 224, 0.9);\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}|628~',
                                                'Blue Template 3' => '587~#ffffff|588~13|131~ccf-googlewebfont-Antic|589~1|629~3d-thick-dark|630~3d-thick|627~1|0~#0036bd|130~#0036bd|517~50|518~50|1~#001445|2~1|3~solid|4~10|5~10|6~10|7~10|8~#001445|9~inset|10~0|11~0|12~49|13~10|14~#001445|15~inset|16~0|17~0|18~50|19~15|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~10|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~5|616~15|617~0|618~#ffffff|619~#ffffff|620~5|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#ffffff|21~30|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~2|190~6|191~-2|192~90|502~left|193~3|194~1|195~#ffffff|196~dotted|197~#ffffff|198~13|199~normal|200~italic|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~2|205~1|206~1|215~0|216~0|217~1|218~3|31~#ffffff|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#000000|38~2|39~1|40~1|41~#ff0000|42~18|43~bold|44~normal|509~inherit|46~#000000|47~2|48~1|49~1|505~dark-midnight-blue|508~inherit|132~#8389fc|133~#ffffff|168~63|519~85|520~90|500~left|501~left|134~#b6c9f5|135~1|136~solid|137~7|138~7|139~7|140~7|141~#89a100|142~inset|143~0|144~0|145~0|146~0|147~#000000|148~13|149~normal|150~normal|151~none|152~inherit|153~#0036bd|154~0|155~0|156~0|157~#ebebeb|158~#ffffff|159~#1c1c1c|160~#949494|161~#424242|162~#ffffff|163~inset|164~0|165~0|166~10|167~0|513~ccf_font_effect_none|176~#ff0022|177~#380000|178~#52000b|179~#ffffff|180~#000000|181~0|182~0|183~0|184~#000000|185~inset|186~1|187~1|188~10|189~0|171~#f70021|514~ccf_font_effect_none|172~#000000|173~2|174~1|175~1|169~93|521~85|522~90|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#002582|542~#001f66|543~1|544~1|545~1|546~1|547~solid|548~#0e3c9e|549~#0d2c75|550~#003cc7|551~#0d2c75|524~#fafafa|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~-1|533~1|534~2|91~#e30000|50~#330000|212~right|92~6|93~25|209~93|100~#780000|101~1|127~solid|102~7|103~7|104~7|105~7|94~#000899|95~|96~0|97~0|98~16|99~4|106~#ffffff|107~14|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#000000|114~1|115~-1|116~1|51~#b80404|52~#1f0000|124~#fafafa|516~ccf_font_effect_none|125~#000000|126~#780000|117~#000899|118~|119~0|120~0|121~18|122~7|552~4|553~#ededed|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#000000|559~1|560~1|561~2|563~10|562~1|597~10|598~30|564~#8fbeff|565~bold|566~normal|594~none|567~0|568~dotted|569~#ffffff|570~#000000|571~1|572~1|573~1|574~#ff476c|595~underline|575~#b50000|576~#000000|577~-1|578~-1|579~1|580~#00d600|581~normal|582~italic|593~none|583~#000000|584~1|585~1|586~1|599~/*contact data icons styles*/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(9, 36, 105, 0.51);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #46A7E2 !important; \ntext-shadow: -1px 1px 2px #000 !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: -1px 1px 2px #000 !important;\nborder-bottom: none !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgb(26, 26, 26);\nbackground-color: rgba(46, 64, 105, 1);\ncolor: #ddd;\ntext-shadow: -1px 2px 2px #000;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar h1 {\ncolor: #fff;\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.08);\nborder-top: 1px solid rgba(0,0,0,0.7);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #c2c2c2;\nbackground: rgba(28, 46, 87, 1);\n}|628~',
                                                'Green Template 1' => '587~#052b1e|588~13|131~ccf-googlewebfont-Cuprum|589~1|629~3d-thick-dark|630~3d-thick-dark|627~0|0~#114159|130~#ffffff|517~50|518~50|1~#063629|2~1|3~solid|4~12|5~12|6~12|7~12|8~#ffffff|9~|10~0|11~0|12~0|13~0|14~#021f16|15~|16~0|17~0|18~5|19~0|600~1|601~#15614b|602~#063326|603~10|604~15|605~10|606~15|607~1|608~solid|609~#ffffff|610~1|611~#d4e6d4|612~#9bc7a4|613~25|614~15|615~15|616~15|617~1|618~#15614b|619~#063326|620~10|621~21|622~12|623~15|624~1|625~solid|626~#c3e0d8|20~#ffffff|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~4|190~3|191~0|192~82|502~left|193~3|194~1|195~#f5f5f5|196~dotted|197~#f5f5f5|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~0|205~0|206~0|215~0|216~0|217~1|218~3|31~#000f0a|32~14|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#cfe6df|38~1|39~1|40~10|41~#b30000|42~20|43~normal|44~normal|509~inherit|46~#dbdbdb|47~0|48~0|49~15|505~forest-green|508~inherit|132~#ffffff|133~#ffffff|168~60|519~85|520~90|500~left|501~left|134~#063629|135~1|136~solid|137~0|138~0|139~0|140~0|141~#063629|142~|143~0|144~0|145~0|146~0|147~#063b2d|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#02241a|160~#ffffff|161~#063629|162~#063629|163~|164~0|165~0|166~12|167~0|513~ccf_font_effect_none|176~#ffffff|177~#ffffff|178~#b32424|179~#9e0808|180~#ffffff|181~-1|182~1|183~1|184~#944141|185~|186~0|187~0|188~9|189~0|171~#8c0000|514~ccf_font_effect_none|172~#ffffff|173~0|174~0|175~10|169~93|521~85|522~90|170~150|523~167|535~10|536~15|537~10|538~12|539~15|540~15|541~#999999|542~#5c5c5c|543~1|544~1|545~1|546~1|547~solid|548~#74a89b|549~#6aad9c|550~#569e8b|551~#6aad9c|524~#ffffff|525~16|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#03241b|532~-1|533~-1|534~1|91~#ffffff|50~#6b9e90|212~right|92~10|93~20|209~99|100~#063629|101~1|127~solid|102~12|103~12|104~12|105~12|94~#27705b|95~|96~0|97~0|98~4|99~0|106~#063629|107~15|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#6b9e90|124~#042e22|516~ccf_font_effect_none|125~#ffffff|126~#043326|117~#033325|118~|119~0|120~0|121~7|122~1|552~4|553~#093828|554~15|555~normal|556~normal|596~none|590~0|591~dotted|592~#ffffff|558~#97b8ad|559~0|560~0|561~0|563~25|562~5|597~10|598~30|564~#0a4a35|565~bold|566~normal|594~none|567~1|568~dotted|569~#00354d|570~#90bdae|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#f5dcdf|577~0|578~0|579~0|580~#085c12|581~bold|582~italic|593~none|583~#cccccc|584~0|585~0|586~0|599~.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(11, 66, 50, 0.33) !important\n}\n.creative_form_FORM_ID.creativecontactform_wrapper {\nbackground-color: transparent !important;\n}\n\n/*contact data icons styles*/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(11, 77, 58, 0.42);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #3AC037 !important; \ntext-shadow: -1px 1px 2px #000 !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: -1px 1px 2px #000 !important;\nborder-bottom: none !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgba(117, 173, 127, 1);\nbackground-color: rgba(198, 223, 203, 1);\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}|628~',
                                                'Green Template 2' => '587~#052b1e|588~13|131~ccf-googlewebfont-Exo|589~1|629~inset-2-dark|630~inset-2-dark|627~0|0~#114159|130~#ffffff|517~50|518~50|1~#063629|2~1|3~solid|4~12|5~12|6~12|7~12|8~#ffffff|9~|10~0|11~0|12~0|13~0|14~#021f16|15~|16~0|17~0|18~5|19~0|600~1|601~#15614b|602~#063326|603~10|604~15|605~10|606~15|607~1|608~solid|609~#b3dbd0|610~0|611~#ffffff|612~#f0f0f0|613~25|614~15|615~15|616~15|617~1|618~#15614b|619~#063326|620~10|621~21|622~12|623~15|624~1|625~solid|626~#88bdae|20~#ffffff|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~4|190~3|191~0|192~82|502~left|193~3|194~1|195~#f5f5f5|196~dotted|197~#f5f5f5|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~-1|205~1|206~1|215~0|216~0|217~1|218~3|31~#000f0a|32~14|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#caebe3|38~1|39~1|40~1|41~#b30000|42~20|43~normal|44~normal|509~inherit|46~#dbdbdb|47~0|48~0|49~15|505~forest-green|508~inherit|132~#ffffff|133~#ffffff|168~60|519~85|520~90|500~left|501~left|134~#063629|135~1|136~solid|137~0|138~0|139~0|140~0|141~#063629|142~|143~0|144~0|145~0|146~0|147~#063b2d|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#02241a|160~#ffffff|161~#063629|162~#063629|163~|164~0|165~0|166~12|167~0|513~ccf_font_effect_none|176~#ffffff|177~#ffffff|178~#b32424|179~#9e0808|180~#ffffff|181~-1|182~1|183~1|184~#944141|185~|186~0|187~0|188~9|189~0|171~#8c0000|514~ccf_font_effect_none|172~#ffffff|173~0|174~0|175~10|169~93|521~85|522~90|170~150|523~167|535~10|536~15|537~10|538~12|539~15|540~15|541~#999999|542~#5c5c5c|543~1|544~1|545~1|546~1|547~solid|548~#4d8577|549~#427a6c|550~#438071|551~#427a6c|524~#ffffff|525~16|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~-1|533~-1|534~1|91~#ffffff|50~#6b9e90|212~right|92~10|93~20|209~99|100~#063629|101~1|127~solid|102~12|103~12|104~12|105~12|94~#27705b|95~|96~0|97~0|98~4|99~0|106~#063629|107~15|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#6b9e90|124~#042e22|516~ccf_font_effect_none|125~#ffffff|126~#043326|117~#033325|118~|119~0|120~0|121~7|122~1|552~4|553~#0b3d2c|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#ffffff|558~#38705d|559~0|560~0|561~0|563~26|562~5|597~10|598~30|564~#0a4a35|565~bold|566~normal|594~none|567~1|568~dotted|569~#00354d|570~#90bdae|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#f5dcdf|577~0|578~0|579~0|580~#085c12|581~bold|582~italic|593~none|583~#cccccc|584~0|585~0|586~0|599~.creative_form_FORM_ID .creativecontactform_body {\nbackground-image: url("ccf_img_path/bg_green_1.png") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(11, 66, 50, 0.33) !important\n}\n.creative_form_FORM_ID.creativecontactform_wrapper {\nbackground-color: transparent !important;\n}\n\n/*contact data icons styles*/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(49, 110, 97, 0.46);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n\n\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #48BA99 !important; \ntext-shadow: -1px 1px 2px #000 !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: -1px 1px 2px #000 !important;\nborder-bottom: none !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgba(87, 150, 132, 1);\nbackground-color: rgba(176, 205, 198, 0.8);\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}|628~',
                                                'Green Template 3' => '587~#000000|588~13|131~\"Comic Sans MS\", cursive, sans-serif|589~1|629~inset-2-dark|630~rounded-dots-dark|627~1|0~#a7de00|130~#76a101|517~50|518~50|1~#2b2b2b|2~0|3~solid|4~8|5~8|6~8|7~8|8~#688a00|9~|10~0|11~0|12~11|13~2|14~#000000|15~|16~0|17~0|18~10|19~1|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~10|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~5|616~15|617~0|618~#ffffff|619~#ffffff|620~5|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#ffffff|21~24|22~bold|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#2f3600|28~1|29~1|30~3|190~6|191~-2|192~90|502~left|193~3|194~1|195~#ffffff|196~dotted|197~#fafafa|198~13|199~normal|200~italic|201~none|202~inherit|511~ccf_font_effect_none|203~#1f2400|204~-1|205~1|206~1|215~0|216~0|217~4|218~0|31~#ffffff|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#749d0b|38~1|39~1|40~1|41~#aa00cc|42~16|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~bright-lavender|508~inherit|132~#c5ea0e|133~#c5ea0e|168~60|519~85|520~90|500~left|501~left|134~#4a8a00|135~1|136~solid|137~4|138~4|139~4|140~4|141~#618208|142~inset|143~6|144~6|145~18|146~0|147~#303e18|148~14|149~normal|150~normal|151~none|152~inherit|153~#fc0a0a|154~0|155~0|156~0|157~#c5ea0e|158~#e0ff30|159~#151c09|160~#ff0000|161~#9fbd07|162~#749d0b|163~|164~0|165~0|166~20|167~4|513~ccf_font_effect_none|176~#b361ff|177~#5a0073|178~#450085|179~#ffffff|180~#000000|181~0|182~0|183~0|184~#6e008a|185~inset|186~0|187~0|188~18|189~0|171~#9100bd|514~ccf_font_effect_none|172~#000000|173~0|174~0|175~0|169~95|521~85|522~90|170~150|523~130|535~8|536~15|537~11|538~12|539~15|540~15|541~#7a9e16|542~#77990f|543~0|544~0|545~0|546~0|547~dotted|548~#b8b8b8|549~#b8b8b8|550~#b8b8b8|551~#b8b8b8|524~#ffffff|525~14|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#050005|532~1|533~1|534~2|91~#a5d211|50~#407002|212~right|92~6|93~25|209~95|100~#3f7000|101~1|127~solid|102~11|103~11|104~11|105~11|94~#ffffff|95~inset|96~3|97~3|98~18|99~-3|106~#ffffff|107~14|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#427007|114~1|115~-1|116~1|51~#79d107|52~#233d00|124~#fafafa|516~ccf_font_effect_none|125~#3e6e00|126~#355e00|117~#ffffff|118~|119~-2|120~-2|121~12|122~-2|552~4|553~#ffffff|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#050005|559~1|560~1|561~5|563~27|562~8|597~10|598~30|564~#0055cc|565~bold|566~normal|594~none|567~0|568~dotted|569~#ffffff|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~underline|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#000500|581~normal|582~italic|593~none|583~#8a8a8a|584~0|585~0|586~0|599~/*contact data icons styles*/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(118, 158, 0, 1);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgba(177, 213, 75, 1);\nbackground-color: rgba(150, 189, 40, 1);\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(217, 234, 168, 1);\n}|628~',
                                                'Yellow Template 1' => '587~#000819|588~13|131~ccf-googlewebfont-Actor|589~1|629~inset-2-dark|630~rounded-dots-dark|627~0|0~#3d3d3d|130~#333333|517~50|518~50|1~#707070|2~1|3~solid|4~0|5~0|6~0|7~0|8~#ffffff|9~|10~0|11~0|12~1|13~0|14~#000000|15~|16~0|17~0|18~3|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~5|608~solid|609~#000000|610~1|611~#ffffff|612~#f0f0f0|613~25|614~15|615~15|616~15|617~0|618~#ffffff|619~#ffffff|620~15|621~21|622~20|623~15|624~3|625~solid|626~#000000|20~#ffffff|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~4|190~3|191~0|192~82|502~left|193~3|194~1|195~#a8a8a8|196~dotted|197~#dbdbdb|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~0|205~0|206~0|215~0|216~0|217~1|218~3|31~#000000|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#ffffff|38~2|39~1|40~1|41~#d40808|42~22|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~black|508~inherit|132~#ffffff|133~#ffffff|168~60|519~85|520~90|500~left|501~left|134~#8a8a8a|135~1|136~solid|137~0|138~0|139~0|140~0|141~#000819|142~inset|143~0|144~0|145~0|146~0|147~#000819|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#000819|160~#ffffff|161~#8a8a8a|162~#878787|163~inset|164~0|165~0|166~10|167~0|513~ccf_font_effect_none|176~#ffdbdd|177~#ffdbdd|178~#f27777|179~#000819|180~#ffffff|181~-1|182~1|183~1|184~#ebaaaa|185~inset|186~0|187~0|188~18|189~0|171~#b30000|514~ccf_font_effect_none|172~#ffffff|173~2|174~1|175~1|169~93|521~85|522~90|170~150|523~167|535~10|536~15|537~10|538~12|539~15|540~15|541~#999999|542~#5c5c5c|543~1|544~1|545~1|546~1|547~solid|548~#8a8a8a|549~#757575|550~#858585|551~#757575|524~#ffffff|525~16|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~-1|533~-1|534~1|91~#ffffff|50~#b0b0b0|212~right|92~10|93~20|209~99|100~#000819|101~1|127~solid|102~12|103~12|104~12|105~12|94~#696969|95~|96~0|97~0|98~4|99~0|106~#000819|107~15|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#8f8f8f|124~#000819|516~ccf_font_effect_none|125~#ffffff|126~#000000|117~#9c9fa6|118~|119~0|120~0|121~7|122~1|552~2|553~#000000|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#ffffff|558~#ffffff|559~0|560~0|561~0|563~2|562~2|597~10|598~30|564~#003bb0|565~bold|566~normal|594~none|567~1|568~dotted|569~#ffffff|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#008f00|581~normal|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~.creative_form_FORM_ID .creativecontactform_header {\nbackground-image: url("ccf_img_path/bg_header.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\n}\n.creative_form_FORM_ID .creativecontactform_footer {\nbackground-image: url("ccf_img_path/bg_footer.png") !important;\nbackground-repeat: repeat-x !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_body {\nbackground-image: url("ccf_img_path/bg_yellow_1.png") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(0, 0, 0, 0.3) !important;\n}\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #689AFF !important; \ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: rgba(168, 166, 141, 0.45);\ncolor: #333;\nborder-radius: 12px;\nborder: 1px solid rgb(181, 173, 131);\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255, 255, 255, 0.53);\n}\n|628~',
                                                'Yellow Template 2' => '587~#000819|588~13|131~ccf-googlewebfont-Actor|589~1|629~dark-thin|630~dark-thin|627~0|0~#3d3d3d|130~#333333|517~50|518~50|1~#707070|2~1|3~solid|4~0|5~0|6~0|7~0|8~#ffffff|9~|10~0|11~0|12~1|13~0|14~#000000|15~|16~0|17~0|18~3|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~5|608~solid|609~#000000|610~1|611~#ffffff|612~#f0f0f0|613~25|614~15|615~15|616~15|617~0|618~#ffffff|619~#ffffff|620~15|621~21|622~20|623~15|624~3|625~solid|626~#000000|20~#ffffff|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~4|190~3|191~0|192~82|502~left|193~3|194~1|195~#a8a8a8|196~dotted|197~#dbdbdb|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~0|205~0|206~0|215~0|216~0|217~1|218~3|31~#453300|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#e2c574|38~2|39~1|40~1|41~#d40808|42~22|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~black|508~inherit|132~#fff6e0|133~#f5dc96|168~60|519~85|520~90|500~left|501~left|134~#8a6f26|135~1|136~solid|137~0|138~0|139~0|140~0|141~#000819|142~|143~0|144~0|145~0|146~0|147~#3b2d05|148~14|149~normal|150~normal|151~none|152~inherit|153~#e2c574|154~0|155~0|156~0|157~#fff6e0|158~#f5dc96|159~#3b2d05|160~#ffffff|161~#8a6f26|162~#7a5c16|163~|164~0|165~0|166~5|167~1|513~ccf_font_effect_none|176~#ffffff|177~#f7f7f7|178~#b80000|179~#b80000|180~#ffffff|181~-1|182~1|183~1|184~#ffffff|185~inset|186~0|187~0|188~0|189~0|171~#a60000|514~ccf_font_effect_none|172~#ebd28d|173~2|174~1|175~1|169~93|521~85|522~90|170~150|523~167|535~10|536~15|537~10|538~12|539~15|540~15|541~#999999|542~#5c5c5c|543~1|544~1|545~1|546~1|547~solid|548~#bda15e|549~#bda15e|550~#bda15e|551~#bda15e|524~#faf0dc|525~16|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#291d00|532~-1|533~-1|534~1|91~#ffffff|50~#c7ba9b|212~right|92~10|93~20|209~99|100~#80611a|101~1|127~solid|102~12|103~12|104~12|105~12|94~#696969|95~|96~0|97~0|98~4|99~0|106~#402f08|107~15|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#c7ba9b|124~#261b02|516~ccf_font_effect_none|125~#ffffff|126~#4d380b|117~#e3d1ad|118~|119~0|120~0|121~7|122~1|552~4|553~#453300|554~14|555~bold|556~normal|596~none|590~0|591~dotted|592~#ffffff|558~#e2c574|559~0|560~0|561~0|563~7|562~1|597~10|598~30|564~#4a3500|565~bold|566~normal|594~none|567~1|568~dotted|569~#4a3500|570~#e2c574|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#e2c574|577~0|578~0|579~0|580~#004500|581~bold|582~italic|593~none|583~#e2c574|584~0|585~0|586~0|599~.creative_form_FORM_ID .creativecontactform_header {\nbackground-image: url("ccf_img_path/bg_header.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\n}\n.creative_form_FORM_ID .creativecontactform_footer {\nbackground-image: url("ccf_img_path/bg_footer.png") !important;\nbackground-repeat: repeat-x !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_body {\nbackground-image: url("ccf_img_path/bg_yellow_2.png") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(0, 0, 0, 0.3) !important;\n}\n\n/*contact data icons styles*/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: #997629;\nborder-radius: 100%\n}\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #689AFF !important; \ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: rgba(202, 164, 62, 0.73);\ncolor: #333;\nborder-radius: 12px;\nborder: 1px solid rgb(153, 126, 48);\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255, 255, 255, 0.53);\n}\n\n|628~',
                                                'Orange Template 1' => '587~#111111|588~13|131~ccf-googlewebfont-Karma|589~1|629~inset-dark|630~inset-dark|627~1|0~#fca000|130~#ff9900|517~50|518~50|1~#cc4100|2~1|3~solid|4~10|5~10|6~10|7~10|8~#cc4100|9~inset|10~10|11~10|12~45|13~2|14~#cc4100|15~inset|16~12|17~12|18~50|19~6|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~5|616~15|617~0|618~#ffffff|619~#ffffff|620~5|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#ffffff|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~-1|29~-1|30~2|190~-1|191~-2|192~90|502~left|193~5|194~1|195~#ffffff|196~dotted|197~#000000|198~13|199~normal|200~italic|201~none|202~inherit|511~ccf_font_effect_none|203~#ffd500|204~0|205~0|206~1|215~0|216~0|217~1|218~3|31~#000000|32~14|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#ffd500|38~0|39~0|40~1|41~#d9001d|42~18|43~bold|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~sunset|508~inherit|132~#b0b0b0|133~#ffffff|168~63|519~85|520~90|500~left|501~left|134~#ffffff|135~1|136~solid|137~7|138~7|139~7|140~7|141~#262524|142~inset|143~0|144~0|145~25|146~-2|147~#000000|148~14|149~normal|150~normal|151~none|152~inherit|153~#fafafa|154~0|155~0|156~0|157~#ebebeb|158~#ffffff|159~#1c1c1c|160~#949494|161~#424242|162~#ffffff|163~inset|164~0|165~0|166~10|167~0|513~ccf_font_effect_none|176~#b5b5b5|177~#616161|178~#000000|179~#ffffff|180~#000000|181~0|182~0|183~0|184~#1f1f1f|185~inset|186~8|187~10|188~27|189~1|171~#c40a0a|514~ccf_font_effect_none|172~#000000|173~0|174~0|175~0|169~93|521~85|522~90|170~150|523~130|535~10|536~15|537~7|538~12|539~15|540~15|541~#c77920|542~#bf792a|543~0|544~0|545~0|546~0|547~dotted|548~#b8b8b8|549~#b8b8b8|550~#b8b8b8|551~#b8b8b8|524~#ffffff|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#0f0f0f|532~-1|533~-1|534~2|91~#ff0000|50~#630000|212~right|92~6|93~25|209~93|100~#610000|101~1|127~solid|102~7|103~7|104~7|105~7|94~#300000|95~inset|96~0|97~0|98~0|99~0|106~#ffffff|107~14|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#000000|114~1|115~-1|116~1|51~#ff0000|52~#520000|124~#fafafa|516~ccf_font_effect_none|125~#000000|126~#610000|117~#300000|118~inset|119~2|120~3|121~9|122~-2|552~4|553~#3d3d3d|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#000000|559~0|560~0|561~0|563~2|562~1|597~10|598~30|564~#006aff|565~bold|566~normal|594~none|567~0|568~dotted|569~#ffffff|570~#f7f7f7|571~1|572~1|573~3|574~#ffffff|595~underline|575~#b50000|576~#050005|577~1|578~1|579~2|580~#008f00|581~normal|582~italic|593~none|583~#ffffff|584~1|585~1|586~2|599~/*contact data icons styles*/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(184, 113, 0, 1);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: rgba(221, 164, 75, 1);\ncolor: #333;\nborder-radius: 12px;\nborder: 1px solid rgb(152, 92, 0);\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255, 255, 255, 0.53);\n}\n|628~',
                                                'Red Template 1' => '587~#ffffff|588~12|131~ccf-googlewebfont-Dosis|589~2|629~inset-2-dark|630~inset-2|627~1|0~#b0000f|130~#700009|517~50|518~50|1~#470006|2~1|3~solid|4~10|5~10|6~10|7~10|8~#470006|9~inset|10~0|11~0|12~49|13~10|14~#470006|15~inset|16~0|17~0|18~50|19~15|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~5|616~15|617~0|618~#ffffff|619~#ffffff|620~5|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#ffffff|21~30|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~2|190~6|191~-2|192~90|502~left|193~3|194~1|195~#ffffff|196~dotted|197~#ffffff|198~14|199~normal|200~italic|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~2|205~1|206~1|215~0|216~0|217~1|218~3|31~#ffffff|32~14|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#000000|38~2|39~1|40~1|41~#ffffff|42~18|43~bold|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~black|508~inherit|132~#ffffff|133~#ffffff|168~63|519~85|520~90|500~left|501~left|134~#540000|135~1|136~solid|137~7|138~7|139~7|140~7|141~#000000|142~inset|143~0|144~0|145~25|146~1|147~#000000|148~13|149~normal|150~normal|151~none|152~inherit|153~#fafafa|154~0|155~0|156~0|157~#ebebeb|158~#ffffff|159~#1c1c1c|160~#949494|161~#424242|162~#ffffff|163~inset|164~0|165~0|166~10|167~0|513~ccf_font_effect_none|176~#7a7a7a|177~#030303|178~#000000|179~#ffffff|180~#000000|181~0|182~0|183~0|184~#1f1f1f|185~inset|186~8|187~10|188~27|189~2|171~#f7ff05|514~ccf_font_effect_none|172~#000000|173~0|174~0|175~0|169~93|521~85|522~90|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#d64655|542~#e08f97|543~0|544~0|545~0|546~0|547~dotted|548~#b8b8b8|549~#b8b8b8|550~#b8b8b8|551~#b8b8b8|524~#141414|525~14|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#6b6b6b|532~0|533~0|534~0|91~#4f4f4f|50~#000000|212~right|92~10|93~25|209~93|100~#2e0606|101~1|127~solid|102~7|103~7|104~7|105~7|94~#a10000|95~|96~0|97~0|98~16|99~4|106~#ffffff|107~14|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#000000|114~1|115~-1|116~1|51~#424242|52~#000000|124~#fafafa|516~ccf_font_effect_none|125~#000000|126~#2e0606|117~#a10000|118~|119~0|120~0|121~18|122~7|552~4|553~#ffffff|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#000000|559~-1|560~-1|561~1|563~22|562~6|597~10|598~30|564~#ffffff|565~bold|566~normal|594~none|567~1|568~dashed|569~#ffffff|570~#000000|571~0|572~0|573~0|574~#bdbdbd|595~none|575~#a3a3a3|576~#000000|577~1|578~1|579~2|580~#97a8fc|581~normal|582~italic|593~none|583~#000000|584~1|585~1|586~2|599~/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgb(42, 0, 3);\nbackground-color: rgba(18, 18, 18, 0.5);\ncolor: #ddd;\ntext-shadow: -1px 2px 2px #000;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar h1 {\ncolor: #fff;\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.08);\nborder-top: 1px solid rgba(0,0,0,0.7);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #c2c2c2;\nbackground:rgba(119, 119, 119, 0.2);\n}\n|628~',
                                                'Wood Template 1' => '587~#000819|588~13|131~ccf-googlewebfont-Dosis|589~1|629~dark-thin|630~rounded-dark|627~0|0~#383838|130~#212121|517~50|518~50|1~#9e857d|2~1|3~solid|4~0|5~0|6~0|7~0|8~#ffffff|9~|10~0|11~0|12~1|13~0|14~#301300|15~|16~0|17~0|18~3|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~3|608~solid|609~#382e2b|610~1|611~#ffffff|612~#f0f0f0|613~25|614~15|615~15|616~15|617~0|618~#ffffff|619~#ffffff|620~15|621~21|622~20|623~15|624~3|625~solid|626~#474747|20~#ffffff|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~2|29~1|30~4|190~3|191~0|192~82|502~left|193~3|194~1|195~#a8a8a8|196~dotted|197~#ffffff|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~0|205~0|206~0|215~0|216~0|217~1|218~3|31~#4a1e00|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#000000|38~0|39~0|40~0|41~#d40808|42~22|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~black|508~inherit|132~#ffffff|133~#ffffff|168~60|519~85|520~90|500~left|501~left|134~#805a3d|135~1|136~solid|137~0|138~0|139~0|140~0|141~#000819|142~|143~0|144~0|145~0|146~0|147~#4d2000|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#2b1201|160~#ffffff|161~#805a3d|162~#6b4327|163~|164~0|165~0|166~10|167~0|513~ccf_font_effect_none|176~#f0f0f0|177~#ffffff|178~#bd5757|179~#ab0000|180~#ffffff|181~-1|182~1|183~1|184~#3d0000|185~|186~0|187~0|188~9|189~-1|171~#940000|514~ccf_font_effect_none|172~#000000|173~0|174~0|175~0|169~95|521~85|522~90|170~150|523~167|535~7|536~15|537~8|538~12|539~15|540~15|541~#545454|542~#919191|543~1|544~1|545~1|546~1|547~solid|548~#858585|549~#807d80|550~#7a7a7a|551~#807d80|524~#faf5fa|525~16|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#050005|532~1|533~1|534~2|91~#ffffff|50~#999999|212~right|92~10|93~20|209~99|100~#000819|101~1|127~solid|102~12|103~12|104~12|105~12|94~#696969|95~|96~0|97~0|98~4|99~0|106~#000819|107~15|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~3|51~#ffffff|52~#8f8f8f|124~#000819|516~ccf_font_effect_none|125~#ffffff|126~#000000|117~#9c9fa6|118~|119~0|120~0|121~7|122~1|552~4|553~#4a1e00|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#ffffff|558~#000000|559~0|560~0|561~0|563~3|562~2|597~10|598~30|564~#003596|565~bold|566~normal|594~none|567~1|568~dotted|569~#000000|570~#808080|571~0|572~0|573~0|574~#d4002a|595~none|575~#b50000|576~#c2c2c2|577~0|578~0|579~0|580~#006e00|581~normal|582~italic|593~none|583~#787878|584~0|585~0|586~0|599~.creative_form_FORM_ID .creativecontactform_header {\nbackground-image: url("ccf_img_path/bg_header.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\n}\n.creative_form_FORM_ID .creativecontactform_footer {\nbackground-image: url("ccf_img_path/bg_footer.png") !important;\nbackground-repeat: repeat-x !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_body {\nbackground-image: url("ccf_img_path/bg_wood_1.png") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\n}\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(32, 17, 0, 0.35) !important;\n}\n/*contact data icons styles*/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(186, 169, 145, 1);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n}\n/*header link**********************************************/\n.creative_form_FORM_ID .creativecontactform_header a {\ncolor: #689AFF !important; \ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n.creative_form_FORM_ID .creativecontactform_header a:hover{\ncolor: #D31E1E !important;\ntext-shadow: none !important;\nborder-bottom: none !important;\n}\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nborder: 1px solid rgb(153, 136, 112);\nbackground-color: rgba(116, 88, 50, 0.32);\ncolor: #000;\ntext-shadow: none;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar h1 {\ncolor: #1F1F1F;\ntext-shadow: -1px 2px 2px #E5E0D9;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.08);\nborder-top: 1px solid rgba(0,0,0,0.7);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #000000;\nbackground: rgba(40, 40, 40, 0.19);\n}\n\n|628~',
                                                'White-Pink Template' => '587~#4d4d4d|588~14|131~ccf-googlewebfont-Abel|589~1|629~rounded-dots-dark|630~rounded-dots-dark|627~1|0~#ffffff|130~#ffffff|517~50|518~50|1~#c7c7c7|2~1|3~solid|4~20|5~20|6~20|7~20|8~#ffffff|9~|10~0|11~0|12~0|13~0|14~#292929|15~|16~0|17~0|18~1|19~0|600~1|601~#f5f5f5|602~#f5f5f5|603~15|604~15|605~15|606~15|607~2|608~solid|609~#cc8acc|610~1|611~#ffffff|612~#ffffff|613~25|614~15|615~15|616~15|617~1|618~#cc8acc|619~#cc8acc|620~15|621~20|622~20|623~15|624~1|625~solid|626~#cc8acc|20~#945f94|21~28|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~0|29~0|30~0|190~3|191~0|192~82|502~left|193~4|194~1|195~#2e2e2e|196~dotted|197~#454545|198~13|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~0|205~0|206~0|215~0|216~0|217~3|218~0|31~#000819|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#ffffff|38~0|39~0|40~0|41~#d4c308|42~20|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~white|508~inherit|132~#ffffff|133~#ffffff|168~60|519~85|520~90|500~left|501~left|134~#8a8a8a|135~1|136~solid|137~15|138~15|139~15|140~15|141~#000819|142~inset|143~0|144~0|145~0|146~0|147~#030405|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#f0f0f0|158~#f0f0f0|159~#0d0d0d|160~#ffffff|161~#8a8a8a|162~#f0f0f0|163~inset|164~0|165~0|166~4|167~1|513~ccf_font_effect_none|176~#ffffff|177~#ffffff|178~#bf50bf|179~#000000|180~#ffffff|181~0|182~0|183~0|184~#ffffff|185~inset|186~0|187~0|188~18|189~0|171~#b054b0|514~ccf_font_effect_none|172~#8c358c|173~0|174~0|175~0|169~95|521~85|522~90|170~150|523~167|535~10|536~15|537~10|538~10|539~15|540~15|541~#cc8acc|542~#cc8acc|543~1|544~1|545~1|546~1|547~solid|548~#bf7abf|549~#bf7abf|550~#bf7abf|551~#bf7abf|524~#ffffff|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#ffffff|532~0|533~0|534~0|91~#cc8acc|50~#cc8acc|212~right|92~3|93~50|209~100|100~#ffffff|101~2|127~solid|102~13|103~13|104~13|105~13|94~#001338|95~|96~0|97~0|98~0|99~0|106~#ffffff|107~15|108~normal|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~0|115~0|116~0|51~#a850a8|52~#a850a8|124~#ffffff|516~ccf_font_effect_none|125~#ffffff|126~#ffffff|117~#993b99|118~|119~0|120~0|121~5|122~1|552~1|553~#000000|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#ffffff|558~#ffffff|559~0|560~0|561~0|563~4|562~1|597~3|598~30|564~#a35ba3|565~bold|566~normal|594~none|567~1|568~dotted|569~#a35ba3|570~#ffffff|571~0|572~0|573~0|574~#000000|595~none|575~#945f94|576~#ffffff|577~0|578~0|579~0|580~#945f94|581~normal|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: #ddd;\ncolor: #333;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(0,0,0,0.2);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #666;\nbackground: #fff;\nbackground: rgba(255,255,255,0.8);\n}|628~',
                                                'Sky Template' => '587~#00618e|588~13|131~ccf-googlewebfont-Signika|589~1|629~rounded-dots-dark|630~rounded-dots-dark|627~1|0~#ffffff|130~#ffffff|517~50|518~50|1~#75b8ff|2~1|3~solid|4~15|5~15|6~15|7~15|8~#b8e9ff|9~|10~0|11~0|12~3|13~1|14~#00537a|15~|16~0|17~0|18~5|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~0|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#ffffff|21~31|22~normal|23~normal|24~none|25~left|506~inherit|510~ccf_font_effect_none|27~#000000|28~0|29~0|30~5|190~3|191~0|192~82|502~left|193~7|194~1|195~#319bcc|196~dotted|197~#00618e|198~14|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#ffffff|204~0|205~0|206~3|215~0|216~0|217~1|218~3|31~#00618e|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#00618e|38~0|39~0|40~0|41~#b80000|42~14|43~normal|44~normal|509~inherit|46~#ffffff|47~0|48~0|49~0|505~sky-blue|508~inherit|132~#ffffff|133~#ffffff|168~60|519~90|520~90|500~left|501~left|134~#5ebbd7|135~1|136~solid|137~9|138~9|139~9|140~9|141~#00537a|142~|143~0|144~0|145~10|146~-3|147~#00537a|148~14|149~normal|150~normal|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#00537a|160~#ffffff|161~#5ebbd7|162~#00537a|163~|164~0|165~0|166~15|167~-1|513~ccf_font_effect_none|176~#ffffff|177~#ffffff|178~#5ebbd7|179~#940000|180~#ffffff|181~0|182~0|183~0|184~#00537a|185~|186~0|187~0|188~19|189~-2|171~#940000|514~ccf_font_effect_none|172~#ffffff|173~2|174~1|175~1|169~95|521~90|522~90|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#f4f6f7|542~#f4f6f7|543~1|544~1|545~1|546~1|547~solid|548~#70b4d4|549~#5a9ebd|550~#5a9ebd|551~#5a9ebd|524~#00618e|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#ffffff|532~0|533~0|534~2|91~#ffffff|50~#65c1eb|212~right|92~8|93~27|209~95|100~#6dc1e8|101~1|127~solid|102~12|103~12|104~12|105~12|94~#00618e|95~|96~0|97~0|98~2|99~0|106~#187ead|107~14|108~bold|109~normal|110~none|112~inherit|515~ccf_font_effect_none|113~#ffffff|114~-1|115~1|116~2|51~#ffffff|52~#65c1eb|124~#08648c|516~ccf_font_effect_none|125~#ffffff|126~#6dc1e8|117~#00618e|118~|119~0|120~0|121~15|122~0|552~4|553~#00618e|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#00618e|559~0|560~0|561~0|563~11|562~7|597~10|598~30|564~#00618e|565~bold|566~normal|594~none|567~1|568~dotted|569~#00618e|570~#ffffff|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#007300|581~normal|582~italic|593~none|583~#007300|584~0|585~0|586~0|599~.creative_form_FORM_ID.creativecontactform_wrapper {\nbackground-image: url("ccf_img_path/bg_sky.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: 100% 100% !important;\nbackground-color: #D3EFFA !important;\n}\n/*contact data icons styles******************************/\n.creative_form_FORM_ID .ccf_content_icon {\nbackground-color: rgba(39, 148, 192, 0.55);\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 89, 124, 0.59);\n}\n/*Input fields styles***************************************/\n.creative_form_FORM_ID .creativecontactform_input_element{\nbackground:-webkit-linear-gradient(top, rgba(255, 255, 255, 0.2), rgba(252, 252, 252, 0.64)) !important;\nbackground:-moz-linear-gradient(top, rgba(255, 255, 255, 0.2), rgba(252, 252, 252, 0.64)) !important;\nbackground:linear-gradient(top, rgba(255, 255, 255, 0.2), rgba(252, 252, 252, 0.64)) !important\n}\n\n/*Heading styles******************************************/\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(255, 255, 255, 0.33) !important;\n}\n\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: rgba(255, 255, 255, 0.45);\ncolor: #0E608D;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.6);\nborder-top: 1px solid rgba(138, 198, 224, 1);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\nbackground: #fff;\nbackground-color: rgba(255, 255, 255, 0.65);\n}|628~',
                                                'Black-Moon Template' => '587~#cccccc|588~13|131~ccf-googlewebfont-Maven Pro|589~2|629~rounded-dark|630~rounded|627~0|0~#ffffff|130~#ffffff|517~50|518~50|1~#373737|2~1|3~solid|4~0|5~0|6~0|7~0|8~#000000|9~|10~2|11~4|12~5|13~0|14~#000000|15~|16~0|17~0|18~7|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~0|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#ffffff|21~38|22~normal|23~normal|24~none|25~left|506~ccf-googlewebfont-Jura|510~ccf_font_effect_none|27~#000000|28~2|29~2|30~2|190~0|191~0|192~70|502~left|193~5|194~1|195~#bababa|196~dotted|197~#c7c7c7|198~14|199~normal|200~normal|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~2|205~2|206~2|215~0|216~0|217~3|218~3|31~#adadad|32~13|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#000000|38~2|39~1|40~1|41~#ff0000|42~20|43~normal|44~normal|509~inherit|46~#000000|47~2|48~1|49~1|505~black|508~inherit|132~#595959|133~#595959|168~60|519~90|520~90|500~left|501~left|134~#4c4c4c|135~1|136~solid|137~5|138~5|139~5|140~5|141~#f5f5f5|142~|143~0|144~0|145~0|146~0|147~#c7c7c7|148~13|149~normal|150~normal|151~none|152~inherit|153~#000000|154~2|155~1|156~1|157~#ffffff|158~#ededed|159~#dedede|160~#000000|161~#828282|162~#808080|163~|164~0|165~0|166~8|167~1|513~ccf_font_effect_none|176~#ffffff|177~#ffffff|178~#520101|179~#bd0000|180~#000000|181~2|182~2|183~1|184~#6e2a2a|185~|186~0|187~0|188~8|189~1|171~#ba0000|514~ccf_font_effect_none|172~#000000|173~2|174~1|175~1|169~95|521~90|522~90|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#424242|542~#262626|543~1|544~1|545~1|546~1|547~solid|548~#383838|549~#383838|550~#141414|551~#2e2e2e|524~#b0b0b0|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~2|533~1|534~1|91~#262626|50~#0d0d0d|212~right|92~8|93~22|209~93|100~#424142|101~1|127~solid|102~7|103~7|104~7|105~7|94~#525252|95~|96~0|97~0|98~0|99~0|106~#949494|107~15|108~bold|109~normal|110~none|112~ccf-googlewebfont-Jura|515~ccf_font_effect_none|113~#000000|114~2|115~1|116~2|51~#262626|52~#0d0d0d|124~#adadad|516~ccf_font_effect_none|125~#000000|126~#757575|117~#7a7a7a|118~|119~0|120~0|121~5|122~0|552~2|553~#bfbfbf|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#000000|559~2|560~2|561~2|563~2|562~2|597~10|598~30|564~#4c8bff|565~normal|566~normal|594~none|567~1|568~dotted|569~#0a78ff|570~#000000|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#000000|577~0|578~0|579~0|580~#00a800|581~normal|582~italic|593~none|583~#000000|584~2|585~1|586~1|599~/*Wrapper styling******************************************/
                                                .creative_form_FORM_ID.creativecontactform_wrapper {\nbackground-image: url("http://creative-solutions.net/components/com_creativecontactform/assets/images/bg_images/bg_black_moon.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\nborder-top: 1px solid rgba(48, 48, 48, 0.55) !important;\nwebkit-box-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5) !important;\n-moz-box-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5) !important;\nbox-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5 !important);\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creativecontactform_wrapper_inner{\nbackground: transparent url("ccf_img_path/bg_light.png") center 0px no-repeat;\nbackground-size: 100% 100% !important;\n}\n/*Input fields styles***************************************/\n.creative_form_FORM_ID .creativecontactform_input_element{\nbackground: -webkit-linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\nbackground: -moz-linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\nbackground: linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\n}\n/*select field type icon************************************/\n.creative_form_FORM_ID .ccf_select_icon {\nopacity: 0.5;\n}\n/*set creative checkbox opacity*************************/\n.creative_form_FORM_ID a.creativeform_twoglux_styled_element {\nopacity: 0.85;\n}\n/*Heading styles******************************************/\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 0.31) !important;\n}\n/*contact data icons styles******************************/\n.creative_form_FORM_ID .ccf_content_icon {\n/*\nbackground-color: rgba(126, 126, 126, 0.33) !important;\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n*/\n}\n/*popup styles*********************************************/\n.creative_form_FORM_ID.ccf_popup_inner_wrapper  .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 1) !important;\n}\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: rgba(132, 132, 132, 0.25);\ncolor: #ddd;\ntext-shadow: -1px 2px 2px #000;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar h1 {\ncolor: #fff;\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.08);\nborder-top: 1px solid rgba(0,0,0,0.7);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #c2c2c2;\nbackground: rgba(40, 40, 40, 0.77);\n}|628~',
                                                'Neon Template' => '587~#ffffff|588~13|131~ccf-googlewebfont-Cagliostro|589~2|629~inset-2-dark|630~inset-2-dark|627~1|0~#171717|130~#030303|517~50|518~50|1~#750075|2~1|3~solid|4~0|5~0|6~0|7~0|8~#ffffff|9~|10~0|11~0|12~0|13~0|14~#bababa|15~|16~0|17~0|18~7|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~0|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#000000|21~36|22~normal|23~italic|24~none|25~left|506~ccf-googlewebfont-Cherry Swash|510~ccf_font_effect_neon|27~#ffffff|28~2|29~1|30~2|190~0|191~0|192~65|502~left|193~5|194~1|195~#faedfa|196~dotted|197~#ffffff|198~13|199~normal|200~italic|201~none|202~ccf-googlewebfont-Cherry Swash|511~ccf_font_effect_none|203~#3b003b|204~1|205~1|206~4|215~0|216~0|217~1|218~3|31~#ffffff|32~13|33~normal|34~italic|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#000000|38~2|39~1|40~1|41~#cc00ff|42~18|43~normal|44~normal|509~inherit|46~#000000|47~1|48~1|49~0|505~bright-lavender|508~inherit|132~#303030|133~#1f1f1f|168~70|519~90|520~90|500~left|501~left|134~#ffffff|135~1|136~solid|137~0|138~0|139~0|140~0|141~#6e006e|142~|143~0|144~0|145~10|146~0|147~#ffffff|148~14|149~normal|150~italic|151~none|152~inherit|153~#ffffff|154~0|155~0|156~0|157~#ffffff|158~#ffffff|159~#ff9eff|160~#000000|161~#cccccc|162~#000000|163~|164~0|165~0|166~12|167~1|513~ccf_font_effect_none|176~#ffdbdd|177~#ffdbdd|178~#ff9999|179~#ffffff|180~#ffffff|181~0|182~0|183~0|184~#fc0000|185~|186~0|187~0|188~6|189~0|171~#f70505|514~ccf_font_effect_none|172~#000000|173~2|174~1|175~1|169~95|521~90|522~90|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#f4f6f7|542~#f4f6f7|543~1|544~1|545~1|546~1|547~solid|548~#7d007d|549~#5c005c|550~#540054|551~#5c005c|524~#fcfcfc|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~0|533~0|534~0|91~#800080|50~#0a000a|212~right|92~8|93~22|209~95|100~#850085|101~1|127~solid|102~0|103~0|104~0|105~0|94~#525252|95~|96~0|97~0|98~0|99~0|106~#ffffff|107~14|108~bold|109~italic|110~none|112~inherit|515~ccf_font_effect_none|113~#000000|114~0|115~0|116~3|51~#0a000a|52~#800080|124~#ffffff|516~ccf_font_effect_none|125~#000000|126~#850085|117~#000000|118~|119~0|120~0|121~6|122~0|552~1|553~#ffffff|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#ffffff|559~0|560~0|561~0|563~21|562~1|597~10|598~30|564~#dd99ff|565~bold|566~normal|594~none|567~1|568~dotted|569~#ffffff|570~#ffffff|571~0|572~0|573~0|574~#eb4c6b|595~none|575~#b50000|576~#ffffff|577~0|578~0|579~0|580~#0cf20c|581~normal|582~italic|593~none|583~#ffffff|584~0|585~0|586~0|599~/*Wrapper styling******************************************/
                                                .creative_form_FORM_ID.creativecontactform_wrapper {\nbackground-image: url("http://creative-solutions.net/components/com_creativecontactform/assets/images/bg_images/bg_neon_1.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: 100% 100% !important;\n}\n\n/*Input fields styles***************************************/\n.creative_form_FORM_ID  .creativecontactform_input_element {\n    background: -webkit-linear-gradient(top, rgba(0, 0, 0, 0.4), rgba(0, 0, 0, 0.45)) !important;\n    background: -moz-linear-gradient(top, rgba(0, 0, 0, 0.4), rgba(0, 0, 0, 0.45))) !important;\n    background: linear-gradient(top, rgba(0, 0, 0, 0.4), rgba(0, 0, 0, 0.45)) !important;\n\nborder: 1px solid rgba(167, 68, 222, 0.9) !important;\n}\n\n/*select field type icon************************************/\n.creative_form_FORM_ID .ccf_select_icon {\nopacity: 0.5;\n}\n/*set creative checkbox opacity*************************/\n.creative_form_FORM_ID a.creativeform_twoglux_styled_element {\nopacity: 0.85;\n}\n/*Heading styles******************************************/\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 0.31) !important;\n}\n/*contact data icons styles******************************/\n.creative_form_FORM_ID .ccf_content_icon {\n/*\nbackground-color: rgba(126, 126, 126, 0.33) !important;\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n*/\n}\n/*popup styles*********************************************/\n.creative_form_FORM_ID.ccf_popup_inner_wrapper  .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 1) !important;\n}\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: rgba(132, 132, 132, 0.25);\ncolor: #ddd;\ntext-shadow: -1px 2px 2px #000;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar h1 {\ncolor: #fff;\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.08);\nborder-top: 1px solid rgba(0,0,0,0.7);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #c2c2c2;\nbackground: rgba(40, 40, 40, 0.77);\n}|628~',
                                                'Night Template' => '587~#ffffff|588~13|131~ccf-googlewebfont-Maven Pro|589~2|629~rounded-dark|630~rounded|627~0|0~#ffffff|130~#ffffff|517~50|518~50|1~#373737|2~1|3~solid|4~0|5~0|6~0|7~0|8~#000000|9~|10~2|11~4|12~5|13~0|14~#000000|15~|16~0|17~0|18~7|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~0|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#ffffff|21~38|22~normal|23~normal|24~none|25~left|506~ccf-googlewebfont-Jura|510~ccf_font_effect_none|27~#000000|28~2|29~2|30~2|190~0|191~0|192~75|502~left|193~6|194~1|195~#bababa|196~dotted|197~#ffffff|198~14|199~normal|200~normal|201~none|202~ccf-googlewebfont-Jura|511~ccf_font_effect_none|203~#000000|204~2|205~2|206~2|215~0|216~0|217~3|218~3|31~#ffffff|32~14|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#000000|38~2|39~1|40~1|41~#ff0000|42~26|43~normal|44~normal|509~inherit|46~#000000|47~2|48~1|49~1|505~black|508~inherit|132~#595959|133~#595959|168~60|519~90|520~90|500~left|501~left|134~#5b616b|135~1|136~solid|137~5|138~5|139~5|140~5|141~#f5f5f5|142~|143~0|144~0|145~0|146~0|147~#fffaff|148~13|149~normal|150~normal|151~none|152~inherit|153~#000000|154~2|155~1|156~1|157~#ffffff|158~#ededed|159~#dedede|160~#000000|161~#828282|162~#363636|163~|164~0|165~0|166~3|167~0|513~ccf_font_effect_none|176~#ffffff|177~#ffffff|178~#520101|179~#d10000|180~#000000|181~2|182~2|183~1|184~#6e2a2a|185~|186~0|187~0|188~8|189~1|171~#d90000|514~ccf_font_effect_none|172~#000000|173~2|174~1|175~1|169~95|521~90|522~90|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#424242|542~#262626|543~1|544~1|545~1|546~1|547~solid|548~#383838|549~#383838|550~#141414|551~#2e2e2e|524~#b0b0b0|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~2|533~1|534~1|91~#202640|50~#00061c|212~right|92~11|93~25|209~93|100~#00071a|101~1|127~solid|102~7|103~7|104~7|105~7|94~#f0f0f0|95~|96~0|97~0|98~2|99~0|106~#b5b5b5|107~16|108~bold|109~normal|110~none|112~ccf-googlewebfont-Jura|515~ccf_font_effect_none|113~#000000|114~2|115~1|116~2|51~#262626|52~#0d0d0d|124~#adadad|516~ccf_font_effect_none|125~#000000|126~#757575|117~#7a7a7a|118~|119~0|120~0|121~7|122~1|552~2|553~#bfbfbf|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#000000|559~2|560~2|561~2|563~2|562~2|597~10|598~30|564~#86aff7|565~normal|566~normal|594~none|567~1|568~dotted|569~#82b3f0|570~#000000|571~0|572~0|573~0|574~#f20030|595~none|575~#f50000|576~#000000|577~2|578~1|579~1|580~#00e000|581~normal|582~italic|593~none|583~#000000|584~2|585~1|586~1|599~/*Wrapper styling******************************************/
                                                .creative_form_FORM_ID.creativecontactform_wrapper {\nbackground-image: url("http://creative-solutions.net/components/com_creativecontactform/assets/images/bg_images/bg_night.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\nborder-top: 1px solid rgba(48, 48, 48, 0.55) !important;\nwebkit-box-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5) !important;\n-moz-box-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5) !important;\nbox-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5 !important);\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creativecontactform_wrapper_inner{\nbackground: transparent url("ccf_img_path/bg_light.png") center 0px no-repeat;\nbackground-size: 100% 100% !important;\n}\n/*Input fields styles***************************************/\n.creative_form_FORM_ID .creativecontactform_input_element{\nbackground: -webkit-linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\nbackground: -moz-linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\nbackground: linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\n}\n/*select field type icon************************************/\n.creative_form_FORM_ID .ccf_select_icon {\nopacity: 0.5;\n}\n/*set creative checkbox opacity*************************/\n.creative_form_FORM_ID a.creativeform_twoglux_styled_element {\nopacity: 0.85;\n}\n/*Heading styles******************************************/\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 0.31) !important;\n}\n/*contact data icons styles******************************/\n.creative_form_FORM_ID .ccf_content_icon {\n/*\nbackground-color: rgba(126, 126, 126, 0.33) !important;\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n*/\n}\n/*popup styles*********************************************/\n.creative_form_FORM_ID.ccf_popup_inner_wrapper  .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 1) !important;\n}\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: rgba(132, 132, 132, 0.25);\ncolor: #ddd;\ntext-shadow: -1px 2px 2px #000;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar h1 {\ncolor: #fff;\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.08);\nborder-top: 1px solid rgba(0,0,0,0.7);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #c2c2c2;\nbackground: rgba(40, 40, 40, 0.77);\n}|628~',
                                                'Fire Template' => '587~#cccccc|588~13|131~ccf-googlewebfont-Magra|589~2|629~rounded-dark|630~rounded|627~0|0~#ffffff|130~#ffffff|517~50|518~50|1~#373737|2~1|3~solid|4~0|5~0|6~0|7~0|8~#000000|9~|10~2|11~4|12~5|13~0|14~#000000|15~|16~0|17~0|18~7|19~0|600~0|601~#ffffff|602~#ffffff|603~18|604~15|605~15|606~20|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~15|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~0|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#000000|21~44|22~normal|23~italic|24~none|25~left|506~ccf-googlewebfont-Londrina Solid|510~ccf_font_effect_fire_animation|27~#000000|28~2|29~2|30~2|190~3|191~0|192~70|502~left|193~6|194~1|195~#bababa|196~dotted|197~#c7c7c7|198~14|199~normal|200~italic|201~none|202~inherit|511~ccf_font_effect_none|203~#000000|204~2|205~2|206~2|215~0|216~0|217~3|218~3|31~#d6d6d6|32~13|33~normal|34~italic|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#000000|38~2|39~1|40~1|41~#ff0000|42~20|43~normal|44~normal|509~inherit|46~#000000|47~2|48~1|49~1|505~black|508~inherit|132~#595959|133~#595959|168~60|519~90|520~90|500~left|501~left|134~#4c4c4c|135~1|136~solid|137~5|138~5|139~5|140~5|141~#f5f5f5|142~|143~0|144~0|145~0|146~0|147~#c7c7c7|148~13|149~normal|150~italic|151~none|152~inherit|153~#000000|154~2|155~1|156~1|157~#ffffff|158~#ededed|159~#dedede|160~#000000|161~#828282|162~#808080|163~|164~0|165~0|166~8|167~1|513~ccf_font_effect_none|176~#ffffff|177~#ffffff|178~#ab640d|179~#eb834c|180~#000000|181~2|182~2|183~1|184~#c78728|185~|186~0|187~0|188~6|189~0|171~#000000|514~ccf_font_effect_fire_animation|172~#000000|173~2|174~1|175~1|169~95|521~90|522~90|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#424242|542~#262626|543~1|544~1|545~1|546~1|547~solid|548~#383838|549~#383838|550~#141414|551~#2e2e2e|524~#b0b0b0|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~2|533~1|534~1|91~#262626|50~#0d0d0d|212~right|92~14|93~20|209~93|100~#424142|101~1|127~solid|102~7|103~7|104~7|105~7|94~#525252|95~|96~0|97~0|98~0|99~0|106~#141414|107~20|108~bold|109~italic|110~none|112~ccf-googlewebfont-Londrina Solid|515~ccf_font_effect_fire|113~#000000|114~2|115~1|116~2|51~#262626|52~#0d0d0d|124~#000000|516~ccf_font_effect_fire_animation|125~#000000|126~#757575|117~#7a7a7a|118~|119~0|120~0|121~5|122~0|552~2|553~#bfbfbf|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#000000|559~2|560~2|561~2|563~2|562~2|597~10|598~30|564~#4c8bff|565~normal|566~normal|594~none|567~1|568~dotted|569~#0a78ff|570~#000000|571~0|572~0|573~0|574~#b00023|595~none|575~#b50000|576~#000000|577~0|578~0|579~0|580~#00a800|581~normal|582~italic|593~none|583~#000000|584~2|585~1|586~1|599~/*Wrapper styling******************************************/
                                                .creative_form_FORM_ID.creativecontactform_wrapper {\nbackground-image: url("http://creative-solutions.net/components/com_creativecontactform/assets/images/bg_images/bg_black_moon.jpg") !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\nborder-top: 1px solid rgba(48, 48, 48, 0.55) !important;\nwebkit-box-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5) !important;\n-moz-box-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5) !important;\nbox-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5 !important);\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creativecontactform_wrapper_inner{\nbackground: transparent url("ccf_img_path/bg_light.png") center 0px no-repeat;\nbackground-size: 100% 100% !important;\n}\n/*Input fields styles***************************************/\n.creative_form_FORM_ID .creativecontactform_input_element{\nbackground: -webkit-linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\nbackground: -moz-linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\nbackground: linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\n}\n/*select field type icon************************************/\n.creative_form_FORM_ID .ccf_select_icon {\nopacity: 0.5;\n}\n/*set creative checkbox opacity*************************/\n.creative_form_FORM_ID a.creativeform_twoglux_styled_element {\nopacity: 0.85;\n}\n/*Heading styles******************************************/\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 0.31) !important;\n}\n/*contact data icons styles******************************/\n.creative_form_FORM_ID .ccf_content_icon {\n/*\nbackground-color: rgba(126, 126, 126, 0.33) !important;\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n*/\n}\n/*popup styles*********************************************/\n.creative_form_FORM_ID.ccf_popup_inner_wrapper  .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 1) !important;\n}\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: rgba(132, 132, 132, 0.25);\ncolor: #ddd;\ntext-shadow: -1px 2px 2px #000;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar h1 {\ncolor: #fff;\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.08);\nborder-top: 1px solid rgba(0,0,0,0.7);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #c2c2c2;\nbackground: rgba(40, 40, 40, 0.77);\n}\n/*Hide pretext***************************************/\n.ccf_next_page_button, .ccf_prev_page_button, .ccf_tab_item {\ncolor: #ccc !important;\n}\n.ccf_popup_button, .ccf_static_button {\ncolor: #a5a5a5 !important;\nfont-family: arial, sans-serif !important;\nfont-size: 12px !important;\nfont-weight: normal !important;\nfont-style: normal !important;\n}\n.ccf_static_form .creativecontactform_title {\nfont-size: 38px !important;\n}|628~',
                                                'Forest Template' => '587~#ffffff|588~13|131~ccf-googlewebfont-Maven Pro|589~2|629~rounded-dark|630~rounded|627~0|0~#ffffff|130~#ffffff|517~50|518~50|1~#373737|2~1|3~solid|4~0|5~0|6~0|7~0|8~#000000|9~|10~2|11~4|12~5|13~0|14~#000000|15~|16~0|17~0|18~7|19~0|600~0|601~#ffffff|602~#ffffff|603~15|604~15|605~15|606~15|607~0|608~solid|609~#ffffff|610~0|611~#ffffff|612~#ffffff|613~5|614~15|615~10|616~15|617~0|618~#ffffff|619~#ffffff|620~0|621~15|622~15|623~15|624~0|625~solid|626~#ffffff|20~#ffffff|21~38|22~normal|23~normal|24~none|25~left|506~ccf-googlewebfont-Jura|510~ccf_font_effect_none|27~#000000|28~2|29~2|30~2|190~0|191~0|192~75|502~left|193~6|194~1|195~#bababa|196~dotted|197~#ffffff|198~14|199~normal|200~normal|201~none|202~ccf-googlewebfont-Jura|511~ccf_font_effect_none|203~#000000|204~2|205~2|206~2|215~0|216~0|217~3|218~3|31~#ffffff|32~14|33~normal|34~normal|35~none|36~left|507~inherit|512~ccf_font_effect_none|37~#000000|38~2|39~1|40~1|41~#ff0000|42~26|43~normal|44~normal|509~inherit|46~#000000|47~2|48~1|49~1|505~black|508~inherit|132~#595959|133~#595959|168~60|519~90|520~90|500~left|501~left|134~#5b616b|135~1|136~solid|137~5|138~5|139~5|140~5|141~#f5f5f5|142~|143~0|144~0|145~0|146~0|147~#fffaff|148~13|149~normal|150~normal|151~none|152~inherit|153~#000000|154~2|155~1|156~1|157~#ffffff|158~#ededed|159~#dedede|160~#000000|161~#828282|162~#363636|163~|164~0|165~0|166~3|167~0|513~ccf_font_effect_none|176~#ffffff|177~#ffffff|178~#520101|179~#d10000|180~#000000|181~2|182~2|183~1|184~#6e2a2a|185~|186~0|187~0|188~8|189~1|171~#d90000|514~ccf_font_effect_none|172~#000000|173~2|174~1|175~1|169~95|521~90|522~90|170~150|523~130|535~8|536~15|537~9|538~12|539~15|540~15|541~#424242|542~#262626|543~1|544~1|545~1|546~1|547~solid|548~#383838|549~#383838|550~#141414|551~#2e2e2e|524~#b0b0b0|525~15|526~normal|527~normal|528~none|529~inherit|530~ccf_font_effect_none|531~#000000|532~2|533~1|534~1|91~#122b16|50~#000301|212~right|92~11|93~25|209~93|100~#001a07|101~1|127~solid|102~7|103~7|104~7|105~7|94~#f0f0f0|95~|96~0|97~0|98~2|99~0|106~#b5b5b5|107~16|108~bold|109~normal|110~none|112~ccf-googlewebfont-Jura|515~ccf_font_effect_none|113~#000000|114~2|115~1|116~2|51~#262626|52~#0d0d0d|124~#adadad|516~ccf_font_effect_none|125~#000000|126~#757575|117~#7a7a7a|118~|119~0|120~0|121~7|122~1|552~2|553~#bfbfbf|554~14|555~normal|556~normal|596~none|590~0|591~dotted|592~#fafafa|558~#000000|559~2|560~2|561~2|563~2|562~2|597~10|598~30|564~#86aff7|565~normal|566~normal|594~none|567~1|568~dotted|569~#82b3f0|570~#000000|571~0|572~0|573~0|574~#f20030|595~none|575~#f50000|576~#000000|577~2|578~1|579~1|580~#00e000|581~normal|582~italic|593~none|583~#000000|584~2|585~1|586~1|599~/*Wrapper styling******************************************/
                                                .creative_form_FORM_ID.creativecontactform_wrapper {\nbackground-image: url("http://creative-solutions.net/components/com_creativecontactform/assets/images/bg_images/bg_forest.jpg") !important;\nbackground-position: 0px -140px !important;\nbackground-repeat: repeat !important;\nbackground-size: auto auto !important;\nbackground-color: #161616 !important;\nborder-top: 1px solid rgba(48, 48, 48, 0.55) !important;\nwebkit-box-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5) !important;\n-moz-box-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5) !important;\nbox-shadow: 2px 4px 5px 0px rgba(0, 0, 0, 0.5 !important);\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creativecontactform_wrapper_inner{\nbackground: transparent url("ccf_img_path/bg_light.png") center 0px no-repeat;\nbackground-size: 100% 100% !important;\n}\n/*Input fields styles***************************************/\n.creative_form_FORM_ID .creativecontactform_input_element{\nbackground: -webkit-linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\nbackground: -moz-linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\nbackground: linear-gradient(top, rgba(58, 58, 58, 0.36), rgba(23, 23, 23, 0.35)) !important;\n}\n/*select field type icon************************************/\n.creative_form_FORM_ID .ccf_select_icon {\nopacity: 0.5;\n}\n/*set creative checkbox opacity*************************/\n.creative_form_FORM_ID a.creativeform_twoglux_styled_element {\nopacity: 0.85;\n}\n/*Heading styles******************************************/\n.creative_form_FORM_ID .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 0.31) !important;\n}\n/*contact data icons styles******************************/\n.creative_form_FORM_ID .ccf_content_icon {\n/*\nbackground-color: rgba(126, 126, 126, 0.33) !important;\nborder-radius: 100%;\nbox-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.33);\n*/\n}\n/*popup styles*********************************************/\n.creative_form_FORM_ID.ccf_popup_inner_wrapper  .creativecontactform_heading {\nbackground: rgba(44, 44, 44, 1) !important;\n}\n/*Creative Scrollbar***************************************/\n.creative_form_FORM_ID .creative_content_scrollbar {\nbackground-color: rgba(132, 132, 132, 0.25);\ncolor: #ddd;\ntext-shadow: -1px 2px 2px #000;\nborder-radius: 12px;\n}\n.creative_form_FORM_ID .creative_content_scrollbar h1 {\ncolor: #fff;\ntext-shadow: -1px 2px 2px #000;\n}\n.creative_form_FORM_ID .creative_content_scrollbar hr {\nborder-bottom: 1px solid rgba(255,255,255,0.08);\nborder-top: 1px solid rgba(0,0,0,0.7);\n}\n.creative_form_FORM_ID p.scrollbar_light {\npadding: 5px 10px;\nborder-radius: 6px;\ncolor: #c2c2c2;\nbackground: rgba(40, 40, 40, 0.77);\n}|628~'
                                            );
            $query_insert = "INSERT IGNORE INTO `#__contact_templates` (`id`, `name`, `created`, `date_start`, `date_end`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `styles`) VALUES ";
            $k = 1;
            foreach($ccf_templates_array as $tmp_name => $tmp_row) {
                $query_last_symbol = $k == sizeof($ccf_templates_array) ? ';' : ',';
                if(!in_array($tmp_name,$tmp_names))
                    $query_insert .= "(NULL, '".$tmp_name."', '0000-00-00 00:00:00', '0000-00-00', '0000-00-00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 0, 0, 0, '', '".$tmp_row."')". $query_last_symbol;
                $k ++;
            }
                            
            $db->setQuery($query_insert);
            $db->execute();

        }


        // INSTALL FORMS ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $query = 'SELECT COUNT(id) AS count_id FROM #__creative_forms';
        $db->setQuery($query);
        $count_forms = $db->loadResult();

        $countries_array = array("Afghanistan","Albania","Algeria","American Samoa","Andorra","Angola","Anguilla","Antarctica","Antigua and Barbuda","Argentina","Armenia","Aruba","Australia","Austria","Azerbaijan","Bahamas","Bahrain","Bangladesh","Barbados","Belarus","Belgium","Belize","Benin","Bermuda","Bhutan","Bolivia","Bosnia and Herzegowina","Botswana","Bouvet Island","Brazil","British Indian Ocean Territory","Brunei Darussalam","Bulgaria","Burkina Faso","Burundi","Cambodia","Cameroon","Canada","Cape Verde","Cayman Islands","Central African Republic","Chad","Chile","China","Christmas Island","Cocos (Keeling) Islands","Colombia","Comoros","Congo","Cook Islands","Costa Rica","Cote D","Croatia","Cuba","Cyprus","Czech Republic","Democratic Republic of Congo","Denmark","Djibouti","Dominica","Dominican Republic","East Timor","Ecuador","Egypt","El Salvador","Equatorial Guinea","Eritrea","Estonia","Ethiopia","Falkland Islands (Malvinas)","Faroe Islands","Fiji","Finland","France","France, Metropolitan","French Guiana","French Polynesia","French Southern Territories","Gabon","Gambia","Georgia","Germany","Ghana","Gibraltar","Greece","Greenland","Grenada","Guadeloupe","Guam","Guatemala","Guinea","Guinea-bissau","Guyana","Haiti","Heard and Mc Donald Islands","Honduras","Hong Kong","Hungary","Iceland","India","Indonesia","Iran","Iraq","Ireland","Israel","Italy","Jamaica","Japan","Jordan","Kazakhstan","Kenya","Kiribati","Korea","Kuwait","Kyrgyzstan","Lao People","Latvia","Lebanon","Lesotho","Liberia","Libyan Arab Jamahiriya","Liechtenstein","Lithuania","Luxembourg","Macau","Macedonia","Madagascar","Malawi","Malaysia","Maldives","Mali","Malta","Marshall Islands","Martinique","Mauritania","Mauritius","Mayotte","Mexico","Micronesia","Moldova","Monaco","Mongolia","Montserrat","Morocco","Mozambique","Myanmar","Namibia","Nauru","Nepal","Netherlands","Netherlands Antilles","New Caledonia","New Zealand","Nicaragua","Niger","Nigeria","Niue","Norfolk Island","North Korea","Northern Mariana Islands","Norway","Oman","Pakistan","Palau","Panama","Papua New Guinea","Paraguay","Peru","Philippines","Pitcairn","Poland","Portugal","Puerto Rico","Qatar","Reunion","Romania","Russian Federation","Rwanda","Saint Kitts and Nevis","Saint Lucia","Saint Vincent and the Grenadines","Samoa","San Marino","Sao Tome and Principe","Saudi Arabia","Senegal","Seychelles","Sierra Leone","Singapore","Slovak Republic","Slovenia","Solomon Islands","Somalia","South Africa","South Georgia &amp; South Sandwich Islands","Spain","Sri Lanka","St. Helena","St. Pierre and Miquelon","Sudan","Suriname","Svalbard and Jan Mayen Islands","Swaziland","Sweden","Switzerland","Syrian Arab Republic","Taiwan","Tajikistan","Tanzania","Thailand","Togo","Tokelau","Tonga","Trinidad and Tobago","Tunisia","Turkey","Turkmenistan","Turks and Caicos Islands","Tuvalu","Uganda","Ukraine","United Arab Emirates","United Kingdom","United States","United States Minor Outlying Islands","Uruguay","Uzbekistan","Vanuatu","Vatican City State (Holy See)","Venezuela","Viet Nam","Virgin Islands (British)","Virgin Islands (U.S.)","Wallis and Futuna Islands","Western Sahara","Yemen","Yugoslavia","Zambia","Zimbabwe");

        if($count_forms == 0) {

            // insert form 1 ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Basic Contact Form', 'Contact Us', 'Feel free to contact us if you have any questions', 'Message successfully sent', 'Send', 'New email', 'OK', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 0, '', '0', 103, '', 0, '1', 'Send me a copy');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();

            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `column_type`, `custom_html`, `google_maps`, `heading`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Name', 'Please enter your name!', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 1, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', '', '', 0, 0, 1, 0, 1, '', '', 0, 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Email', 'Please enter your email!', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 2, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', '', '', 0, 0, 1, 0, 1, '', '', 0, 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Country', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 3, '', '1', '', '', 10, 10, '', '', '0', '1', 'Select country', 'No results match', '', '', '', '', '', '', '', '', '', '', 1, 1, 1, 1, 1, '', '', 0, 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'How did you find us?', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 4, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', '', '', 1, 1, 1, 1, 1, '', '', 0, 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Message', 'Write your message!', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 5, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', '', '', 0, 0, 1, 0, 1, '', '', 0, 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '');

                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();

            // insert options
            $field_id = $field_id_first + 2;
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 

                            ";
            foreach($countries_array as $k => $country_val) {
                 $query_insert .= "(NULL, ".$field_id.", '".$country_val."', '".$country_val."', ".$k.", '1', '0')";
                 if($k != sizeof($countries_array) - 1)
                    $query_insert .= ',';
            }
            $db->setQuery($query_insert);
            $db->execute();

            // insert options
            $field_id = $field_id_first + 3;
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 
                                (NULL, ".$field_id.", 'Web search', 'Web search', 2, '1', '0'),
                                (NULL, ".$field_id.", 'Social networks', 'Social networks', 1, '1', '0'),
                                (NULL, ".$field_id.", 'Recommended by a friend', 'Recommended by a friend', 3, '1', '0');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            // end insert form 1
        }

        // get forms names
        $query = "SELECT `name` FROM `#__creative_forms`";
        $db->setQuery($query);
        $contact_form_names_array = $db->LoadAssocList();

        $form_names = array();
        if(is_array($contact_form_names_array)) {
            foreach($contact_form_names_array as $k => $form_name) {
                $form_names[] = $form_name["name"];
            }
        }

        if(!in_array('Contact Data Page', $form_names)) {

            // insert form : Contact Form With Captcha ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Contact Form With Captcha', 'Contact Us', 'Feel free to contact us if you have any questions', 'Message successfully sent', 'Send', 'New email', 'OK', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 0, '', '0', 103, '', 0, '1', 'Send me a copy');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `column_type`, `custom_html`, `google_maps`, `heading`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Name', 'Please enter your name!', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 1, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', '', '', 0, 0, 1, 0, 1, '', '', 0, 0, 1, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Email', 'Please enter your email!', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 2, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', '', '', 0, 0, 1, 0, 1, '', '', 0, 0, 1, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Website', 'Please enter your website!', 8, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 3, '', '0', '', '', 10, 10, '', '', '0', '1', 'Select country', 'No results match', '', '', '', '', '', '', '', '', '', '', 0, 0, 1, 0, 1, '', '', 0, 0, 1, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Where did you hear about us?', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 5, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', '', '', 0, 0, 1, 0, 1, '', '', 0, 0, 2, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Message', 'Write your message!', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 6, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', '', '', 0, 0, 1, 0, 1, '', '', 0, 0, 2, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Security Code', '', 13, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 4, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', 'Security code is not correct', '', '', 0, 0, 1, 0, 1, '', '', 0, 0, 1, '', '', '', '', '', '', '', '', '', 120, '', '');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();

            // insert options
            $field_id = $field_id_first + 3;
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 
                                (NULL, ".$field_id.", 'A Friend or colleauge', 'A Friend or colleauge', 0, '1', '0'),
                                (NULL, ".$field_id.", 'Web search', 'Web search', 1, '1', '0'),
                                (NULL, ".$field_id.", 'Social networks', 'Social networks', 2, '1', '0');
                            ";
            $db->setQuery($query_insert);
            $db->execute();

            // END insert contact form with captcha///

            

             // insert form: Contact Form With ReCaptcha ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Contact Form With ReCapctha', 'Contact Us', 'Feel free to contact us if you have any questions', 'Message successfully sent', 'Send', 'New email', 'OK', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 1, '', '0', 103, '', 0, '1', 'Send me a copy', '0', 1, 1, 1, 1, 1, '.creative_form_FORM_ID .creative_field_box_wrapper_1 .creativecontactform_field_box_inner {\r\nwidth: 300px !important;\r\n}\r\n.creative_form_FORM_ID .creative_field_box_wrapper_1 {\r\nwidth: 52% !important;\r\n}\r\n.creative_form_FORM_ID .creative_field_box_wrapper_2 {\r\nwidth: 48% !important;\r\n}\r\n.creative_form_FORM_ID .creative_field_box_wrapper_1 .creative_textarea_wrapper, .creative_form_FORM_ID .creative_field_box_wrapper_2 .creative_textarea_wrapper {\r\nheight: 190px !important;\r\n}\r\n.creative_form_FORM_ID .creativecontactform_pre_text {\r\nwidth: 95% !important;\r\n}\r\n');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();

            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Name', 'Please enter your name!', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 89, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Email', 'Please enter your email!', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 91, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Message', 'Write your message!', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 112, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Security', '', 19, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 103, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', 'light', 'image', '', 120, '', '');

                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();

            // END insert Contact Form With ReCaptcha //////////


            // insert Contact Data Page ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Contact Data Page', 'Contact Data Page', 'You can use this page to show your contact data <b>anywhere in your website</b>!', 'Message successfully sent', 'Send', 'New email', 'OK', '90%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 13, '', '0', 103, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '.creative_form_FORM_ID .creativecontactform_pre_text {\r\nwidth: 90% !important;\r\n}\r\n\r\n.creative_form_FORM_ID .creativecontactform_submit_wrapper \r\n{\r\ndisplay:none !important;\r\n}');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'About Us Popup', '', 21, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 153, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '<h1>About Us</h1>\r\n<p>{heading}Our mission{/heading}</p>\r\n<p>Aliquam erat volutpat. Maecenas ultricies feugiat dui vitae pulvinar. Integer convallis ultrices tempor. Ut consequat nunc eget tellus ultrices sollicitudin. Phasellus mattis scelerisque vestibulum. Nulla facilisi. Pellentesque imperdiet vestibulum mauris, in condimentum arcu dignissim sed. Suspendisse potenti. Nulla pretium ultricies erat, vitae scelerisque tortor semper et.</p>\r\n<p>Aliquam erat volutpat. Maecenas ultricies feugiat dui vitae pulvinar. Integer convallis ultrices tempor. Ut consequat nunc eget tellus ultrices sollicitudin. Phasellus mattis scelerisque vestibulum. Nulla facilisi. Pellentesque imperdiet vestibulum mauris, in condimentum arcu dignissim sed. Suspendisse potenti. Nulla pretium ultricies erat, vitae scelerisque tortor semper et.</p>\r\n<p>{heading}Our values{/heading}</p>\r\n<p>Aliquam erat volutpat. Maecenas ultricies feugiat dui vitae pulvinar. Integer convallis ultrices tempor. Ut consequat nunc eget tellus ultrices sollicitudin. Phasellus mattis scelerisque vestibulum. Nulla facilisi. Pellentesque imperdiet vestibulum mauris, in condimentum arcu dignissim sed. Suspendisse potenti. Nulla pretium ultricies erat, vitae scelerisque tortor semper et.</p>\r\n<p>{heading}Our partners{/heading}</p>\r\n<p>Aliquam erat volutpat. Maecenas ultricies feugiat dui vitae pulvinar. Integer convallis ultrices tempor. Ut consequat nunc eget tellus ultrices sollicitudin. Phasellus mattis scelerisque vestibulum. Nulla facilisi. Pellentesque imperdiet vestibulum mauris, in condimentum arcu dignissim sed. Suspendisse potenti. Nulla pretium ultricies erat, vitae scelerisque tortor semper et.</p>', ''),
                                (NULL, 0, ".$form_id.", 'Google Maps', '', 18, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 152, '', '0', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '<iframe src=\"https://www.google.com/maps/d/embed?mid=z2ij1oq8eejA.k0YHKZpiIGcA\" width=\"100%\" height=\"250\"></iframe>', '', '', '', '', '', '', 120, '', '');
                            ";


            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();
            
            $query_insert = 
                                "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Contact Data', '', 20, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 148, '', '0', '', '', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '{section icon=\"info\" label=\"About Us:\"}\r\nTell your visitors about your website/company..\r\n<br />Show large content in   \r\n{creative_popup id=\"".$field_id_first."\" size=\"600X400\"}\r\nCreative Popup\r\n{/creative_popup}\r\n{/section}\r\n\r\n{section icon=\"address\" label=\"Address:\"}\r\nPO Box 21177 / Level 13, 2 Elizabeth St, Melbourne<br />Victoria 3000 Australia\r\n{/section}\r\n\r\n{section icon=\"phone\" label=\"Phone:\"}\r\n{num}+00 (0) 123 456 789{/num} (Primary)<br />\r\n{num}+00 (0) 123 456 789{/num}\r\n{/section}\r\n\r\n{section icon=\"mobile\" label=\"Mobile:\"}\r\n{num}+00 (0) 123 456 789{/num}\r\n{/section}\r\n\r\n{section icon=\"fax\" label=\"Fax:\"}\r\n+00 (0) 123 456 789\r\n{/section}\r\n\r\n{section icon=\"email\" label=\"E-mail:\"}\r\nsome-email@example.com\r\n{/section}\r\n\r\n{section icon=\"link\" label=\"Website:\"}\r\n<a href=\"http://www.example.com\" target=\"_blank\">example.com</a>\r\n{/section}\r\n\r\n\r\n\r\n', 110, '', '');
                                ";

            $db->setQuery($query_insert);
            $db->execute();

            // END insert Contact Data Page //////////


            // insert Contact Page With Maps ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Contact Page With Maps', 'Contact Page With Maps', 'Feel free to contact us if you have any questions', 'Message successfully sent', 'Send', 'New email', 'OK', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 878, '2015-01-22 14:36:11', 1, 0, 11, '', '0', 103, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '.creative_form_FORM_ID .creative_field_box_wrapper_1 .creative_textarea_wrapper, .creative_form_FORM_ID .creative_field_box_wrapper_2 .creative_textarea_wrapper {\r\nheight: 245px !important;\r\n}\r\n\r\n.creative_form_FORM_ID .creativecontactform_pre_text {\r\nwidth: 100% !important;\r\n}\r\n\r\n.creative_form_FORM_ID .creativecontactform_send,\r\n.creative_form_FORM_ID .creativecontactform_send_new\r\n{\r\nfloat: left !important;\r\n}');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Name', 'Please enter your name!', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 65, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Website', 'Please enter your website!', 8, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 99, '', '0', '', '', 10, 10, '', '', '0', '1', 'Select country', 'No results match', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Message', 'Write your message!', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 105, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Google Maps', '', 18, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 878, '0000-00-00 00:00:00', 1, 0, 154, '', '0', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '<iframe src=\"https://www.google.com/maps/d/embed?mid=z2ij1oq8eejA.k0YHKZpiIGcA\" width=\"100%\" height=\"350\"></iframe>', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Contact Data', '', 20, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 149, '', '0', '', '', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '{section icon=\"address\" label=\"Address:\"}\r\nPO Box 21177 / Level 13, 2 Elizabeth St, Melbourne Victoria 3000 Australia\r\n{/section}\r\n\r\n{section icon=\"phone\" label=\"Phone:\"}\r\n{num}+00 (0) 123 456 789{/num}\r\n{/section}\r\n\r\n{section icon=\"email\" label=\"E-mail:\"}\r\nsome-email@example.com\r\n{/section}', 110, '', ''),
                                (NULL, 0, ".$form_id.", 'Country', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 96, '', '0', '', '', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Email', 'Please enter your email!', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 94, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '');

                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();

            // insert options
            $field_id = $field_id_first + 5;
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 

                            ";
            foreach($countries_array as $k => $country_val) {
                 $query_insert .= "(NULL, ".$field_id.", '".$country_val."', '".$country_val."', ".$k.", '1', '0')";
                 if($k != sizeof($countries_array) - 1)
                    $query_insert .= ',';
            }
            $db->setQuery($query_insert);
            $db->execute();
            // END insert Contact Page With Maps //////////

            // insert Contact Page With About Us ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Contact Page With About Us', 'Contact Page With About Us', 'Feel free to contact us if you have any questions', 'Message successfully sent', 'Send', 'New email', 'OK', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 12, '', '0', 103, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '.creative_form_FORM_ID .creative_field_box_wrapper_1 .creative_textarea_wrapper, .creative_form_FORM_ID .creative_field_box_wrapper_2 .creative_textarea_wrapper {\r\nheight: 260px !important;\r\n}\r\n\r\n.creative_form_FORM_ID .creativecontactform_pre_text {\r\nwidth: 100% !important;\r\n}\r\n\r\n.creative_form_FORM_ID .creativecontactform_send,\r\n.creative_form_FORM_ID .creativecontactform_send_new\r\n{\r\nfloat: left !important;\r\n}\r\n\r\n.creative_form_FORM_ID  .creative_content_scrollbar {\r\nheight: 310px !important;\r\n}');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'About Us', '', 16, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 151, '', '0', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '<div class=\"creative_content_scrollbar\">\r\n<h1 style=\"margin: 5px 0 8px;font-size: 24px;\">About Us</h1>\r\n<hr />\r\n<p class=\"scrollbar_light\">\r\n<span style=\"margin-bottom: 10px;display: block;font-size: 120%;font-weight: bold;margin-top: 5px;\">Our mission</span>\r\nAliquam erat volutpat. Maecenas ultricies feugiat dui vitae pulvinar. Integer convallis ultrices tempor. Ut consequat nunc eget tellus ultrices sollicitudin. Phasellus mattis scelerisque vestibulum. Nulla facilisi. Pellentesque imperdiet vestibulum mauris, in condimentum arcu dignissim sed. Suspendisse potenti. Nulla pretium ultricies erat, vitae scelerisque tortor semper et. \r\n</p>\r\n<p>\r\n<span style=\"margin-bottom: 10px;display: block;font-size: 120%;font-weight: bold;margin-top: 5px;\">Our values</span>\r\nNulla facilisi. Nunc volutpat. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Ut sit amet orci vel mauris blandit vehicula. Nullam quis enim. Integer dignissim viverra velit. Curabitur in odio. In hac habitasse platea dictumst. Ut consequat, tellus eu volutpat varius, justo orci elementum dolor, sed imperdiet nulla tellus ut diam. Vestibulum ipsum ante, malesuada quis, tempus ac, placerat sit amet, elit.\r\n</p>\r\n</div>', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Message', 'Write your message!', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 106, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Name', 'Please enter your name!', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 64, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Country', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 98, '', '0', '', '', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Email', 'Please enter your email!', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 95, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Map Popup', '', 21, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 157, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '<iframe src=\"https://www.google.com/maps/d/embed?mid=z2ij1oq8eejA.k0YHKZpiIGcA\" width=\"700\" height=\"500\"></iframe>'),
                                (NULL, 0, ".$form_id.", 'Website', '', 8, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 97, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '');


                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();

            // insert fields
            $popup_id = $field_id_first + 5;
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Contact Data', '', 20, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 150, '', '0', '', '', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '{section icon=\"address\" label=\"Address:\"}\r\nPO Box 21177 / Level 13, 2 Elizabeth St, Melbourne Victoria 3000 Australia\r\n{/section}\r\n\r\n{section icon=\"phone\" label=\"Phone:\"}\r\n{num}+00 (0) 123 456 789{/num}\r\n{/section}\r\n\r\n{section icon=\"email\" label=\"E-mail:\"}\r\nsome-email@example.com\r\n{/section}\r\n\r\n{section icon=\"map\" label=\"Map:\"}\r\n{creative_popup id=\"".$popup_id."\" size=\"745X545\"}Find us on map{/creative_popup}\r\n{/section}', 110, '', '');

                            ";
            $db->setQuery($query_insert);
            $db->execute();

            // insert options
            $field_id = $field_id_first + 3;
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 

                            ";
            foreach($countries_array as $k => $country_val) {
                 $query_insert .= "(NULL, ".$field_id.", '".$country_val."', '".$country_val."', ".$k.", '1', '0')";
                 if($k != sizeof($countries_array) - 1)
                    $query_insert .= ',';
            }
            $db->setQuery($query_insert);
            $db->execute();
            // END insert Contact Page With About Us //////////

            // insert Mini Contact Form ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Mini Contact Form', 'Contact Us', 'Feel free to contact us if you have any questions', 'Message successfully sent', 'Send', 'New email', 'OK', '350px', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 15, '', '0', 103, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '.creative_form_FORM_ID .creativecontactform_pre_text {\r\nwidth: 95% !important;\r\n}\r\n.creative_form_FORM_ID .creativecontactform_submit_wrapper {\r\nwidth: 95% !important;\r\n}\r\n.creative_form_FORM_ID .creative_field_box_wrapper_0 .creativecontactform_field_box_inner,\r\n.creative_form_FORM_ID .creative_field_box_wrapper_0 .creativecontactform_field_box_textarea_inner \r\n{\r\nwidth: 95% !important;\r\n}');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Email', 'Please enter your email!', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 0, 0, 120, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '0', '0', '', '', '', '', '', 0, '', '', 1, 1, 1, 1, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Name', 'Please enter your name!', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 1, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 1, 1, 1, 1, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Message', 'Please enter your message!', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 125, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 1, 1, 1, 1, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            // END insert Mini Contact Form //////////

            // insert File Upload Progress ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'File Upload With Progressbar', 'File Upload With Progressbar', '', 'Message successfully sent', 'Send', 'New email', 'OK', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 3, '', '0', 105, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Please select some files', '', 14, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 82, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', 'Select files...', '1', '5', 'jpg|jpeg|png|gif|pdf|doc|docx|ppt|pptx|odt|avi|ogg|m4a|mov|mp3|mp4|mpg|wav|wmv|zip|rar|7z', 'File is too small', 'File size exceeds the maximum allowed size (5 MB)', 'Invalid file format', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Info', '', 20, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 58, '', '0', '', '', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '{section icon=\"info\" label=\"Info:\"}File Upload with multiple file selection, drag&drop support, progress bar and validation. Supports cross-domain, chunked and resumable file uploads. You can configure upload min/max size, accepted file types, error messages etc.{/section}\r\n<br />', 75, '', ''),
                                (NULL, 0, ".$form_id.", 'Security', '', 13, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 87, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            // END insert File Upload Progress //////////

            // insert Contact Form With Calendars ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Contact Form With Calendars', 'Contact Form With Calendars', 'This demo shows some usage of datepicker!', 'Message successfully sent', 'Send', 'New email', 'OK', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 2, '', '0', 105, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '.creative_form_FORM_ID .creativecontactform_pre_text {\r\nwidth: 95% !important;\r\n}\r\n.creative_form_FORM_ID .creativecontactform_submit_wrapper {\r\nwidth: 95% !important;\r\n}');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Date (Display month & year menus)', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 156, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, 'd MM, yy', 'fadeIn', 0, 0, 1, 0, 1, '1920:2025', 'NOW', 1, 1, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Date (Display multiple months)', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 161, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, 'mm/dd/yy', 'show', 0, 0, 1, 0, 3, '-1 MONTH', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Date (Set min & max dates)', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 164, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, 'mm/dd/yy', 'show', 0, 0, 1, 0, 1, '-20', '+1M +10D', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Date (Date format - Full)', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 166, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, 'DD, d MM, yy', 'show', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Info', '', 20, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 154, '', '0', '', '', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '{section icon=\"info\" label=\"Info:\"}\r\nThere are a lot of configurable options! You can change or hide datepicker icon,<br />change datepicker style, set number of months, min/max dates and much more!\r\n{/section}\r\n<br />', 75, '', '');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            // END insert Contact Form With Calendars //////////

            // insert Event Registration Form ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Event Registration Form', 'Event Registration Form', 'Fill out the form to register to our event', 'Message successfully sent', 'Register', 'New Order', 'OK', '500px', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 4, '', '0', 105, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '.creative_form_FORM_ID .creativecontactform_pre_text {\r\nwidth: 95% !important;\r\n}\r\n.creative_form_FORM_ID .creativecontactform_submit_wrapper {\r\nwidth: 95% !important;\r\n}');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'First Name', '', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 40, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Last Name', '', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 58, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Are you an existing customer?', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 90, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Company', '', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 87, '', '0', '95%', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Email', '', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 57, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Phone Number', '', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 77, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Event Type', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 86, '', '1', '95%', '', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Any comments or questions?', '', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 88, '', '0', '95%', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();

            $field_id_1 = $field_id_first + 2;
            $field_id_2 = $field_id_first + 6;

             // insert options
            $field_id = $field_id_first + 3;
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 
                                (NULL, ".$field_id_2.", 'Type 1', 'Type 1', 1, '1', '0'),
                                (NULL, ".$field_id_2.", 'Type 2', 'Type 2', 2, '1', '0'),
                                (NULL, ".$field_id_2.", 'Type 3', 'Type 3', 3, '1', '0'),
                                (NULL, ".$field_id_1.", 'Yes', 'Yes', 1, '1', '0'),
                                (NULL, ".$field_id_1.", 'No', 'No', 2, '1', '0');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            // END insert Event Registration Form //////////

            // insert Application Form ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Application Form', 'Application Form', 'Would you like to work with us? So send an application form!', 'Message successfully sent', 'Send', 'New', 'OK', '500px', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '2015-01-20 12:16:47', 1, 0, 6, '', '0', 105, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '.creative_form_FORM_ID .creativecontactform_pre_text {\r\nwidth: 95% !important;\r\n}\r\n.creative_form_FORM_ID .creativecontactform_submit_wrapper {\r\nwidth: 95% !important;\r\n}');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Name', 'Please enter your name!', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 44, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'CV', '', 14, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 80, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', 'Upload CV...', '1', '5', 'jpg|jpeg|png|gif|pdf|doc|docx|ppt|pptx|odt|avi|ogg|m4a|mov|mp3|mp4|mpg|wav|wmv|zip|rar|7z', 'File is too small', 'File size exceeds the maximum allowed size (5 MB)', 'Invalid file format', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Email', 'Please enter your email!', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 51, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Phone Number', 'Please enter your phone number!', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 72, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Applying for Position', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 79, '', '1', '', '', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Custom Notes', '', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 81, '', '0', '', '-12px 0 10px 0px ', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '');

                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();


             // insert options
            $field_id = $field_id_first + 4;
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 
                                (NULL, ".$field_id.", 'Position 1', 'Position 1', 1, '1', '0'),
                                (NULL, ".$field_id.", 'Position 2', 'Position 2', 2, '1', '0'),
                                (NULL, ".$field_id.", 'Position 3', 'Position 3', 3, '1', '0');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            // END insert Application Form //////////

            // insert Online Booking Form ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Online Booking Form', 'Online Booking Form', 'To make a reservation please complete and submit the booking form.', 'Message successfully sent', 'Submit', 'Submit New', 'Close', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 8, '', '0', 105, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Full Name', '', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 34, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'E-mail', '', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 38, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Phone Number', '', 6, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 41, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Arrival Date', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 47, '', '1', '45%', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, 'mm/dd/yy', 'show', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Departure Date', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 48, '', '1', '45%', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, 'mm/dd/yy', 'show', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Number of people', '', 7, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 43, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Comments', '', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 53, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            // END insert Online Booking Form //////////

            // insert Hotel Reservation Form ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Hotel Reservation Form', 'Hotel Reservation Form', 'An online hotel booking form to track your bookings easily and manage further reservations more accurate.', 'Message successfully sent', 'Submit', 'New Reservation', 'OK', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 878, '0000-00-00 00:00:00', 1, 0, 10, '', '0', 105, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'First Name', '', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 4, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Email', '', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 7, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Meal plan', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 23, '', '1', '', '', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Room type', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 22, '', '1', '', '', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Accomodation type', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 19, '', '1', '', '', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Check-out Date', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 18, '', '1', '75%', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, 'mm/dd/yy', 'show', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Check-in Date', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 17, '', '1', '75%', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, 'mm/dd/yy', 'show', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Country', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 8, '', '1', '', '', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'City', '', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 14, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Postal / Zip Code', '', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 15, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Address', '', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 9, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Phone Number', '', 6, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 11, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Additional Requests', '', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 31, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Pick up from Airport?', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 37, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Last Name', '', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 10, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Custom HTML', '', 16, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 16, '', '0', '', '', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Number of rooms', '', 7, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 21, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '');

                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();


             // insert options
            $field_id_1 = $field_id_first + 2;
            $field_id_2 = $field_id_first + 3;
            $field_id_3 = $field_id_first + 4;
            $field_id_4 = $field_id_first + 7;
            $field_id_5 = $field_id_first + 13;
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 
                                (NULL, ".$field_id_1.", 'RO (room only)', 'RO (room only)', 1, '1', '0'),
                                (NULL, ".$field_id_1.", 'ВВ (bed and breakfast)', 'ВВ (bed and breakfast)', 2, '1', '0'),
                                (NULL, ".$field_id_1.", 'HB (half board)', 'HB (half board)', 3, '1', '0'),
                                (NULL, ".$field_id_1.", 'FB (full board)', 'FB (full board)', 4, '1', '0'),
                                (NULL, ".$field_id_1.", 'AI (all inclusive)', 'AI (all inclusive)', 5, '1', '0'),
                                (NULL, ".$field_id_1.", 'UAI (ultra all inclusive)', 'UAI (ultra all inclusive)', 6, '1', '0'),
                                (NULL, ".$field_id_1.", 'Standard', 'Standard', 1, '1', '0'),
                                (NULL, ".$field_id_2.", 'Standard Twin', 'Standard Twin', 2, '1', '0'),
                                (NULL, ".$field_id_2.", 'Standard Sea View', 'Standard Sea View', 3, '1', '0'),
                                (NULL, ".$field_id_2.", 'Superior', 'Superior', 4, '1', '0'),
                                (NULL, ".$field_id_2.", 'Superior Sea View', 'Superior Sea View', 5, '1', '0'),
                                (NULL, ".$field_id_2.", 'Deluxe', 'Deluxe', 6, '1', '0'),
                                (NULL, ".$field_id_2.", 'Deluxe Sea View', 'Deluxe Sea View', 7, '1', '0'),
                                (NULL, ".$field_id_2.", 'Family', 'Family', 8, '1', '0'),
                                (NULL, ".$field_id_2.", 'Junior Suite', 'Junior Suite', 9, '1', '0'),
                                (NULL, ".$field_id_2.", 'Executive Suite', 'Executive Suite', 10, '1', '0'),
                                (NULL, ".$field_id_2.", 'Deluxe Suite', 'Deluxe Suite', 11, '1', '0'),
                                (NULL, ".$field_id_2.", 'Hermitage Suite', 'Hermitage Suite', 12, '1', '0'),
                                (NULL, ".$field_id_2.", 'Presidential Suite', 'Presidential Suite', 13, '1', '0'),
                                (NULL, ".$field_id_2.", 'Bungalow', 'Bungalow', 14, '1', '0'),
                                (NULL, ".$field_id_2.", 'Connected', 'Connected', 15, '1', '0'),
                                (NULL, ".$field_id_2.", 'Club', 'Club', 16, '1', '0'),
                                (NULL, ".$field_id_3.", 'SNGL', 'SNGL', 1, '1', '0'),
                                (NULL, ".$field_id_3.", 'DBL', 'DBL', 2, '1', '0'),
                                (NULL, ".$field_id_3.", 'TRPL', 'TRPL', 3, '1', '0'),
                                (NULL, ".$field_id_3.", 'SGL+1ch', 'SGL+1ch', 4, '1', '0'),
                                (NULL, ".$field_id_3.", 'SGL+2ch', 'SGL+2ch', 5, '1', '0'),
                                (NULL, ".$field_id_3.", 'DBL+1ch', 'DBL+1ch', 6, '1', '0'),
                                (NULL, ".$field_id_3.", 'DBL+2ch', 'DBL+2ch', 7, '1', '0'),
                                (NULL, ".$field_id_3.", 'TRPL+1ch', 'TRPL+1ch', 8, '1', '0'),
                                (NULL, ".$field_id_3.", 'TRPL+2ch', 'TRPL+2ch', 9, '1', '0'),
                                (NULL, ".$field_id_5.", 'Yes', 'Yes', 8, '1', '0'),
                                (NULL, ".$field_id_5.", 'No', 'No', 9, '1', '0'),
                            ";
            foreach($countries_array as $k => $country_val) {
                 $query_insert .= "(NULL, ".$field_id_4.", '".$country_val."', '".$country_val."', ".$k.", '1', '0')";
                 if($k != sizeof($countries_array) - 1)
                    $query_insert .= ',';
            }
            $db->setQuery($query_insert);
            $db->execute();
            // END insert Hotel Reservation Form //////////

            // insert Evaluation Survey ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Evaluation Survey', 'Evaluation Survey', 'Please let us know how was the food and service.', 'Message successfully sent', 'Submit', 'New', 'OK', '530px', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 878, '0000-00-00 00:00:00', 1, 0, 5, '', '0', 105, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '.creative_form_FORM_ID .creativecontactform_pre_text {\r\nwidth: 95% !important;\r\n}\r\n.creative_form_FORM_ID .creativecontactform_submit_wrapper {\r\nwidth: 95% !important;\r\n}');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Day Visited', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 46, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, 'mm/dd/yy', 'show', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Any comments, questions or suggestions?', '', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 85, '', '0', '95%', '15px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Food Quality', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 63, '', '1', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Overall Service Quality', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 74, '', '1', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Name', '', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 35, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Email', '', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 49, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Age', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 54, '', '1', '', '', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Cleanliness', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 65, '', '1', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Speed of Service', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 70, '', '1', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Order Accuracy', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 82, '', '1', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Overall Experience', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 83, '', '1', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '');

                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();


             // insert options
            $field_id_1 = $field_id_first + 2;
            $field_id_2 = $field_id_first + 3;
            $field_id_3 = $field_id_first + 7;
            $field_id_4 = $field_id_first + 8;
            $field_id_5 = $field_id_first + 9;
            $field_id_6 = $field_id_first + 10;
            $field_id_7 = $field_id_first + 6;
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 
                                (NULL, ".$field_id_1.", 'Excellent', 'Excellent', 1, '1', '0'),
                                (NULL, ".$field_id_1.", 'Good', 'Good', 2, '1', '0'),
                                (NULL, ".$field_id_1.", 'Average', 'Average', 3, '1', '0'),
                                (NULL, ".$field_id_1.", 'Dissatisfied', 'Dissatisfied', 4, '1', '0'),
                                (NULL, ".$field_id_2.", 'Excellent', 'Excellent', 1, '1', '0'),
                                (NULL, ".$field_id_2.", 'Good', 'Good', 2, '1', '0'),
                                (NULL, ".$field_id_2.", 'Average', 'Average', 3, '1', '0'),
                                (NULL, ".$field_id_2.", 'Dissatisfied', 'Dissatisfied', 4, '1', '0'),
                                (NULL, ".$field_id_3.", 'Excellent', 'Excellent', 1, '1', '0'),
                                (NULL, ".$field_id_3.", 'Good', 'Good', 2, '1', '0'),
                                (NULL, ".$field_id_3.", 'Average', 'Average', 3, '1', '0'),
                                (NULL, ".$field_id_3.", 'Dissatisfied', 'Dissatisfied', 4, '1', '0'),
                                (NULL, ".$field_id_4.", 'Excellent', 'Excellent', 1, '1', '0'),
                                (NULL, ".$field_id_4.", 'Good', 'Good', 2, '1', '0'),
                                (NULL, ".$field_id_4.", 'Average', 'Average', 3, '1', '0'),
                                (NULL, ".$field_id_4.", 'Dissatisfied', 'Dissatisfied', 4, '1', '0'),
                                (NULL, ".$field_id_5.", 'Excellent', 'Excellent', 1, '1', '0'),
                                (NULL, ".$field_id_5.", 'Good', 'Good', 2, '1', '0'),
                                (NULL, ".$field_id_5.", 'Average', 'Average', 3, '1', '0'),
                                (NULL, ".$field_id_5.", 'Dissatisfied', 'Dissatisfied', 4, '1', '0'),
                                (NULL, ".$field_id_6.", 'Excellent', 'Excellent', 1, '1', '0'),
                                (NULL, ".$field_id_6.", 'Good', 'Good', 2, '1', '0'),
                                (NULL, ".$field_id_6.", 'Average', 'Average', 3, '1', '0'),
                                (NULL, ".$field_id_6.", 'Dissatisfied', 'Dissatisfied', 4, '1', '0'),
                                (NULL, ".$field_id_7.", 'Under 13', 'Under 13', 1, '1', '0'),
                                (NULL, ".$field_id_7.", '13-17', '13-17', 2, '1', '0'),
                                (NULL, ".$field_id_7.", '18-24', '18-24', 3, '1', '0'),
                                (NULL, ".$field_id_7.", '25-34', '25-34', 4, '1', '0'),
                                (NULL, ".$field_id_7.", '35-44', '35-44', 5, '1', '0'),
                                (NULL, ".$field_id_7.", '45-54', '45-54', 6, '1', '0'),
                                (NULL, ".$field_id_7.", '55 or older', '55 or older', 7, '1', '0');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            // END insert Evaluation Survey //////////

             // insert COMPLEX FROM ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Complex Contact Form', 'Contact Us', 'Feel free to contact us if you have any questions', 'Message successfully sent', 'Send', 'New email', 'OK', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 0, '', '0', 103, '', 0, '1', 'Send me a copy', '0', 1, 1, 1, 1, 1, '/**********Set height of textarea in right column*****************************/\r\n.creative_form_FORM_ID .creative_field_box_wrapper_2 .creative_textarea_wrapper {\r\nheight: 130px !important;\r\n}\r\n\r\n/**********Set width of certain section****************************************/\r\n.creative_form_FORM_ID .ccf_section_width_control_5 {\r\nwidth: 75px !important;\r\n}\r\n.creative_form_FORM_ID .ccf_section_margin_control_5 {\r\nmargin-left: 75px !important;\r\n}');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();

            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Name', 'Please enter your name!', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 136, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 1, 1, 1, 1, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Email', 'Please enter your email!', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 137, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Country', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 141, '', '0', '', '', 10, 10, '', '', '0', '1', 'Select country', 'No results match', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 0, 0, 0, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'How did you find us?', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 139, '', '1', '', '', 10, 10, '', '', '0', '1', 'Select', '', '', '', '', '', '', '', '', '', 1, '', '', 1, 1, 1, 1, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Message', 'Write your message...', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 144, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 1, 1, 1, 1, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Birth Date', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 138, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, 'd MM, yy', 'fadeIn', 0, 0, 1, 0, 1, '1920:2025', 'NOW', 1, 1, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'File Upload', '', 14, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 148, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', 'Select files...', '1', '5', 'jpg|jpeg|png|gif|pdf|doc|docx|ppt|pptx|odt|avi|ogg|m4a|mov|mp3|mp4|mpg|wav|wmv|zip|rar|7z', 'File is too small', 'File size exceeds the maximum allowed size (5 MB)', 'Invalid file format', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Agree with terms and conditions', '', 11, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 155, '', '1', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Custom Html', '', 16, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 145, '', '0', '', '', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Write a message', '', 17, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 135, '', '0', '', '', 0, 0, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 0, 0, 0, '', '', 0, 0, '', 'Write a message', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Google Maps', '', 18, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 134, '', '0', '', '', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '<iframe src=\"https://www.google.com/maps/d/embed?mid=z2ij1oq8eejA.k0YHKZpiIGcA\" width=\"98%\" height=\"250\"></iframe>', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Heading - Contact Data', '', 17, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 92, '', '0', '', '', 0, 0, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 0, 0, 0, '', '', 0, 0, '', 'Contact Data', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Attach Files', '', 17, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 147, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', 'Attach Files', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Security Code', '', 19, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 152, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', 'light', 'image', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Contact Data', '', 20, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 120, '', '0', '', '', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '{section icon=\"address\" label=\"Address:\"}\r\nPO Box 21177 / Level 13, 2 Elizabeth St, Melbourne Victoria 3000 Australia\r\n{/section}\r\n\r\n{section icon=\"phone\" label=\"Phone:\"}\r\n{num}+00 (0) 123 456 789{/num},<br/>\r\n{num}+00 (0) 123 456 789{/num}\r\n{/section}\r\n\r\n{section icon=\"mobile\" label=\"Mobile:\"}\r\n{num}+00 (0) 123 456 789{/num}\r\n{/section}\r\n\r\n{section icon=\"email\" label=\"E-mail:\"}\r\nexample1@example.com,<br/>\r\nexample2@example.com\r\n{/section}\r\n\r\n{section icon=\"link\" label=\"Website:\"}\r\n<a href=\"http://example.com\" target=\"_blank\">Example.com</a>\r\n{/section}\r\n', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Map heading', '', 17, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 128, '', '0', '', '', 0, 0, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 0, 0, 0, '', '', 0, 0, '', 'Map', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Popup', '', 21, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 157, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '<h1>Terms &amp; Conditions</h1>\r\n<p>{heading}Main Rules{/heading}</p>\r\n<p>{section icon=\"info\" label=\"Info:\"}<strong>You can have any kind of information here, included <span style=\"text-decoration: underline;\">images</span>, <span style=\"text-decoration: underline;\">videos</span> etc.</strong>{/section}</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed at ante. Mauris eleifend, quam a vulputate dictum, massa quam dapibus leo, eget vulputate orci purus ut lorem. In fringilla mi in ligula. Pellentesque aliquam quam vel dolor. Nunc adipiscing. Sed quam odio, tempus ac, aliquam molestie, varius ac, tellus. Vestibulum ut nulla aliquam risus rutrum interdum. Pellentesque lorem. Curabitur sit amet erat quis risus feugiat viverra. Pellentesque augue justo, sagittis et, lacinia at, venenatis non, arcu. Nunc nec libero. In cursus dictum risus. Etiam tristique nisl a nulla. Ut a orci. Curabitur dolor nunc, egestas at, accumsan at, malesuada nec, magna.</p>\r\n<p>Nulla facilisi. Nunc volutpat. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Ut sit amet orci vel mauris blandit vehicula. Nullam quis enim. Integer dignissim viverra velit. Curabitur in odio. In hac habitasse platea dictumst. Ut consequat, tellus eu volutpat varius, justo orci elementum dolor, sed imperdiet nulla tellus ut diam. Vestibulum ipsum ante, malesuada quis, tempus ac, placerat sit amet, elit.<br /><br />{heading}Privacy Rules{/heading}</p>\r\n<p>Sed eget turpis a pede tempor malesuada. Vivamus quis mi at leo pulvinar hendrerit. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque aliquet lacus vitae pede. Nullam mollis dolor ac nisi. Phasellus sit amet urna. Praesent pellentesque sapien sed lacus. Donec lacinia odio in odio. In sit amet elit. Maecenas gravida interdum urna. Integer pretium, arcu vitae imperdiet facilisis, elit tellus tempor nisi, vel feugiat ante velit sit amet mauris. Vivamus arcu. Integer pharetra magna ac lacus. Aliquam vitae sapien in nibh vehicula auctor. Suspendisse leo mauris, pulvinar sed, tempor et, consequat ac, lacus. Proin velit. Nulla semper lobortis mauris. Duis urna erat, ornare et, imperdiet eu, suscipit sit amet, massa. Nulla nulla nisi, pellentesque at, egestas quis, fringilla eu, diam.</p>\r\n<p>Donec semper, sem nec tristique tempus, justo neque commodo nisl, ut gravida sem tellus suscipit nunc. Aliquam erat volutpat. Ut tincidunt pretium elit. Aliquam pulvinar. Nulla cursus. Suspendisse potenti. Etiam condimentum hendrerit felis. Duis iaculis aliquam enim. Donec dignissim augue vitae orci. Curabitur luctus felis a metus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. In varius neque at enim. Suspendisse massa nulla, viverra in, bibendum vitae, tempor quis, lorem.<br /><br />{heading}Other Rules{/heading}</p>\r\n<p>Donec dapibus orci sit amet elit. Maecenas rutrum ultrices lectus. Aliquam suscipit, lacus a iaculis adipiscing, eros orci pellentesque nisl, non pharetra dolor urna nec dolor. Integer cursus dolor vel magna. Integer ultrices feugiat sem. Proin nec nibh. Duis eu dui quis nunc sagittis lobortis. Fusce pharetra, enim ut sodales luctus, lectus arcu rhoncus purus, in fringilla augue elit vel lacus. In hac habitasse platea dictumst. Aliquam erat volutpat. Fusce iaculis elit id tellus. Ut accumsan malesuada turpis. Suspendisse potenti. Vestibulum lacus augue, lobortis mattis, laoreet in, varius at, nisi. Nunc gravida. Phasellus faucibus. In hac habitasse platea dictumst. Integer tempor lacus eget lectus. Praesent fringilla augue fringilla dui.</p>', ''),
                                (NULL, 0, ".$form_id.", 'City', '', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 143, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Security', '', 17, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 149, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', 'Security', '', '', '', '', '', '', '', 120, '', '');


                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();

            // insert options
            $field_id_1 = $field_id_first + 2;
            $field_id_2 = $field_id_first + 3;
            $field_id_3 = $field_id_first + 7;
            $field_id_popup = $field_id_first + 16;
            
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 
                                (NULL, ".$field_id_2.", 'Web search', 'Web search', 2, '1', '0'),
                                (NULL, ".$field_id_2.", 'Social networks', 'Social networks', 1, '1', '0'),
                                (NULL, ".$field_id_2.", 'Recommended by a friend', 'Recommended by a friend', 3, '1', '0'),
                                (NULL, ".$field_id_3.", 'Agree with  {creative_popup id=\"".$field_id_popup."\" size=\"700X500\"}terms and conditions{/creative_popup}', 'Yes', 3, '1', '0'),
                            ";
            // $db->setQuery($query_insert);
            foreach($countries_array as $k => $country_val) {
                 $query_insert .= "(NULL, ".$field_id_1.", '".$country_val."', '".$country_val."', ".$k.", '1', '0')";
                 if($k != sizeof($countries_array) - 1)
                    $query_insert .= ',';
            }

            $db->setQuery($query_insert);

            $db->execute();
            // END insert Complex Contact Form //////////

             // insert Complex Job Application Form ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'Complex Job Application Form', 'Job Application Form', 'Please complete the form below to apply for a position with us.', 'Message successfully sent', 'Send', 'New email', 'OK', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 7, '', '0', 105, '', 0, '0', 'Send me a copy', '0', 1, 1, 1, 1, 1, '.creative_form_FORM_ID .creativecontactform_pre_text {\r\nwidth: 95% !important;\r\n}\r\n.creative_form_FORM_ID .creativecontactform_submit_wrapper {\r\nwidth: 95% !important;\r\n}\r\n.creative_form_FORM_ID .creative_field_box_wrapper_0_inner,\r\n.creative_form_FORM_ID .creative_field_box_wrapper_1_inner,\r\n.creative_form_FORM_ID .creative_field_box_wrapper_2_inner\r\n{\r\nmargin-left: 10px;\r\n}\r\n\r\n.creative_form_FORM_ID .creative_field_box_wrapper_2 .creative_textarea_wrapper {\r\nheight: 145px;\r\n}');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Personal Information', '', 17, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 33, '', '0', '95%', '0px 0px 10px -10px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', 'Personal Information', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Full Name', '', 3, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 36, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Age', '', 7, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 39, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Address', '', 5, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 42, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Postal / Zip Code', '', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 45, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Country', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 50, '', '1', '', '', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'City', '', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 52, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Your Application', '', 17, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 55, '', '0', '', '0px 0px 10px -10px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', 'Your Application', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Applying for Position', '', 10, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 56, '', '1', '', '', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Employment Date', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 59, '', '0', '70%', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, 'mm/dd/yy', 'show', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Type of Employment', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 61, '', '1', '', '15px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Upload Resume', '', 14, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 62, '', '1', '', '15px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', 'Select file...', '1', '5', 'jpg|jpeg|png|gif|pdf|doc|docx|ppt|pptx|odt|avi|ogg|m4a|mov|mp3|mp4|mpg|wav|wmv|zip|rar|7z', 'File is too small', 'File size exceeds the maximum allowed size (5 MB)', 'Invalid file format', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Contact Data', '', 17, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 64, '', '0', '', '-10px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', 'Contact Data', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Email', '', 4, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 69, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Phone Number', '', 6, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 71, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Fax', '', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 73, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Other Information', '', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 75, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Security', '', 17, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 76, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', 'Security', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Security', '', 19, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 78, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', 'light', 'image', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Popup - Terms and Conditions', '', 21, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 168, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '<h1>Terms &amp; Conditions</h1>\r\n<p>{heading}Main Rules{/heading}</p>\r\n<p>{section icon=\"info\" label=\"Info:\"}You can have any kind of information here, included <span style=\"text-decoration: underline;\">images</span>, <span style=\"text-decoration: underline;\">videos</span> etc.{/section}</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed at ante. Mauris eleifend, quam a vulputate dictum, massa quam dapibus leo, eget vulputate orci purus ut lorem. In fringilla mi in ligula. Pellentesque aliquam quam vel dolor. Nunc adipiscing. Sed quam odio, tempus ac, aliquam molestie, varius ac, tellus. Vestibulum ut nulla aliquam risus rutrum interdum. Pellentesque lorem. Curabitur sit amet erat quis risus feugiat viverra. Pellentesque augue justo, sagittis et, lacinia at, venenatis non, arcu. Nunc nec libero. In cursus dictum risus. Etiam tristique nisl a nulla. Ut a orci. Curabitur dolor nunc, egestas at, accumsan at, malesuada nec, magna.</p>\r\n<p>Nulla facilisi. Nunc volutpat. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Ut sit amet orci vel mauris blandit vehicula. Nullam quis enim. Integer dignissim viverra velit. Curabitur in odio. In hac habitasse platea dictumst. Ut consequat, tellus eu volutpat varius, justo orci elementum dolor, sed imperdiet nulla tellus ut diam. Vestibulum ipsum ante, malesuada quis, tempus ac, placerat sit amet, elit.<br /><br />{heading}Privacy Rules{/heading}</p>\r\n<p>Sed eget turpis a pede tempor malesuada. Vivamus quis mi at leo pulvinar hendrerit. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque aliquet lacus vitae pede. Nullam mollis dolor ac nisi. Phasellus sit amet urna. Praesent pellentesque sapien sed lacus. Donec lacinia odio in odio. In sit amet elit. Maecenas gravida interdum urna. Integer pretium, arcu vitae imperdiet facilisis, elit tellus tempor nisi, vel feugiat ante velit sit amet mauris. Vivamus arcu. Integer pharetra magna ac lacus. Aliquam vitae sapien in nibh vehicula auctor. Suspendisse leo mauris, pulvinar sed, tempor et, consequat ac, lacus. Proin velit. Nulla semper lobortis mauris. Duis urna erat, ornare et, imperdiet eu, suscipit sit amet, massa. Nulla nulla nisi, pellentesque at, egestas quis, fringilla eu, diam.</p>\r\n<p>Donec semper, sem nec tristique tempus, justo neque commodo nisl, ut gravida sem tellus suscipit nunc. Aliquam erat volutpat. Ut tincidunt pretium elit. Aliquam pulvinar. Nulla cursus. Suspendisse potenti. Etiam condimentum hendrerit felis. Duis iaculis aliquam enim. Donec dignissim augue vitae orci. Curabitur luctus felis a metus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. In varius neque at enim. Suspendisse massa nulla, viverra in, bibendum vitae, tempor quis, lorem.<br /><br />{heading}Other Rules{/heading}</p>\r\n<p>Donec dapibus orci sit amet elit. Maecenas rutrum ultrices lectus. Aliquam suscipit, lacus a iaculis adipiscing, eros orci pellentesque nisl, non pharetra dolor urna nec dolor. Integer cursus dolor vel magna. Integer ultrices feugiat sem. Proin nec nibh. Duis eu dui quis nunc sagittis lobortis. Fusce pharetra, enim ut sodales luctus, lectus arcu rhoncus purus, in fringilla augue elit vel lacus. In hac habitasse platea dictumst. Aliquam erat volutpat. Fusce iaculis elit id tellus. Ut accumsan malesuada turpis. Suspendisse potenti. Vestibulum lacus augue, lobortis mattis, laoreet in, varius at, nisi. Nunc gravida. Phasellus faucibus. In hac habitasse platea dictumst. Integer tempor lacus eget lectus. Praesent fringilla augue fringilla dui.</p>', ''),
                                (NULL, 0, ".$form_id.", 'Agree with Terms and Conditions', '', 11, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 170, '', '1', '', '15px 0px 10px 0px', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '');

                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();

            // insert options
            $field_id_1 = $field_id_first + 5;
            $field_id_2 = $field_id_first + 8;
            $field_id_3 = $field_id_first + 20;
            $field_id_4 = $field_id_first + 10;
            $field_id_popup = $field_id_first + 19;
            
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 
                                (NULL, ".$field_id_2.", 'Position 1', 'Position 1', 1, '1', '0'),
                                (NULL, ".$field_id_2.", 'Position 2', 'Position 2', 2, '1', '0'),
                                (NULL, ".$field_id_2.", 'Position 3', 'Position 3', 3, '1', '0'),
                                (NULL, ".$field_id_2.", 'Position 4', 'Position 4', 4, '1', '0'),
                                (NULL, ".$field_id_2.", 'Position 5', 'Position 5', 5, '1', '0'),

                                (NULL, ".$field_id_4.", 'Full-time', 'Full-time', 1, '1', '0'),
                                (NULL, ".$field_id_4.", 'Part-time', 'Part-time', 2, '1', '0'),
                                (NULL, ".$field_id_4.", 'Fixed term or contract', 'Fixed term or contract', 3, '1', '0'),
                                (NULL, ".$field_id_4.", 'Apprenticeships and traineeships', 'Apprenticeships and traineeships', 4, '1', '0'),
                                (NULL, ".$field_id_4.", 'Probationary period', 'Probationary period', 5, '1', '0'),

                                (NULL, ".$field_id_3.", 'Agree with  {creative_popup id=\"".$field_id_popup."\" size=\"700X500\"}terms and conditions{/creative_popup}', 'Yes', 3, '1', '0'),
                            ";
            // $db->setQuery($query_insert);
            foreach($countries_array as $k => $country_val) {
                 $query_insert .= "(NULL, ".$field_id_1.", '".$country_val."', '".$country_val."', ".$k.", '1', '0')";
                 if($k != sizeof($countries_array) - 1)
                    $query_insert .= ',';
            }
            $db->setQuery($query_insert);
            $db->execute();
            // END insert Complex Job Application Form //////////

             // insert All Elements Demo ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            $query_insert = 
                            "
                                INSERT INTO `#__creative_forms` (`id`, `email_to`, `email_bcc`, `email_subject`, `email_from`, `email_from_name`, `email_replyto`, `email_replyto_name`, `shake_count`, `shake_distanse`, `shake_duration`, `id_template`, `name`, `top_text`, `pre_text`, `thank_you_text`, `send_text`, `send_new_text`, `close_alert_text`, `form_width`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `redirect`, `redirect_itemid`, `redirect_url`, `redirect_delay`, `send_copy_enable`, `send_copy_text`, `show_back`, `email_info_show_referrer`, `email_info_show_ip`, `email_info_show_browser`, `email_info_show_os`, `email_info_show_sc_res`, `custom_css`) VALUES
                                (NULL, '', '', '', '', '', '', '', 2, 10, 300, 1, 'All Elements Demo', 'All Elements Demo', 'This is an example of all available elements in Creative Contact Form. The text you see here is a pre-text! Every form may have it where you are free to use HTML.\r\n<br /><br />\r\nIf you need a different look, choose from the available templates or just create your own template using <a href=\"http://creative-solutions.net/joomla/creative-contact-form/template-creator-demo\" target=\"_blank\">Template Creator</a> wizard!\r\n<br /><br />', 'Message successfully sent', 'Send Button', 'New email', 'OK', '100%', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 9, '', '0', 105, '', 0, '1', 'Send copy to yourself', '0', 1, 1, 1, 1, 1, '.creative_form_FORM_ID .creativecontactform_pre_text {\r\nwidth: 95% !important;\r\n}\r\n.creative_form_FORM_ID .creativecontactform_submit_wrapper {\r\nwidth: 95% !important;\r\n}\r\n.creative_form_FORM_ID  .creative_field_box_wrapper_0 .creativecontactform_field_box_textarea_inner {\r\nwidth: 95% !important;\r\n}');
                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $form_id = $db->insertid();
            
            // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Simple Text (name, email, address, phone, number, url). HTML is allowed in labels!', 'Each text field can have a tooltip!', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 5, '', '1', '95%', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Text Area', '', 2, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 6, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Radio', '', 12, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 13, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Checkbox', '', 11, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 26, '', '1', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Heading', '', 17, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 29, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', 'Heading', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Select', '', 9, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 12, '', '1', '90%', '5px 0px 15px 0px', 10, 10, '', '', '0', '1', 'Select Country', 'No results match', '', '', '', '', '', '', '', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Multiple Select', '', 10, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 25, '', '1', '', '5px 0px 15px 0px', 10, 10, '', '', '0', '1', 'Select', 'No results match', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Multiple File Upload', '', 14, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 20, '', '0', '', '15px 0 10px 0', 10, 10, '', '', '0', '1', '', '', 'Select files...', '1', '5', 'jpg|jpeg|png|gif|pdf|doc|docx|ppt|pptx|odt|avi|ogg|m4a|mov|mp3|mp4|mpg|wav|wmv|zip|rar|7z', 'File is too small', 'File size exceeds the maximum allowed size (5 MB)', 'Invalid file format', '', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Image Captcha', '', 13, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 24, '', '1', '', '-7px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', 'Security code is not correct', 1, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Google ReCaptcha', '', 19, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 28, '', '1', '', '25px 0 10px 0', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', 'light', 'image', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Datepicker', '', 15, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 27, '', '0', '80%', '19px 0px 10px 0px', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 2, 'mm/dd/yy', 'show', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Popup Demo', '', 21, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 146, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '<h1>Creative Popup Demo</h1>\r\n<p>{heading}Headings can be included here!{/heading}</p>\r\n<p>{section icon=\"info\" label=\"Info:\"}<strong>You can have any kind of information here, included <span style=\"text-decoration: underline;\">images</span>, <span style=\"text-decoration: underline;\">videos</span> etc.</strong>{/section}</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed at ante. Mauris eleifend, quam a vulputate dictum, massa quam dapibus leo, eget vulputate orci purus ut lorem. In fringilla mi in ligula. Pellentesque aliquam quam vel dolor. Nunc adipiscing. Sed quam odio, tempus ac, aliquam molestie, varius ac, tellus. Vestibulum ut nulla aliquam risus rutrum interdum. Pellentesque lorem. Curabitur sit amet erat quis risus feugiat viverra. Pellentesque augue justo, sagittis et, lacinia at, venenatis non, arcu. Nunc nec libero. In cursus dictum risus. Etiam tristique nisl a nulla. Ut a orci. Curabitur dolor nunc, egestas at, accumsan at, malesuada nec, magna.</p>\r\n<p>Nulla facilisi. Nunc volutpat. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Ut sit amet orci vel mauris blandit vehicula. Nullam quis enim. Integer dignissim viverra velit. Curabitur in odio. In hac habitasse platea dictumst. Ut consequat, tellus eu volutpat varius, justo orci elementum dolor, sed imperdiet nulla tellus ut diam. Vestibulum ipsum ante, malesuada quis, tempus ac, placerat sit amet, elit.<br /><br />{heading}Show a map in popup{/heading}</p>', '<iframe src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2624.9916298517096!2d2.2944809999999936!3d48.85837000000001!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x47e66e2964e34e2d%3A0x8ddca9ee380ef7e0!2sEiffel+Tower!5e0!3m2!1shy!2s!4v1419178425174\" width=\"100%\" height=\"500\" frameborder=\"0\" style=\"border:0\"></iframe>'),
                                (NULL, 0, ".$form_id.", 'Google Earth Popup', '', 21, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 153, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '<iframe src=\"https://www.google.com/maps/embed?pb=!1m0!3m2!1sen!2s!4v1421842182969!6m8!1m7!1s4M7aE4T81mEAAAQIL7_78Q!2m2!1d32.3567088!2d-64.7273254!3f358.8060799024528!4f-3.5601139997918523!5f0.7820865974627469\" width=\"100%\" height=\"450\" frameborder=\"0\" style=\"border:0\"></iframe>'),
                                (NULL, 0, ".$form_id.", 'Creative Scrollbar', '', 16, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 140, '', '0', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '<u style=\"display: inline-block;margin-bottom: 12px;margin-top: 5px;font-size: 115%\">Creative Scrollbar</u>: Show large content in following creative way!\r\n<div class=\"creative_content_scrollbar\">\r\n<h1>Creative Scrollbar</h1>\r\n<hr />\r\n<p class=\"scrollbar_light\">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Sed at ante. Mauris eleifend, quam a vulputate dictum, massa quam dapibus leo, eget vulputate orci purus ut lorem. In fringilla mi in ligula. Pellentesque aliquam quam vel dolor. Nunc adipiscing. Sed quam odio, tempus ac, aliquam molestie, varius ac, tellus. Vestibulum ut nulla aliquam risus rutrum interdum. Pellentesque lorem. Curabitur sit amet erat quis risus feugiat viverra. Pellentesque augue justo, sagittis et, lacinia at, venenatis non, arcu. Nunc nec libero. In cursus dictum risus. Etiam tristique nisl a nulla. Ut a orci. Curabitur dolor nunc, egestas at, accumsan at, malesuada nec, magna.\r\n</p>\r\n<p>\r\nNulla facilisi. Nunc volutpat. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Ut sit amet orci vel mauris blandit vehicula. Nullam quis enim. Integer dignissim viverra velit. Curabitur in odio. In hac habitasse platea dictumst. Ut consequat, tellus eu volutpat varius, justo orci elementum dolor, sed imperdiet nulla tellus ut diam. Vestibulum ipsum ante, malesuada quis, tempus ac, placerat sit amet, elit.\r\n</p>\r\n<p class=\"scrollbar_light\">\r\nSed eget turpis a pede tempor malesuada. Vivamus quis mi at leo pulvinar hendrerit. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque aliquet lacus vitae pede. Nullam mollis dolor ac nisi. Phasellus sit amet urna. Praesent pellentesque sapien sed lacus. Donec lacinia odio in odio. In sit amet elit. Maecenas gravida interdum urna. Integer pretium, arcu vitae imperdiet facilisis, elit tellus tempor nisi, vel feugiat ante velit sit amet mauris. Vivamus arcu. Integer pharetra magna ac lacus. Aliquam vitae sapien in nibh vehicula auctor. Suspendisse leo mauris, pulvinar sed, tempor et, consequat ac, lacus. Proin velit. Nulla semper lobortis mauris. Duis urna erat, ornare et, imperdiet eu, suscipit sit amet, massa. Nulla nulla nisi, pellentesque at, egestas quis, fringilla eu, diam.\r\n</p>\r\n<p>\r\nDonec semper, sem nec tristique tempus, justo neque commodo nisl, ut gravida sem tellus suscipit nunc. Aliquam erat volutpat. Ut tincidunt pretium elit. Aliquam pulvinar. Nulla cursus. Suspendisse potenti. Etiam condimentum hendrerit felis. Duis iaculis aliquam enim. Donec dignissim augue vitae orci. Curabitur luctus felis a metus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. In varius neque at enim. Suspendisse massa nulla, viverra in, bibendum \r\n</p>\r\n<p class=\"scrollbar_light\">\r\nDonec dapibus orci sit amet elit. Maecenas rutrum ultrices lectus. Aliquam suscipit, lacus a iaculis adipiscing, eros orci pellentesque nisl, non pharetra dolor urna nec dolor. Integer cursus dolor vel magna. Integer ultrices feugiat sem. Proin nec nibh. Duis eu dui quis nunc sagittis lobortis. Fusce pharetra, enim ut sodales luctus, lectus arcu rhoncus purus, in fringilla augue elit vel lacus. In hac habitasse platea dictumst. Aliquam erat volutpat. Fusce iaculis elit id tellus. Ut accumsan malesuada turpis. Suspendisse potenti. Vestibulum lacus augue, lobortis mattis, laoreet in, varius at, nisi. Nunc gravida. Phasellus faucibus. In hac habitasse platea dictumst. Integer tempor lacus eget lectus. Praesent fringilla augue fringilla dui.\r\n</p>\r\n</div>', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Terms and Conditions Popup', '', 21, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 150, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '<h1>Terms &amp; Conditions</h1>\r\n<p>{heading}Main Rules{/heading}</p>\r\n<p>{section icon=\"info\" label=\"Info:\"}<strong>You can have any kind of information here, included <span style=\"text-decoration: underline;\">images</span>, <span style=\"text-decoration: underline;\">videos</span> etc.</strong>{/section}</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed at ante. Mauris eleifend, quam a vulputate dictum, massa quam dapibus leo, eget vulputate orci purus ut lorem. In fringilla mi in ligula. Pellentesque aliquam quam vel dolor. Nunc adipiscing. Sed quam odio, tempus ac, aliquam molestie, varius ac, tellus. Vestibulum ut nulla aliquam risus rutrum interdum. Pellentesque lorem. Curabitur sit amet erat quis risus feugiat viverra. Pellentesque augue justo, sagittis et, lacinia at, venenatis non, arcu. Nunc nec libero. In cursus dictum risus. Etiam tristique nisl a nulla. Ut a orci. Curabitur dolor nunc, egestas at, accumsan at, malesuada nec, magna.</p>\r\n<p>Nulla facilisi. Nunc volutpat. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Ut sit amet orci vel mauris blandit vehicula. Nullam quis enim. Integer dignissim viverra velit. Curabitur in odio. In hac habitasse platea dictumst. Ut consequat, tellus eu volutpat varius, justo orci elementum dolor, sed imperdiet nulla tellus ut diam. Vestibulum ipsum ante, malesuada quis, tempus ac, placerat sit amet, elit.<br /><br />{heading}Privacy Rules{/heading}</p>\r\n<p>Sed eget turpis a pede tempor malesuada. Vivamus quis mi at leo pulvinar hendrerit. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque aliquet lacus vitae pede. Nullam mollis dolor ac nisi. Phasellus sit amet urna. Praesent pellentesque sapien sed lacus. Donec lacinia odio in odio. In sit amet elit. Maecenas gravida interdum urna. Integer pretium, arcu vitae imperdiet facilisis, elit tellus tempor nisi, vel feugiat ante velit sit amet mauris. Vivamus arcu. Integer pharetra magna ac lacus. Aliquam vitae sapien in nibh vehicula auctor. Suspendisse leo mauris, pulvinar sed, tempor et, consequat ac, lacus. Proin velit. Nulla semper lobortis mauris. Duis urna erat, ornare et, imperdiet eu, suscipit sit amet, massa. Nulla nulla nisi, pellentesque at, egestas quis, fringilla eu, diam.</p>\r\n<p>Donec semper, sem nec tristique tempus, justo neque commodo nisl, ut gravida sem tellus suscipit nunc. Aliquam erat volutpat. Ut tincidunt pretium elit. Aliquam pulvinar. Nulla cursus. Suspendisse potenti. Etiam condimentum hendrerit felis. Duis iaculis aliquam enim. Donec dignissim augue vitae orci. Curabitur luctus felis a metus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. In varius neque at enim. Suspendisse massa nulla, viverra in, bibendum vitae, tempor quis, lorem.<br /><br />{heading}Other Rules{/heading}</p>\r\n<p>Donec dapibus orci sit amet elit. Maecenas rutrum ultrices lectus. Aliquam suscipit, lacus a iaculis adipiscing, eros orci pellentesque nisl, non pharetra dolor urna nec dolor. Integer cursus dolor vel magna. Integer ultrices feugiat sem. Proin nec nibh. Duis eu dui quis nunc sagittis lobortis. Fusce pharetra, enim ut sodales luctus, lectus arcu rhoncus purus, in fringilla augue elit vel lacus. In hac habitasse platea dictumst. Aliquam erat volutpat. Fusce iaculis elit id tellus. Ut accumsan malesuada turpis. Suspendisse potenti. Vestibulum lacus augue, lobortis mattis, laoreet in, varius at, nisi. Nunc gravida. Phasellus faucibus. In hac habitasse platea dictumst. Integer tempor lacus eget lectus. Praesent fringilla augue fringilla dui.</p>', ''),
                                (NULL, 0, ".$form_id.", 'Agree with terms and conditions', '', 11, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 142, '', '1', '', '20px 0px 10px 0px', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Map Popup', '', 21, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 151, '', '0', '', '', 10, 10, '', '', '0', '1', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '', '', '', '', '', '', '', 120, '', '<iframe src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2624.9916298517096!2d2.2944809999999936!3d48.85837000000001!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x47e66e2964e34e2d%3A0x8ddca9ee380ef7e0!2sEiffel+Tower!5e0!3m2!1shy!2s!4v1419178425174\" width=\"100%\" height=\"500\" frameborder=\"0\" style=\"border:0\"></iframe>');


                            ";
            $db->setQuery($query_insert);
            $db->execute();
            $field_id_first = $db->insertid();

            $field_id_popup_1 = $field_id_first + 12;
            $field_id_popup_2 = $field_id_first + 11;
            $field_id_popup_3 = $field_id_first + 16;
            $field_id_popup_4 = $field_id_first + 14;



             // insert fields
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_fields` (`id`, `id_user`, `id_form`, `name`, `tooltip_text`, `id_type`, `alias`, `created`, `publish_up`, `publish_down`, `published`, `checked_out`, `checked_out_time`, `access`, `featured`, `ordering`, `language`, `required`, `width`, `field_margin_top`, `select_show_scroll_after`, `select_show_search_after`, `message_required`, `message_invalid`, `ordering_field`, `show_parent_label`, `select_default_text`, `select_no_match_text`, `upload_button_text`, `upload_minfilesize`, `upload_maxfilesize`, `upload_acceptfiletypes`, `upload_minfilesize_message`, `upload_maxfilesize_message`, `upload_acceptfiletypes_message`, `captcha_wrong_message`, `column_type`, `datepicker_date_format`, `datepicker_animation`, `datepicker_style`, `datepicker_icon_style`, `datepicker_show_icon`, `datepicker_input_readonly`, `datepicker_number_months`, `datepicker_mindate`, `datepicker_maxdate`, `datepicker_changemonths`, `datepicker_changeyears`, `custom_html`, `heading`, `google_maps`, `recaptcha_site_key`, `recaptcha_security_key`, `recaptcha_wrong_message`, `recaptcha_theme`, `recaptcha_type`, `contact_data`, `contact_data_width`, `creative_popup`, `creative_popup_embed`) VALUES
                                (NULL, 0, ".$form_id.", 'Google Maps', '', 18, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 30, '', '0', '', '', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '', '', '<u style=\"display: inline-block;margin-bottom: 5px;font-size: 115%\">Google Maps</u>: <span style=\"display: inline-block;font-size: 11px;float: right;\">{creative_popup id=\"".$field_id_popup_1."\" size=\"700X490\"}Google Earth popup demo{/creative_popup}</span>\r\n<iframe src=\"https://www.google.com/maps/d/embed?mid=z2ij1oq8eejA.k0YHKZpiIGcA\" width=\"100%\" height=\"350\"></iframe>', '', '', '', '', '', '', 120, '', ''),
                                (NULL, 0, ".$form_id.", 'Custom Html', '', 16, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0, '0000-00-00 00:00:00', 1, 0, 32, '', '0', '', '', 10, 10, '', '', '0', '0', '', '', '', '', '', '', '', '', '', '', 0, '', '', 0, 0, 1, 0, 1, '', '', 0, 0, '<br />\r\n<u style=\"font-size: 115%\">Custom Html</u>: Insert any html in your forms! You can also embed videos, iframes, or insert images.\r\n<br /><br />\r\n\r\n<u style=\"font-size: 115%\">Creative Popup</u>: Create a popup content, and place link on <b>any text</b> in the form. {creative_popup id=\"".$field_id_popup_2."\" size=\"800X600\"}Popup Demo{/creative_popup}!\r\n<br /><br />\r\n\r\n<u style=\"font-size: 115%\">Contact Data</u>: You can show your contact data in following beautiful way!\r\n<br /><br />\r\n{section icon=\"address\" label=\"Address:\"}\r\nPO Box 21177 / Level 13, 2 Elizabeth St, Melbourne Victoria 3000 Australia\r\n{/section}\r\n\r\n{section icon=\"phone\" label=\"Phone:\"}\r\n{num}+00 (0) 123 456 789{/num},<br/>\r\n{num}+00 (0) 123 456 789{/num}\r\n{/section}\r\n\r\n{section icon=\"mobile\" label=\"Mobile:\"}\r\n{num}+00 (0) 123 456 789{/num}\r\n{/section}\r\n\r\n{section icon=\"email\" label=\"E-mail:\"}\r\nexample1@example.com,<br/>\r\nexample2@example.com\r\n{/section}\r\n\r\n{section icon=\"link\" label=\"Website:\"}\r\n<a href=\"http://example.com\" target=\"_blank\">Example.com</a>\r\n{/section}\r\n\r\n{section icon=\"map\" label=\"Map:\"}\r\n{creative_popup id=\"".$field_id_popup_3."\" size=\"700X540\"}Find us on map{/creative_popup}\r\n{/section}\r\n\r\n\r\n{section icon=\"info\" label=\"Info:\"}\r\nYou can have the following types of icons:  <b>address</b>, <b>phone</b>, <b>mobile</b>, <b>fax</b>, <b>email</b>, <b>link</b>, <b>tip</b>, <b>info</b>, <b>question</b>, <b>map</b>. \r\n{/section}\r\n\r\n{section icon=\"tip\" label=\"Tip:\"}\r\nYou can use them to show any information in your form.\r\n{/section}\r\n\r\n', '', '', '', '', '', '', '', '', 120, '', '');
                            ";
            $db->setQuery($query_insert);
            $db->execute();


            // insert options
            $field_id_1 = $field_id_first + 2;
            $field_id_2 = $field_id_first + 3;
            $field_id_3 = $field_id_first + 5;
            $field_id_4 = $field_id_first + 6;
            $field_id_5 = $field_id_first + 15;
            
            $query_insert = 
                            "
                                INSERT IGNORE INTO `#__creative_form_options` (`id`, `id_parent`, `name`, `value`, `ordering`, `showrow`, `selected`) VALUES 
                                (NULL, ".$field_id_1.", 'Option 1', 'Option 1', 1, '1', '0'),
                                (NULL, ".$field_id_1.", 'Option 2', 'Option 2', 2, '1', '0'),
                                (NULL, ".$field_id_1.", 'Option 3', 'Option 3', 3, '1', '0'),

                                (NULL, ".$field_id_2.", 'Option 1', 'Option 1', 1, '1', '0'),
                                (NULL, ".$field_id_2.", 'Option 2', 'Option 2', 2, '1', '0'),
                                (NULL, ".$field_id_2.", 'Option 3', 'Option 3', 3, '1', '0'),

                                (NULL, ".$field_id_4.", 'Option 1', 'Option 1', 1, '1', '0'),
                                (NULL, ".$field_id_4.", 'Option 2', 'Option 2', 2, '1', '0'),
                                (NULL, ".$field_id_4.", 'Option 3', 'Option 3', 3, '1', '0'),

                                (NULL, ".$field_id_5.", 'Agree with  {creative_popup id=\"".$field_id_popup_4."\" size=\"700X500\"}terms and conditions{/creative_popup}', 'Yes', 3, '1', '0'),
                            ";
            // $db->setQuery($query_insert);
            foreach($countries_array as $k => $country_val) {
                 $query_insert .= "(NULL, ".$field_id_3.", '".$country_val."', '".$country_val."', ".$k.", '1', '0')";
                 if($k != sizeof($countries_array) - 1)
                    $query_insert .= ',';
            }
            $db->setQuery($query_insert);
            $db->execute();
            // END insert All Elements Demo //////////




        }
        // END INSTALL PRO FORMS ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

         // 3.x to 3.5.0 update ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        $query_create = 
                            "
                                CREATE TABLE IF NOT EXISTS `#__creative_submissions` (
                                  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                  `id_form` int(10) UNSIGNED NOT NULL,
                                  `date` datetime NOT NULL,
                                  `email` text NOT NULL,
                                  `message` text NOT NULL,
                                  `ip` text NOT NULL,
                                  `browser` text NOT NULL,
                                  `op_s` text NOT NULL,
                                  `sc_res` text NOT NULL,
                                  `name` text NOT NULL,
                                  `viewed` enum('0','1') NOT NULL DEFAULT '0',
                                  `country` text NOT NULL,
                                  `city` text NOT NULL,
                                  `page_title` text NOT NULL,
                                  `page_url` text NOT NULL,
                                  `star_index` tinyint(3) UNSIGNED NOT NULL,
                                  `imp_index` tinyint(3) UNSIGNED NOT NULL,
                                  `uploads` text NOT NULL,
                                    PRIMARY KEY (`id`)
                                ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
                            ";
        $db->setQuery($query_create);
        $db->execute();

        // 3.5 to 4.0 update ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        
        $query = "SELECT * FROM `#__creative_forms` LIMIT 1";
        $db->setQuery($query);
        $columns_data = $db->LoadAssoc();

        if(is_array($columns_data)) {
            $columns_titles = array_keys($columns_data);
            if(!in_array('render_type',$columns_titles)) {

                $query_update = 
                                    "
                                         ALTER TABLE 
                                            `#__creative_forms` 
                                        ADD 
                                            `render_type` TINYINT UNSIGNED NOT NULL,
                                        ADD 
                                            `popup_button_text` TEXT NOT NULL,
                                        ADD 
                                            `static_button_position` TINYINT UNSIGNED NOT NULL, 
                                        ADD 
                                            `static_button_offset` TEXT NOT NULL, 
                                        ADD 
                                            `appear_animation_type` TINYINT UNSIGNED NOT NULL DEFAULT '1', 
                                        ADD 
                                            `check_token` TINYINT UNSIGNED NOT NULL,
                                        ADD 
                                            `next_button_text` TEXT NOT NULL, 
                                        ADD 
                                            `prev_button_text` TEXT NOT NULL
                                    ";
                $db->setQuery($query_update);
                $db->execute();

            }
        }
        // END 3.5 to 4.0 update //////////////////////////////////////////////////////////////////////////

         // 4.0 to 4.5 update /////////////////////////////////////////////////////////////////////////////
        // FREE TO PRO UPDATE//////
        $query_update = 
                            "
                                UPDATE `#__creative_field_types` SET `name` = CASE
                                    WHEN id = 22 THEN 'Multiple Recipients'
                                    WHEN id = 23 THEN 'Time'
                                    WHEN id = 24 THEN 'Stars'
                                    WHEN id = 25 THEN 'E-Signature'
                                    WHEN id = 26 THEN 'Page Break'
                                    WHEN id = 27 THEN 'If-Then'
                                    WHEN id = 28 THEN 'Hidden'
                                    ELSE `name`
                                    END 
                                WHERE id in (22,23,24,25,26,27,28)
                            ";
        $db->setQuery($query_update);
        $db->execute();


        $query = "SELECT * FROM `#__creative_fields` LIMIT 1";
        $db->setQuery($query);
        $columns_data = $db->LoadAssoc();

        if(is_array($columns_data)) {
            $columns_titles = array_keys($columns_data);
             if(!in_array('m_recipients_value',$columns_titles)) {
                $query_update = 
                                    "
                                         ALTER TABLE 
                                            `#__creative_fields` 
                                        ADD 
                                            `m_recipients_value` TEXT NOT NULL,
                                        ADD 
                                            `m_recipients_multiple` TINYINT UNSIGNED NOT NULL,
                                        ADD 
                                            `pagebreak_type` TINYINT UNSIGNED NOT NULL,
                                        ADD 
                                            `pagebreak_page_title` TEXT NOT NULL,
                                        ADD 
                                            `if_id` INT UNSIGNED NOT NULL,
                                        ADD 
                                            `if_val` TEXT NOT NULL,
                                        ADD 
                                            `then_id` INT UNSIGNED NOT NULL,
                                        ADD 
                                            `hidden_val` TEXT NOT NULL
                                    ";
                $db->setQuery($query_update);
                $db->execute();

                $query = "SELECT * FROM `#__creative_field_types`";
                $db->setQuery($query);
                $db->execute();
                $num_rows = $db->getNumRows();

                if($num_rows < 25) {
                    $query_insert = 
                                                "
                                                    INSERT IGNORE INTO 
                                                        `#__creative_field_types` 
                                                    (`id`, `name`) 
                                                        VALUES 
                                                    (22, 'Multiple Recipients'),
                                                    (23, 'Time'),
                                                    (24, 'Stars'),
                                                    (25, 'E-Signature'),
                                                    (26, 'Page Break'),
                                                    (27, 'If-Then'),
                                                    (28, 'Hidden')
                                                ";
                    $db->setQuery($query_insert);
                    $db->execute();
                }

           }
        }     
         // END 4.0 to 4.5 update /////////////////////////////////////////////////////////////////////////////

        // to 4.6.1 update //////////////////////////////////////////////////////////////
        $query = "SELECT * FROM `#__creative_forms` LIMIT 1";
        $db->setQuery($query);
        $columns_data = $db->LoadAssoc();

        if(is_array($columns_data)) {
            $columns_titles = array_keys($columns_data);
            if(!in_array('email_template',$columns_titles)) {
                $query_update = "ALTER TABLE `#__creative_forms` ADD `email_template` TEXT NOT NULL, ADD `auto_reply` TEXT NOT NULL";
                $db->setQuery($query_update);
                $db->execute();
            }
        }

        //update email_template
        $email_template = 
                            '<html>
<body>
<div style="padding:40px;margin:0;background-color: #f7f7f7;font-family:\'Helvetica Neue\',Helvetica,Arial,sans-serif;border-radius: 5px;line-height:1.2;width:90%;">
<table border="0" cellspacing="0" cellpadding="0" style="width:100%;">
<tbody>
<tr>
<td style="background:#004586;border-right: 1px solid #004586;color:#fff;font-size:16px;vertical-align:middle;font-weight:bold;height:35px;padding:4px 8px 4px 15px;">
Message Sent From [SITENAME]
</td>
</tr>
<tr>
<td style="border-bottom:1px solid #004586;border-left:1px solid #ccc; border-right:1px solid #ccc;background-color:#fff;padding:15px" valign="top">
<div style="margin-top:5px;margin-bottom:15px;font-size:14px">
<p style="margin: 5px 0;"><strong>Dear User</strong>,</p><p style="margin: 5px 0;">
You have received a message, with the following details:
</p>
</div>
<div style="border:1px solid #dddddd;padding:10px;background-color:#f5f5f5;width:80%;margin-left:auto;margin-right:auto">
<table border="0" cellspacing="0" cellpadding="4" style="width:100%">
<tbody>
<tr>
<td align="right" valign="top" style="width: 200px;font-size:14px;font-weight:normal;">[FIELD_LABEL]</td>
<td align="left" valign="top" style="font-size:14px;font-weight:normal;">[FIELD_VALUE]</td>
</tr>
</tbody>
</table>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</body>
</html>';
        $query_update = "UPDATE `#__creative_forms` SET `email_template` = ".$db->quote($email_template)." WHERE `email_template` = '' OR `email_template` IS NULL";
        $db->setQuery($query_update);
        $db->execute();
        
         // END to 4.6.1 update /////////////////////////////////////////////////////////////////////////////

    }

}